2007-07-09  Paolo Bonzini  <bonzini@gnu.org>

        PR middle-end/32004
        * function.c (rest_of_match_asm_constraints): Pass PROP_REG_INFO.

2007-07-09  Uros Bizjak  <ubizjak@gmail.com>

	PR tree-optimization/32681
	* tree-if-conv.c (find_phi_replacement_condition): Use the condition
	saved in second_edge->aux when first_bb is a loop header.

2007-07-07 Anatoly Sokolov <aesok@post.ru>

	PR target/31331
	* config/avr/avr.c (avr_naked_function_p): Handle receiving a type
	rather than a decl. 
	(avr_attribute_table): Make "naked" attribute apply to function types
	rather than to decls.
	(avr_handle_fntype_attribute): New function.

2007-07-07  Uros Bizjak  <ubizjak@gmail.com>

	PR target/32660
	Backport from mainline.
	* config/i386/sse.md (*vec_extractv2di_1_sse2): New.
	(*vec_extractv2di_1_sse): New.

2007-07-06  Paolo Bonzini  <bonzini@gnu.org>

	PR middle-end/32004
	* function.c (match_asm_constraints_1, rest_of_match_asm_constraints,
	pass_match_asm_constraints): New.
	* passes.c (init_optimization_passes): Add new pass.
	* stmt.c (expand_asm_operands): Set cfun->has_asm_statement.
	* function.h (struct function): Add has_asm_statement bit.
	(current_function_has_asm_statement): New.
	* tree-pass.h (pass_match_asm_constraints): New.

2007-07-06  Uros Bizjak  <ubizjak@gmail.com>

	PR rtl-optimization/32450
	* function.c (thread_prologue_and_epilogue_insns): Emit blockage insn
	to ensure that instructions are not moved into the prologue when
	profiling is on.

2007-07-04  Uros Bizjak  <ubizjak@gmail.com>

	PR tree-optimization/31966
	PR tree-optimization/32533
	* tree-if-conv.c (add_to_dst_predicate_list): Use "edge", not
	"basic_block" description as its third argument.  Update function
	calls to get destination bb from "edge" argument.  Save "cond" into
	aux field of the edge.  Update prototype for changed arguments.
	(if_convertible_loop_p): Clear aux field of incoming edges if bb
	contains phi node.
	(find_phi_replacement_condition): Operate on incoming edges, not
	on predecessor blocks.  If there is a condition saved in the
	incoming edge aux field, AND it with incoming bb predicate.
	Return source bb of the first edge.
	(clean_predicate_lists): Clean aux field of outgoing node edges.
	(tree_if_conversion): Do not initialize cond variable. Move
	variable declaration into the loop.
	(replace_phi_with_cond_gimple_modify_stmt): Remove unneded
	initializations of new_stmt, arg0 and arg1 variables.

2007-07-04  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/32506
	Backport from mainline.
	* config/sh/sh.md (udivsi3_i1_media): Use target_reg_operand
	predicate instead of target_operand.
	(divsi3_i1_media, divsi3_media_2): Likewise.

2007-07-03  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	PR target/28307
	* gthr-posix.h [SUPPORTS_WEAK && GTHREAD_USE_WEAK]
	(__gthrw_pragma): Provide default definition.
	(__gthrw2): Use it.
	* gthr-posix.c (__gthrw_pragma): Define.

2007-06-30  Alexandre Oliva  <aoliva@redhat.com>

	* dwarf2out.c (dwarf2out_finish): Accept namespaces as context of
	limbo die nodes.

2007-06-28  Seongbae Park  <seongbae.park@gmail.com>

	* config/arm/arm.c (arm_get_frame_offsets): Set
	offsets->locals_base to avoid negative stack size.
	(thumb1_expand_prologue): Assert on negative stack size.

2007-06-28  Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/rs6000.c (rs6000_function_ok_for_sibcall): Ensure
	decl is non-external for AIX ABI.

2007-06-28  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/predicates.md (current_file_function_operand):
	Ensure the symbol is non-external for AIX ABI.

2007-06-21  Uros Bizjak  <ubizjak@gmail.com>

	PR target/32389
	* config/i386/i386.h (enum ix86_stack_slot): Add SLOT_VIRTUAL.
	* config/i386/i386.c (assign_386_stack_local): Assert that
	SLOT_VIRTUAL is valid only before virtual regs are instantiated.
	(ix86_expand_builtin) [IX86_BUILTIN_LDMXCSR, IX86_BUILTIN_STMXCSR]:
	Use SLOT_VIRTUAL stack slot instead of SLOT_TEMP.
	* config/i386/i386.md (truncdfsf2, truncxfsf2, truncxfdf2): Ditto.

2007-06-20  Jakub Jelinek  <jakub@redhat.com>

	PR inline-asm/32109
	* gimplify.c (gimplify_asm_expr): Issue error if type is addressable
	and !allows_mem.

	PR middle-end/32285
	* calls.c (precompute_arguments): Also precompute CALL_EXPR arguments
	if ACCUMULATE_OUTGOING_ARGS.

2007-06-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR rtl-optimization/28011
	Backport from mainline.
	* reload.c (push_reload): Set dont_share if IN appears in OUT
	also when IN is a PLUS rtx.
	(reg_overlap_mentioned_for_reload_p): Return true if X and IN
	are same PLUS rtx.

2007-06-19  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/32353
	* tree-ssa-structalias.c (set_uids_in_ptset): Also handle RESULT_DECL.

2007-06-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c (sparc_override_options): Initialize
	fpu mask correctly.

2007-06-08  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/32163
	Backport from mainline.
	* config/sh/sh.md (symGOT_load): Don't schedule insns when
	the symbol is generated with the stack protector.

2007-05-31  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	Backport from mainline:
	2007-05-05  Aurelien Jarno  <aurelien@aurel32.net>

	* config/pa/pa.md: Split tgd_load, tld_load and tie_load
	into pic and non-pic versions. Mark r19 as used for 
	tgd_load_pic, tld_load_pic and tie_load_pic. Mark r27 as used 
	for tgd_load, tld_load and tie_load .
	* config/pa/pa.c (legitimize_tls_address): Emit pic or non-pic
	version of tgd_load, tld_load and tie_load depending on the 
	value of flag_pic.

2007-05-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/31701
	Backport from mainline.
	* config/sh/sh.c (output_stack_adjust): Avoid using the frame
	register itself to hold the offset constant.  Tell flow the use
	of r4 and r5 when they are used.

2007-05-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/31480
	Backport from mainline.
	* config/sh/sh.md (length): Check if prev_nonnote_insn (insn)
	is null.

2007-05-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/31022
	Backport from mainline.
	* config/sh/sh.c (sh_adjust_cost): Use the result of single_set
	instead of PATTERN.

2007-05-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/31691
	* combine.c (simplify_set): Build a new src pattern instead of
	substituting its operands in the COMPARE case.

2007-05-16  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-06-09  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/26998
	* tree-vrp.c (extract_range_from_unary_expr): For NEGATE_EXPR
	of signed types, only TYPE_MIN_VALUE is special, but for both,
	minimum and maximum value.  Likewise VR_ANTI_RANGE is special
	in this case, as is -fwrapv.

2007-05-11  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/31876
	* config/sh/sh.md (andsi3): Avoid calling gen_lowpart on
        a SImode SUBREG of a floating point register.

2007-05-08  Andreas Krebbel  <krebbel1@de.ibm.com>

	* loop.c (move_movables): Remove REG_EQUAL notes for conditional
	invariants as well.

2007-04-29  Bernd Schmidt  <bernd.schmidt@analog.com>

	* reload.c (combine_reloads): When trying to use a dying register,
	check whether it's uninitialized and don't use if so.

2007-04-27  Ulrich Weigand  <uweigand@de.ibm.com>

	PR middle-end/30761
	* reload1.c (eliminate_regs_in_insn): In the single_set special
	case, attempt to re-recognize the insn before falling back to
	having reload fix it up.

2007-04-26  Ian Lance Taylor  <iant@google.com>

	PR target/28675
	* reload.c (find_reloads_subreg_address): If the address was valid
	in the original mode but not in the new mode, reload the whole
	address.

2007-04-25  Anatoly Sokolov <aesok@post.ru>

	PR target/18989
 	* config/avr/avr.h (ASM_OUTPUT_ALIGN): Redefine.

2007-04-25  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-10-13  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/29446
	* tree-vrp.c (fix_equivalence_set): Remove.
	(extract_range_from_assert): Do not call fix_equivalence_set.
	(debug_value_range): Print a newline.
	(compare_name_with_value): For equivalence sets with
	inconsistent value ranges conservatively bail out.
	(compare_names): Likewise.

2007-04-24  Andreas Krebbel  <krebbel1@de.ibm.com>

	PR target/31641
	* config/s390/s390.c (s390_expand_setmem): Don't ICE for constant length
	argument of 0 for memset.
	(s390_expand_movmem, s390_expand_setmem, s390_expand_cmpmem): Use
	unsigned shift instead of the signed variant.

2007-04-22  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR middle-end/31448
	* expr.c (reduce_to_bit_field_precision): Handle
	CONST_INT rtx's.

2007-04-20  Richard Henderson  <rth@redhat.com>

	PR target/28623
	* config/alpha/alpha.c (get_unaligned_address): Remove extra_offset
	argument; update all callers.
	(get_unaligned_offset): New.
	* config/alpha/alpha.md (extendqidi2, extendhidi2): Don't use
	get_unaligned_address, just pass on the address directly.
	(unaligned_extendqidi): Use gen_lowpart instead of open-coding
	the subreg in the helper patterns.
	(unaligned_extendqidi_le): Use get_unaligned_offset.
	(unaligned_extendqidi_be, unaligned_extendhidi_le): Likewise.
	(unaligned_extendhidi_be): Likewise.
	(unaligned_extendhidi): Tidy.
	* config/alpha/alpha-protos.h: Update.

2007-04-20  Richard Henderson  <rth@redhat.com>

	* config/alpha/linux.h (CPP_SPEC): Undef before redefine.

2007-04-20  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.c (bdesc_2arg): Use ORDERED rather than UNORDERED
	for __builtin_ia32_cmpordss.

	PR tree-optimization/31632
	* fold-const.c (fold_binary): Use op0 and op1 instead of arg0
	and arg1 for optimizations of comparison against min/max values.
	Fold arg0 to arg1's type for optimizations of comparison against
	min+1 and max-1 values.

2007-04-18  Anatoly Sokolov <aesok@post.ru>

	* config/avr/avr.c (ptrreg_to_str): Replace error() with
	output_operand_lossage().

2007-04-17  Anatoly Sokolov <aesok@post.ru>

	PR target/30483
	* config/avr/avr.c (ptrreg_to_str): Replace gcc_unreachable() with
	error().

2007-04-16  Matthias Klose  <doko@debian.org>

	* config/alpha/linux.h (CPP_SPEC): Define.
	* config/arm/linux-gas.h (SUBTARGET_CPP_SPEC): Extend.

2007-04-16  H.J. Lu  <hongjiu.lu@intel.com>

	* Backport from mainline:
	2007-04-16  H.J. Lu  <hongjiu.lu@intel.com>

	PR target/31582
	* config/i386/i386.c (ix86_expand_vec_set_builtin): Make a
	copy of source, pass it to ix86_expand_vector_set and return
	it as target.

2007-04-14  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR tree-opt/30045
	* tree-vrp.c (nonnull_arg_p): Treat the static decl as always
	non null.

2007-04-14  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR middle-end/30729
	* stmt.c (warn_if_unused_value): VA_ARG_EXPR has side
	effects unknown to this function, return early.

2007-04-14  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR c/31520
	* c-decl.c (finish_decl): Grab the type of the decl after the call
	to store_init_value.

2007-04-07  Anatoly Sokolov <aesok@post.ru>

	PR target/30289
	* config/avr/avr.md (*clrmemqi, *clrmemhi): Mark operand 4 as 
	earlyclobber.

2007-04-05  Anatoly Sokolov <aesok@post.ru>

	PR target/25448
	* config/avr/avr.c (avr_handle_fndecl_attribute): Use the 
	DECL_ASSEMBLER_NAME, not the DECL_NAME.

2007-04-04  Richard Henderson  <rth@redhat.com>

	PR target/31361
	* config/i386/i386.c (ix86_init_mmx_sse_builtins): Remove
	v8hi_ftype_v8hi_v2di, v4si_ftype_v4si_v2di.  Use like-types for
	the variable shift builtins.
	(ix86_expand_builtin): Properly expand the variable shift builtins.
	* config/i386/sse.md (ashr<mode>3, lshr<mode>3, ashl<mode>3): Make
	operand 2 be TImode.
	* config/i386/emmintrin.h (_mm_slli_epi16, _mm_slli_epi32,
	_mm_slli_epi64, _mm_srai_epi16, _mm_srai_epi32, _mm_srli_epi16,
	_mm_srli_epi32, _mm_srli_epi64): Turn into macros.
	(_mm_srli_si128, _mm_srli_si128): Fix disabled inline versions.
	(_mm_sll_epi16, _mm_sll_epi32, _mm_sll_epi64, _mm_sra_epi16,
	_mm_sra_epi32, _mm_srl_epi16, _mm_srl_epi32, _mm_srl_epi64): Use
	two-vector shift builtins.

2007-04-02  Anatoly Sokolov <aesok@post.ru>

	PR target/31137
	* config/avr/avr.c (avr_rtx_costs): Add missing 'break' statements.

2007-04-02  H.J. Lu  <hongjiu.lu@intel.com>

	* Backport from mainline:
	2007-03-28  Grigory Zagorodnev <grigory_zagorodnev@linux.intel.com>

	PR target/31380
	* config/i386/sse.md (uminv16qi3): Use UMIN instead of UMAX.

2007-03-30  Anatoly Sokolov <aesok@post.ru>

	* config/avr/avr.c (avr_override_options): Clear 
	'flag_delete_null_pointer_checks'.

2007-03-21  Richard Henderson  <rth@redhat.com>

	PR target/31245
	* config/i386/emmintrin.h (__m128i, __m128d): Mark may_alias.
	* config/i386/mmintrin.h (__m64): Likewise.
	* config/i386/xmmintrin.h (__m128): Likewise.

2007-03-19  Seongbae Park <seongbae.park@gmail.com>

	PR tree-optimization/30590
	* tree-nrv.c (tree_nrv): Check for the partial update
	of the return value.

2007-03-19  Jeff Law  <law@redhat.com>

	* tree-cfg.c (find_taken_edge): Tighten conditions for
	optimizing computed gotos.

2007-03-19  Brooks Moses  <brooks.moses@codesourcery.com>

	* doc/extend.texi: Edit "gnu_inline" documentation.
	* doc/invoke.texi: Edit "-fgnu89-inline" documentation.

2007-03-19  Ian Lance Taylor  <iant@google.com>

	* c.opt (fgnu89-inline): New option.
	* c-opts.c (c_common_post_options): Warn about -fno-gnu89-inline.
	* c-common.c (c_common_attributes): Add gnu_inline attribyte.
	(handle_gnu_inline_attribute): New static function.
	* c-cppbuiltin.c (c_cpp_builtins): Define __GNUC_GNU_INLINE__.
	* doc/invoke.texi (Option Summary): Mention -fgnu89-inline.
	(C Dialect Options): Document -fgnu89-inline.
	* doc/extend.texi (Function Attributes): Document gnu_inline.
	(Inline): Mention that C99 inline will be implemented in 4.3.
	Refer to ways to get the old handling.
	* doc/cpp.texi (Common Predefined Macros): Document
	__GNUC_GNU_INLINE__ and __GNUC_STDC_INLINE__.

2007-03-17  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/29906
	* dwarf2out.c (force_type_die): Adjust comment.
	(dwarf2out_imported_module_or_decl): Handle base AT_import types.

2007-03-16  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (attr_length_call): Partially revert change of 2007-03-09.
	(output_call): Likewise.

2007-03-15  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2007-02-28  Richard Guenther  <rguenther@suse.de>

	PR middle-end/30364
	* fold-const.c (fold_binary): Do not associate expressions
	with more than one variable for integer types that do not wrap.

2007-03-13  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/31123
	* pa.md (vdepi_ior): Don't allow zero length deposit.  Likewise for
	two unamed patterns.
	
2007-03-12  Roger Sayle  <roger@eyesopen.com>
	    Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR middle-end/30433
	* fold-const.c (fold_relational_const): Add back compile-time
	evaluation of complex constant equality/inequality comparisons.

2007-03-12  Richard Henderson  <rth@redhat.com>

	PR target/26090
	* config/alpha/alpha.c (alpha_elf_select_section): New.
	(alpha_elf_unique_section, alpha_elf_section_type_flags): New.
	(alpha_elf_select_rtx_section): Force flag_pic true.
	(TARGET_ASM_SELECT_SECTION, TARGET_ASM_UNIQUE_SECTION): New.
	(TARGET_SECTION_TYPE_FLAGS): New.

2007-03-12  Ira Rosen  <irar@il.ibm.com>

	PR tree-optimization/29925
	* tree-data-ref.c (analyze_offset): Add a return value (bool) to
	indicate success/failure of the analysis. Add negation to subtrahend
	in case of subtraction. Fail if both operands contain constants.
	(create_data_ref): Fail if analyze_offset fails.

2007-03-09  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (attr_length_call): Revise condition for long pc-relative branch.
	(output_call): Use "LONG_PIC_SDIFF" instruction sequence for long local
	calls on the SOM target.  Don't use "LONG_PIC_PCREL" call sequence on
	SOM target.

2007-03-09  Alexandre Oliva  <aoliva@redhat.com>

	PR rtl-optimization/30643
	* cse.c (cse_insn): Recompute dest_hash after insert_regs for
	dest_addr_elt.

2007-03-08  Andreas Schwab  <schwab@suse.de>

	* c-common.c (fold_offsetof_1): Remove extra argument in recursive
	call.

2007-03-08  Volker Reichelt  <reichelt@netcologne.de>

	PR c++/30852
	* c-common.c (fold_offsetof_1): Handle COMPOUND_EXPR.

2007-03-07  Richard Henderson  <rth@redhat.com>

	PR target/30848
	* reg-stack.c (emit_swap_insn): If a malformed asm was seen,
	silently fix up the stack in the case of a missing register.

2007-03-06  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* convert.c (convert_to_integer): Fix nearbyint/rint -> *lrint
	conversion.
	
2007-03-05  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.md: In unamed move patterns, disparge copies between general
	and floating point registers using '?' modifier.  Don't include 'f'
	constraint for register preferences in DImode, SImode, HImode and
	QImode patterns.  Likewise for 'r' in DFmode and SFmode patterns.
	Remove constraints for copies between general and floating registers
	in soft-float DFmode pattern.
	(movdf): Fail if operand1 is a CONST_DOUBLE and operand0 is a hard
	floating register.
	(movsf): Likewise. 

2007-02-27  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa/predicates.md (move_src_operand): Allow zero for mode.
	* pa/pa.md: Fix constraints for zero CONST_DOUBLE in 64-bit DFmode
	move pattern.

2007-02-27  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/30931
	* loop.c (combine_givs_p): Return false if either GIV is not
	always executed.

2007-02-21 Ira Rosen  <irar@il.ibm.com>

	* Makefile.in (tree-ssa-alias.o): Depend on pointer-set.h.

2007-02-20 Ira Rosen  <irar@il.ibm.com>

	* tree-ssa-alias.c: Include pointer-set.h. 
	(may_aliases_intersect): Use the correct type (varray) for
	may_aliases sets.

2007-02-18  Kaz Kojima  <kkojima@gcc.gnu.org>

	Backport from mainline.
	PR rtl-optimization/29599
	* reload1.c (eliminate_regs_in_insn): Take the destination
	mode into account when computing the offset.

2007-02-18  Roger Sayle  <roger@eyesopen.com>

	Backport from mainline.
	PR middle-end/24427
	PR rtl-optimization/28173
	* fold-const.c (fold_binary) <BIT_IOR_EXPR>: Transform (X&C1)|C2
	into (X,C2) if C1 is a subset of the bits of C2.  Transform
	(X&C1)|C2 into X|C2 if C1|C2 == ~0.  Canonicalize (X&C1)|C2 as
	(X&(C1&~C2))|C2.
	<BIT_AND_EXPR>: Canonicalize (X|C1)&C2 as (X&C2)|(C1&C2).

2007-02-18 Ira Rosen  <irar@il.ibm.com>

	* tree-ssa-alias.c (may_aliases_intersect): New function.
	* tree-data-ref.c (ptr_ptr_may_alias_p): Call may_aliases_intersect 
	for different tags.
	* tree-flow.h (may_aliases_intersect): Add function declaration.

2007-02-17  Alexandre Oliva  <aoliva@redhat.com>

	PR tree-optimization/30823
	* tree-sra.c (sra_build_assignment): Drop type-checking assert.

2007-02-16  Guy Martin  <gmsoft@gentoo.org>

	* pa.md (tp_load): Correct mfctl instruction syntax.

2007-02-16  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/30787
	* loop.c (strength_reduce): Don't reduce giv that is not always
	executed and where add_val or mult_val can trap.

2007-02-16  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	PR other/27843
	* Makefile.in (SYSTEM_HEADER_DIR): Use single quotes to avoid
	nested double- and backquotes.

2007-02-15  Anatoly Sokolov <aesok@post.ru>

	PR target/19087
	* config/avr/avr.c (DWARF2_ADDR_SIZE): Define.
	
2007-02-15  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.c (constantpool_mem_p): Skip over SUBREGs.

2007-02-15  Alexandre Oliva  <aoliva@redhat.com>

	* tree-sra.c (instantiate_missing_elements): Canonicalize
	bit-field types.
	(sra_build_assignment): New.
	(generate_copy_inout, generate_element_copy,
	generate_element_zero, generate_one_element_init): Use it.

2007-02-15  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/30189
	* dwarf2out.c (modified_type_die): Follow DECL_ORIGINAL_TYPE
	even if cv-qualification is the same.

2007-02-14  Eric Botcazou  <ebotcazou@adacore.com>
	    Maxim Kuvyrkov <mkuvyrkov@ispras.ru>

	PR rtl-optimization/28772
	* Makefile.in (haifa-sched.o): Add dependency on $(PARAMS_H).

	Backport from mainline:
	2006-04-13  Eric Botcazou  <ebotcazou@adacore.com>

	* params.def (PARAM_MAX_SCHED_READY_INSNS): New parameter,
	defaulting to 100.
	* params.h (MAX_SCHED_READY_INSNS): New macro.
	* haifa-sched.c: (queue_to_ready): Re-queue insns for the next cycle
	past MAX_SCHED_READY_INSNS during the first scheduling pass.
	(schedule_block): Delay insns past MAX_SCHED_READY_INSNS in
	the ready list for 1 cycle during the first scheduling pass.
	* doc/invoke.texi (--param): New parameter max-sched-ready-insns.

2007-02-14  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/30473
	* builtins.c (fold_builtin_sprintf): Do not attempt to optimize
	sprintf (str, "%s").  Do not optimize sprintf (str, "nopercent", p++).

2007-02-14  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2007-01-30  Richard Guenther  <rguenther@suse.de>

	PR middle-end/30313
	* passes.c (execute_one_pass): Reset in_gimple_form to not
	confuse non-unit-at-a-time mode.

2007-02-14  Mark Mitchell  <mark@codesourcery.com>

	* DEV-PHASE: Set to prerelease.
	* BASE-VER: Increment.

2007-02-13  Release Manager

	* GCC 4.1.2 released.

2007-02-06  Mark Mitchell  <mark@codesourcery.com>

	PR target/29487
	* tree.h (DECL_REPLACEABLE_P): New macro.
	* except.c (set_nothrow_function_flags): Likewise.

2007-02-06  Rask Ingemann Lamberisen  <rask@sygehus.dk>

	PR 30370 
	* config/rs6000/t-ppccomm: Correct Makefile typo.

2007-01-29  Josh Conner  <jconner@apple.com>

	PR middle-end/29683
	* calls.c (compute_argument_addresses): Set stack and stack_slot
	for partial args, too.
	(store_one_arg): Use locate.size.constant for the size when
	generating a save_area.

2007-01-28  Ralf Wildenhalf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/sourcebuild.texi: Add comma for clarity.
	* doc/extend.texi: Fix some typos.
	* doc/passes.texi: Likewise.
	* doc/cppinternals.texi: Likewise.
	* doc/c-tree.texi: Likewise.
	* doc/tree-ssa.texi: Likewise.
	* doc/install.texi: Likewise.

2007-01-21  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/29329
	* combine.c (replaced_rhs_insn): Rename to i2mod.
	(replaced_rhs_value): Rename to i2mod_new_rhs.
	(i2mod_old_rhs): New global variable.
	(combine_instructions): Adjust for above change.  Save a copy of
	the old RHS into i2mod_old_rhs when the contents of a REG_EQUAL
	note are substituted in the second instruction.
	(distribute_notes) <REG_DEAD>: Adjust for above change.  Do not
	ditch the note if it pertains to the second eliminated register
	and this register is mentioned in i2mod_old_rhs.

	Revert:
	2006-09-12  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* combine.c (distribute_notes) <REG_DEAD>: Do not consider SETs past
	the insn to which the note was originally attached.

2007-01-20  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (output_move_double): Change array size of xoperands to 4.

2007-01-17  Tom Tromey  <tromey@redhat.com>

	* doc/sourcebuild.texi (libgcj Tests): Use sourceware.org.
	* doc/install.texi (Testing): Use sourceware.org.
	(Binaries): Likewise.
	(Specific): Likewise.
	* doc/contrib.texi (Contributors): Use sourceware.org.

2007-01-11  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa-linux.h (ASM_OUTPUT_INTERNAL_LABEL): Undefine.
	* pa.h (ASM_OUTPUT_LABEL): Output colon when using GAS.
	(ASM_OUTPUT_INTERNAL_LABEL): Define.

2007-01-09  Nicolas Pitre  <nico@cam.org>

	PR target/30173
	* arm/ieee754-df.S (Lad_s): Also test the low word of X for zero.

2007-01-08  Nick Clifton  <nickc@redhat.com>

	* config/frv/predicates.md (reg_or_0_operand): Accept
	CONST_DOUBLEs.

2007-01-06  Richard Sandiford  <richard@codesourcery.com>

	Backport from mainline:
	2006-05-23  Richard Sandiford  <richard@codesourcery.com>

	PR rtl-optimization/27736
	* combine.c (replaced_rhs_value): New variable.
	(combine_instructions): Set it.
	(distribute_notes): When distributing a note in replaced_rhs_insn,
	check whether the value was used in replaced_rhs_value.

	2006-05-22  Richard Sandiford  <richard@codesourcery.com>

	PR rtl-optimization/25514
	* combine.c (replaced_rhs_insn): New variable.
	(combine_instructions): Set replaced_rhs_insn when trying to replace
	a SET_SRC with a REG_EQUAL note.
	(distribute_notes): Use replaced_rhs_insn when determining the live
	range of a REG_DEAD register.

2007-01-05  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/30212
	* tree-vrp.c (adjust_range_with_scev): Do not adjust invalid
	ranges by using TYPE_MIN_VALUE or TYPE_MAX_VALUE.

2007-01-05  Richard Guenther  <rguenther@suse.de>

	PR middle-end/27826
	* tree.c (get_narrower): Do not construct COMPONENT_REFs
	with mismatched types.  Instead explicitly build a
	conversion NOP_EXPR.

2007-01-05  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-06-24  Jan Hubicka  <jh@suse.cz>

	PR c/25795
	PR c++/27369
	* craph.c (cgraph_varpool_nodes): Export.
	(decide_is_variable_needed): Do not worry about "used" attribute.
	* cgraph.h (cgraph_varpool_nodes): Declare.
	* cgraphunit.c (decide_is_function_needed): Do not worry about "used"
	attribute.
	(process_function_and_variable_attributes): New function.
	(cgraph_finalize_compilation_unit): Call it.
	* c-decl.c (finish_decl): Do not worry about used attribute.
	* c-common.c (handle_externally_visible_attribute): Only validate.

2007-01-05  Joel Brobecker  <brobecker@adacore.com>

	* doc/install.texi (Final install): Document the fact that
	the GNAT runtime should not be stripped.

2007-01-05  Jakub Jelinek  <jakub@redhat.com>

	PR c/30360
	* libgcc2.c (__divdc3): Compare c and d against 0.0 instead of
	denom against 0.0.

	Backport from mainline:
	2006-09-17  Steven Bosscher  <steven@gcc.gnu.org>

	PR c/25993
	* c-opts.c (c_common_handle_option): Ignore the -std options
	if the input language is assembly.

2007-01-05  Richard Guenther  <rguenther@suse.de>

	PR middle-end/28116
	* tree-inline.c (copy_body_r): Mark argument of ADDR_EXPR
	addressable.

2007-01-05  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-10-15  Jan Hubicka  <jh@suse.cz>

	PR middle-end/29241
	* cgraphunit.c (cgraph_preserve_function_body_p): Preserve functions
	declared always_inline even when not inlining.

2007-01-03  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/30286
	* fold-const.c (negate_expr): Don't call fold_build1
	for INTEGER_CST or REAL_CST.

2006-12-27  Ian Lance Taylor  <iant@google.com>

	PR debug/26964
	* dwarf2out.c (gen_type_die): Don't write out a DIE for
	ENUMERAL_TYPE if it was already written out.

2006-12-23  Eric Botcazou  <ebotcazou@adacore.com>

	* dwarf2out.c (dbx_reg_number): Do leaf register remapping
	only if the function is leaf.
	(multiple_reg_loc_descriptor): Likewise.

	Backport from mainline:
	2006-05-13  Nick Clifton  <nickc@redhat.com>

	* dwarf2out.c (dbx_reg_number): Check return value from
	LEAF_REG_REMAP and only use it if it is valid.
	(multiple_reg_loc_descriptor): Likewise.

2006-12-21  Jakub Jelinek  <jakub@redhat.com>

	PR target/30230
	* config/ia64/ia64.c (ia64_add_bundle_selector_before): New function.
	(bundling): Use it.

2006-12-17  Matthias Klose  <doko@debian.org>

	PR libstdc++/11953
	* config/mips/linux.h (SUBTARGET_CPP_SPEC): Extend.

2006-12-16  Joseph Myers  <joseph@codesourcery.com>
	    David Edelsohn  <edelsohn@gnu.org>

	PR target/24036
	* doc/tm.texi (HARD_REGNO_NREGS_HAS_PADDING,
	HARD_REGNO_NREGS_WITH_PADDING): Document new target macros.
	* defaults.h (HARD_REGNO_NREGS_HAS_PADDING,
	HARD_REGNO_NREGS_WITH_PADDING): Define.
	* config/i386/i386.h (HARD_REGNO_NREGS_HAS_PADDING,
	HARD_REGNO_NREGS_WITH_PADDING): Define.
	* rtlanal.c (subreg_regno_offset, subreg_offset_representable_p):
	Use new macros to detect modes with holes; do not look at integer
	units.
	(subreg_offset_representable_p): Check for and disallow cases
	where the modes use different numbers of bits from registers.
	* config/rs6000/rs6000.c (rs6000_emit_move): Handle TFmode
	constant for soft-float.
	(rs6000_hard_regno_nregs): Use UNITS_PER_FP_WORD for e500 GPRs
	containing doubles.
	(rs6000_split_multireg_move): Use DFmode reg_mode for TFmode moves
	in E500 double case.
	* config/rs6000/rs6000.md (movtf): Allow soft-float.
	(movtf_softfloat): New.

2006-12-15  Jakub Jelinek  <jakub@redhat.com>

	PR target/30185
	* config/rs6000/rs6000.md (div<mode>3): Use correct mode in
	force_reg call.

2006-12-12  Jakub Jelinek  <jakub@redhat.com>

	PR libstdc++/11953
	* gthr-posix.h (_REENTRANT): Only define if __osf__ is defined.

	* config/ia64/linux.h (CPP_SPEC): Define.
	* config/s390/linux.h (CPP_SPEC): Define.

2006-12-12  Jim Wilson  <wilson@specifix.com>
	    Jakub Jelinek  <jakub@redhat.com>

	PR rtl-optimization/27761
	* combine.c (try_combine): Don't create a useless garbage SET
	if PATTERN (i2) is a PARALLEL.  If added_sets_1, save
	PATTERN (i1) resp. SET from i1src to i1dest in i1pat
	and use it to prevent accidental modification of i1src.

2006-12-08  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/30039
	* pa.md (high:DI and lo_sum:DI): Handle 64-bit CONST_INTs in 32-bit
	patterns.  Correct length of high:DI instruction sequence.

2006-11-29  Joseph Myers  <joseph@codesourcery.com>

	* config/rs6000/predicates.md (gpc_reg_operand): Check
	invalid_e500_subreg.
	* config/rs6000/rs6000.c (invalid_e500_subreg): Don't allow any
	SImode subregs of SPE vectors.
	* config/rs6000/rs6000.md (insv): Fail for invalid E500 subregs.
	* jump.c (true_regnum): Require subregs to satisfy
	subreg_offset_representable_p.

2006-11-29  Jie Zhang  <jie.zhang@analog.com>

	* doc/tm.texi (NO_PROFILE_COUNTERS): Document more accurately.

2006-11-29  Joseph Myers  <joseph@codesourcery.com>

	* config/rs6000/rs6000.c (rs6000_gimplify_va_arg): If
	STRICT_ALIGNMENT and the type is more aligned than the saved
	registers, copy via a temporary.

2006-11-28  Joseph Myers  <joseph@codesourcery.com>

	* function.c (instantiate_virtual_regs_in_insn): Call force_reg
	inside start_sequence / end_sequence pair.

2006-11-27  Michael Matz  <matz@suse.de>
	    Andreas Krebbel  <krebbel1@de.ibm.com>

	PR target/29319
	* config/s390/predicates.md (larl_operand): Check addend of larl
	operand to be in range of -/+2GB.
	* config/s390/s390.c (legitimize_pic_address): Likewise.  
	Changed type of variable even to HOST_WIDE_INT.

2006-11-25  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR tree-opt/29964
	* ipa-pure-const.c (check_tree): If the original tree
	is volatile return early and say the function is not pure
	nor const.  Remove the volatile check for writes.  
	(analyze_function): Print out the result of the local
	analysis pass.

2006-11-24  Jakub Jelinek  <jakub@redhat.com>

	PR c/29736
	* c-common.c (handle_vector_size_attribute): Disallow VECTOR_TYPE
	or UNION_TYPE inner types.

2006-11-24  Joseph Myers  <joseph@codesourcery.com>

	* config/rs6000/eabispe.h (TARGET_DEFAULT): Include
	MASK_STRICT_ALIGN.
	* config/rs6000/linuxspe.h (TARGET_DEFAULT): Likewise.
	* config/rs6000/rs6000.c (rs6000_override_options): Use
	MASK_STRICT_ALIGN for 8540 and 8548.  Add MASK_STRICT_ALIGN to
	POWERPC_MASKS.

2006-11-24  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390.c (s390_emit_compare_and_swap): New function.
	(s390_expand_cs_hqi, s390_expand_atomic): Call 
	s390_emit_compare_and_swap.

2006-11-23  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (return_addr_rtx): Change 0xe0400002 to -532676606.

2006-11-22  Joseph Myers  <joseph@codesourcery.com>

	* config/rs6000/spe.md (SPE64): New mode macro.
	(mov_sidf_e500_subreg0): Change to mov_si<mode>_e500_subreg0.  Add
	memory load.
	(mov_si<mode>_e500_subreg0_2): New.
	(mov_sidf_e500_subreg4): Change to mov_si<mode>_e500_subreg4.  Add
	memory load.
	(mov_si<mode>_e500_subreg4_2): New.
	* config/rs6000/predicates.md (input_operand): Do not allow
	invalid E500 subregs.
	(rs6000_nonimmediate_operand): Check for invalid E500 subregs also
	if TARGET_SPE.
	* config/rs6000/rs6000.c (invalid_e500_subreg): Check for subregs
	involving DFmode if TARGET_E500_DOUBLE.  Check for subregs
	involving vector modes if TARGET_SPE.

2006-11-20  Anatoly Sokolov <aesok@post.ru>

	PR target/18553
	PR target/29449
	* config/avr/avr.h (OBJECT_FORMAT_ELF): Define.

	* config/avr/avr.h (DWARF2_DEBUGGING_INFO): Define.

2006-11-19  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/29114
	* pa.c (emit_move_sequence): Don't split constants with PLUS for modes
	larger than BITS_PER_WORD.

2006-11-19  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-11-15  Paolo Bonzini  <bonzini@gnu.org>

	PR middle-end/29753
	* gimplify.c (fold_indirect_ref_rhs): Use
	STRIP_USELESS_TYPE_CONVERSION rather than STRIP_NOPS.

2006-11-19  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-09-22  Zdenek Dvorak <dvorakz@suse.cz>

	PR tree-optimization/28888
	* tree-if-conv.c (combine_blocks): Rewritten.
	* tree-cfg.c (tree_verify_flow_info): Check that edges with
	EDGE_TRUE/FALSE_VALUE follow COND_EXPR.

2006-11-18  Joseph Myers  <joseph@codesourcery.com>

	* config/rs6000/spe.md (movv4hi_internal): Add alternative for
	easy vector constant loads.

2006-11-18  Joseph Myers  <joseph@codesourcery.com>

	* config/rs6000/rs6000.h (TARGET_NO_LWSYNC): Define.
	* config/rs6000/rs6000-c.c (rs6000_cpu_cpp_builtins): Define
	__NO_LWSYNC__ if TARGET_NO_LWSYNC.
	* config/rs6000/sync.md (lwsync): Emit plain sync if
	TARGET_NO_LWSYNC.

2006-11-17  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR tree-opt/29788
	* fold-const.c (fold_indirect_ref_1): Fold *&CONST_DECL down
	to what is the const decl is a place holder for.

2006-11-17  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/29584
	* tree-ssa-dom.c (simplify_switch_and_lookup_avail_expr): Don't
	optimize if DEF doesn't have integral type.

2006-11-17  Uros Bizjak  <ubizjak@gmail.com>

	* config/i386/i386.c (ix86_function_sseregparm): Fix comment:
	number of arguments passed to local functions in SSE registers is 3.

	* doc/invoke.texi (Function Attributes) [sseregparm]: Correct
	number of arguments passed in SSE registers to 3.

2006-11-16  Eric Botcazou  <ebotcazou@adacore.com>

	PR middle-end/26306
	* gimplify.c (gimplify_expr): Only force a load for references to
	non-BLKmode volatile values.
	* doc/implement-c.texi (Qualifiers implementation): Document the
	interpretation of what a volatile access is.
	* doc/extend.texi (C++ Extensions): Rework same documentation.

2006-11-16  Joseph Myers  <joseph@codesourcery.com>

	* config/rs6000/spe.md (frob_di_df_2): Handle non-offsettable
	memory operand.

2006-11-15  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/ia64.c (ia64_hpux_init_libfuncs):  Use HP-UX millicode
	routines for integer division.

2006-11-15  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/29581
	* lambda-code.c (replace_uses_equiv_to_x_with_y): Add YINIT,
	REPLACEMENTS, FIRSTBSI arguments.  If initial condition or
	type is different between Y and USE, create a temporary
	variable, initialize it at the beginning of the body bb
	and use it as replacement instead of Y.

2006-11-15  Richard Guenther  <rguenther@suse.de>

	Backport from mainline: 
	2006-11-12  Michael Matz  <matz@suse.de>
		    Roger Sayle  <roger@eyesopen.com>

	PR rtl-optimization/29797
	* ifcvt.c (noce_try_bitop): Correct calculation of bitnum on
	BITS_BIG_ENDIAN targets.

2006-11-13  Jakub Jelinek  <jakub@redhat.com>

	* configure.ac (ld_vers): Parse GNU ld version 2.17.50.0.3-6 20060715
	style versions.
	* configure: Rebuilt.

2006-11-13  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-10-23  Richard Guenther  <rguenther@suse.de>

	PR middle-end/21032
	* convert.c (convert_to_real): Fold (float)-x to -(float)x
	only if not flag_rounding_math.

2006-11-11  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR tree-opt/28545
	* tree-vrp.c (replace_uses_by_vrp): New function.
	(remove_range_assertions): Use it.

2006-11-12  Jie Zhang  <jie.zhang@analog.com>

	* config/bfin/bfin.h (TARGET_CPU_CPP_BUILTINS): Use builtin_define_std
	instead of builtin_define for bfin and BFIN.

2006-11-11  Jie Zhang  <jie.zhang@analog.com>

	* config/bfin/bfin.h (FUNCTION_PROFILER): Don't use LABELNO.
	(NO_PROFILE_COUNTERS): Define as 1.

2006-11-09  Janis Johnson  <janis187@us.ibm.com>

	Backports from mainline.
	* doc/sourcebuild.texi (Test Directives): Document dg-shouldfail,
	output-exists and output-exists-not.

2006-11-07  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/29610
	* tree-cfgcleanup.c (cleanup_control_flow): Honor return value
	of tree_purge_dead_eh_edges as it may free dominators.

	* g++.dg/other/pr29610.C: New testcase.

2006-11-07  Jie Zhang  <jie.zhang@analog.com>

	* gcc.c (process_command): Treat -b as normal switch if its argument
	has no dash.

2006-11-05  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/29695
	* fold-const.c (fold_ternary): Fix A < 0 ? <sign bit of A> : 0
	simplification.

2006-11-02  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi (sparc-sun-solaris2*): Update GMP/MPFR build

	(sparc64-sun-solaris2*): Likewise.

2006-11-02  Zdenek Dvorak <dvorakz@suse.cz>

	PR tree-optimization/27891
	* tree-ssa-loop-ivopts.c (rewrite_use_outer): Do not insert code
	on abnormal edge.

2006-11-01  David Edelsohn  <edelsohn@gnu.org>
	    Ian Lance Taylor  <ian@airs.com>

	PR middle-end/29250
	* expr.c (expand_expr_real_1) <NON_LVALUE_EXPR, NOP_EXPR,
	CONVERT_EXPR>: Change EXPAND_SUM modifier to EXPAND_NORMAL when
	recursing.

2006-11-01  Chris Johns <chris@contemporary.net.au>

	PR bootstrap/28400
	* Makefile.in (install-driver): Use exeext when installing
	$target-gcc-$version.
	
2006-11-01  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/28970
	* loop.c (loop_giv_reduce_benefit): Take the max of the addition
	cost on all the increments of the BIV.

2006-11-01  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.def (gamma, lgamma): Use ATTR_MATHFN_FPROUNDING_STORE.

2006-10-31  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/29631
	* loop.c (basic_induction_var): Add new parameter inner_mode.
	<PLUS>: If set, convert the increment to it before sign-extending.
	<CONST_INT>: Likewise.
	<SUBREG>: Set it.
	<ASHIFTRT>: Likewise.  Return 0 if flag_wrapv.
	(check_insn_for_bivs): Pass VOIDmode as inner_mode to above.

2006-10-30  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/29637
	* tree.c (make_vector_type): Don't recurse if TYPE_MAIN_VARIANT
	of the innertype is the innertype itself.

2006-10-28 Uros Bizjak <uros@kss-loka.si>

	PR target/29377
	* config/h8300/h8300.c (h8300_emit_stack_adjustment): Change "size"
	argument to HOST_WIDE_INT.  Update function prototype.
	(round_frame_size): Change return type to HOST_WIDE_INT.  Change
	"size" argument to HOST_WIDE_INT.  Update function prototype.

2006-10-26  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390/s390.c (s390_init_frame_layout): Check positive
	frame_size.

2006-10-25  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/hpux.h: Define _INCLUDE__STDC_A1_SOURCE in C++.
	Add unix98.o to link line.

2006-10-25  Paolo Bonzini  <bonzini@gnu.org>

	PR c/29092
	* c-typeck.c (digest_init): Always allow initializing vectors
	that have static storage duration with compound literals.
	* tree.c (build_type_attribute_qual_variant): New, based on
	build_type_attribute_variant.
	(build_type_attribute_variant): Rewrite using the former.
	(make_vector_type): Use build_type_attribute_qual_variant to build
	type variants.  Use type_hash_canon on the others.

2006-10-23  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/predicates.md ("bras_sym_operand"): Do not accept
	nonlocal function symbols if flag_pic.

2006-10-19  Eric Botcazou  <ebotcazou@adacore.com>

	* fold-const.c (add_double): Rename to add_double_with_sign.
	Add 'unsigned_p' parameter and take it into account for the overflow.
	(mul_double): Rename to mul_double_with_sign. 
	Add 'unsigned_p' parameter and take it into account for the overflow.
	(fold_div_compare): Call add_double_with_sign instead of add_double
	and mul_double_with_sign instead of mul_double, passing them the
	unsignedness of the type.
	* tree.h (add_double): Macroize.
	(add_double_with_sign): New prototype.
	(mul_double): Macroize.
	(mul_double_with_sign): New prototype.

2006-10-19 Ira Rosen  <irar@il.ibm.com>

	Backport from mainline:
	2006-08-07  Victor Kaplansky <victork@il.ibm.com>

	PR tree-optimization/26969
	* tree-vect-analyze.c (vect_analyze_loop_form): Add check of latch
	with an empty list of PHIs.

2006-10-18  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-08-16  Zdenek Dvorak <dvorakz@suse.cz>

	PR gcov/profile/26570
	* value-prof.c (static_values): Removed.
	(tree_find_values_to_profile): Do not set static_values.
	(find_values_to_profile): Do not free static_values.
	* profile.c (instrument_values): Do not free the values.
	(branch_prob): Free the values.

2006-10-18  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-05-11  Jan Hubicka  <jh@suse.cz>

	PR debug/26881
	* Makefile.in (gt-cgraphunit.h): Add.
	* cgraphunit.c: Include gt-cgraphunit.h.
	(local_static_output): New static vector.
	(cgraph_varpool_assemble_decl): Defer outputting debug info
	for local statics to...
	(cgraph_varpool_debug_local_statics): ... here.
	(cgraph_optimize): Use it.

2006-10-18  Richard Guenther  <rguenther@suse.de>

	* except.c (set_nothrow_function_flags): Fix return value.

2006-10-17  Paul Brook  <paul@codesourcery.com>

	Backport from mainline:
	* config/arm/arm.c (arm_rtx_costs_1): Handle multiply-accumulate.

2006-10-16  Richard Guenther  <rguenther@suse.de>

	PR target/28960
	Backport from mainline:
	2006-08-23  Stuart Hastings  <stuart@apple.com>

	PR target/28825
	* config/i386/i386.c (ix86_expand_vector_init_duplicate,
	ix86_expand_vector_init_one_nonzero): Remove TARGET_SSE test.

2006-10-16  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-10-10  Richard Guenther  <rguenther@suse.de>

	PR inline-asm/29119
	* gimplify.c (gimplify_asm_expr): Mark the gimplified lvalue
	addressable.

2006-10-16  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-08-13  Alexandre Oliva  <aoliva@redhat.com>
		    Andrew Pinski  <pinskia@physics.uc.edu>

	PR c/27184
	* tree.c (build_array_type): Unify array types with
	unspecified index_type.
	* c-decl.c (grokdeclarator): Make sure we do not modify a
	unified incomplete array type.
	* c-typeck.c (store_init_value): Create distinct type before
	filling in the index type in an initializer from a compound
	literal.

	* c-decl.c (grokdeclarator): Remove code where we copy the
	array type over.

2006-10-16  Jakub Jelinek  <jakub@redhat.com>

	PR c/29091
	* varasm.c (output_constant): If TREE_VECTOR_CST_ELTS chain is shorter than
	the number of vector elements fill the rest with zeros.

2006-10-16  Richard Guenther  <rguenther@suse.de>

	PR target/25519
	* doc/extend.texi (X86 Built-in Functions): Fix typos in
	SSE builtin documentation.  Document SSE2 builtins.

2006-10-15  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa64-hpux.h (LINK_SPEC): Force __cxa_finalize to be an undefined
	symbol in the output file for non-shared links when -nostdlib or
	-nodefaultlibs isn't specified.

	* config.gcc (hppa*64*-*-hpux11*, hppa[12]*-*-hpux11*): Default to
	posix thread support.

2006-10-14  Richard Guenther  <rguenther@suse.de>

	PR rtl-optimization/29323
	* except.c (set_nothrow_function_flags): For functions
	that do not bind local bail out early.

2006-10-14  Uros Bizjak  <uros@kss-loka.si>

	* config/i386/athlon.md (athlon_fist): Add fisttp.

2006-10-12  Jie Zhang  <jie.zhang@analog.com>

	* config/bfin/bfin.md (eh_return): Call emit_jump_insn instead of
	emit_insn to emit eh_return_internal instruction.
	(eh_return_internal): Explicitly set pc.

2006-10-06  Steve Ellcey  <sje@cup.hp.com>

	PR target/28490
	Backport from mainline
	2006-09-15  Jim Wilson  <wilson@specifix.com>
	2006-09-19  Steve Ellcey  <sje@cup.hp.com>
	* config/ia64/ia64.c (ia64_legitimate_constant_p): Allow function
	pointers as legitimate constants.  Handle symbol offsets same as
	they are handled in ia64_expand_move and move_operand.

2006-10-06  Jakub Jelinek  <jakub@redhat.com>

	* tree-loop-linear.c (linear_transform_loops): Don't forget to
	free DEPENDENCE_RELATIONS and DATAREFS.

	PR target/28924
	* builtins.c (expand_builtin_sync_operation,
	expand_builtin_compare_and_swap, expand_builtin_lock_test_and_set):
	Use convert_to_mode to handle promoted arguments.

2006-10-05  Uros Bizjak  <uros@kss-loka.si>

	* config/i386/sync.md ("sync_add<mode>", "sync_sub<mode>",
	"sync_ior<mode>", "sync_and<mode>", "sync_xor<mode>"):
	Use <modeconstraint> instead of "r" as operand 1 constraint.

2006-10-06  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/29290
	* tree-loop-linear.c (linear_transform_loops): Bail if loop_nest has
	multiple exits.

	PR target/29198
	* config/i386/i386.c (legitimize_pic_address): Reject TLS symbols.
	* config/i386/predicates.md (local_symbolic_operand): Likewise.

2006-10-05  David Edelsohn  <edelsohn@gnu.org>

	Backport from mainline
	2006-09-11  Guenter Roeck  <guenter@roeck-us.net>
		    David Edelsohn  <edelsohn@gnu.org>

	PR target/27287
	* config/rs6000/spe.md (frob_df_di): Remove %H.
	(frob_di_df): Remove %H.  Change evmergelo to mr.
	(frob_di_df_2): Remove %H.  Change evldd to two loads.

2006-10-05  Andrew Pinski  <pinskia@physics.uc.edu>

	PR debug/28980
	* dwarf2out.c (loc_descriptor_from_tree_1): Handle
	FUNCTION_DECL.

2006-10-04  Andrew Pinski  <pinskia@physics.uc.edu>

	PR c/27490
	PR c/27489
	* c-typeck.c (build_compound_expr): If the second expression
	is an error mark, then just return an error mark instead of
	creating a COMPOUND_EXPR.

2006-10-04  Andrew Pinski  <pinskia@physics.uc.edu>

	PR tree-opt/28952
	* tree-vect-transform.c (vectorizable_condition): Move the check
	for the type after the check for simple condition.

2006-10-03  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/28862
	* stor-layout.c (relayout_decl): Don't zero the alignment if it
	was set by the user.

2006-10-02  Jakub Jelinek  <jakub@redhat.com>

	Backport from mainline
	2006-02-20  Angel Nunez Mencias  <anunez@de.ibm.com>

	* config/s390/s390.c (legitimize_pic_address): Assertions checking
	for non tls symbols added.
	(legitimize_address): Do nothing for PLUS expressions if one of the
	addends is a tls symbol reference.

2006-10-02  Jakub Jelinek  <jakub@redhat.com>

	PR c/29154
	* gimplify.c (gimplify_self_mod_expr): Run inner expression's post
	side effects after the outer expression's post side effects.

2006-09-27  Paul Brook  <paul@codesourcery.com>

	PR target/29230
	Backport from mainline.
	* config/arm/arm.md (arith_adjacentmem): Handle large offsets.

2006-09-25  Matthias Klose  <doko@debian.org>

	* doc/invoke.texi: Add missing full stop.

2006-09-24  Roger Sayle  <roger@eyesopen.com>

	PR debug/29132
	Backport from mainline
	* dwarf2out.c (dwarf2out_begin_prologue): Initialise the current label,
	dw_fde_current_label, to be the start of the function, i.e. the same
	value as dw_fde_begin.

2006-09-20  Steven Bosscher  <steven@gcc.gnu.org>

	PR middle-end/26983
	Backport from mainline
	* builtins.c (expand_builtin_setjmp): Force next_lab to be
	preserved.

2006-09-20  Paul Brook  <paul@codesourcery.com>

	Backport from mainline.
	* config/arm/unwind-arm.c (selfrel_offset31): Clear top bit for
	positive offsets.

2006-09-18  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/4520
	Backport from mainline
	* cselib.c (cselib_hash_rtx): Avoid hashing on the address of labels
	and symbols.  Instead use the implementation from cse.c's hash_rtx.

2006-09-18  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	PR tree-optimization/28900
	* tree-if-conv.c (find_phi_replacement_condition): Gimplify
	compound conditional before creating COND_EXPR condition.

2006-09-18  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	J"orn Rennecke  <joern.rennecke@st.com>
	Richard Guenther  <rguenther@suse.de>
	Adam Nemet  <anemet@caviumnetworks.com>

	PR middle-end/27226
	* builtins.c (get_pointer_alignment): Handle more forms
	of base addresses that can be used to derive more precise
	information about alignment.

2006-09-15 Uros Bizjak <uros@kss-loka.si>

	PR target/28946
	* config/i386/i386.md ("*ashldi3_cconly_rex64", "*ashlsi3_cconly",
	"*ashlhi3_cconly", "*ashlqi3_cconly", "*ashrdi3_one_bit_cconly_rex64",
	"*ashrdi3_cconly_rex64", "*ashrsi3_one_bit_cconly", "*ashrsi3_cconly",
	"*ashrhi3_one_bit_cconly", "*ashrhi3_cconly",
	"*ashrqi3_one_bit_cconly", "*ashrqi3_cconly",
	"*lshrdi3_cconly_one_bit_rex64", "*lshrdi3_cconly_rex64",
	"*lshrsi3_one_bit_cconly", "*lshrsi3_cconly",
	"*lshrhi3_one_bit_cconly", "*lshrhi3_cconly",
	"*lshrqi2_one_bit_cconly", "*lshrqi2_cconly": New patterns to
	implement only CC setting effects of shift instructions.

2006-09-14  Jason Merrill  <jason@redhat.com>

	PR middle-end/28493
	* builtins.c (expand_builtin_setjmp_receiver): Clobber
	hard_frame_pointer_rtx after using it to update the frame pointer.

2006-09-14  Anatoly Sokolov <aesok@post.ru>

	PR target/26504
	* config/avr/avr.h (FRAME_POINTER_CFA_OFFSET): Define.

2006-09-12  H.J. Lu  <hongjiu.lu@intel.com>

	* doc/invoke.texi (mpreferred-stack-boundary): Remove exception
	for -Os. Update __m128 alignment requirement.

2006-09-12  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/28243
	* combine.c (distribute_notes) <REG_DEAD>: Do not consider SETs past
	the insn to which the note was originally attached.

2006-09-11  H.J. Lu  <hongjiu.lu@intel.com>

	PR target/13685
	PR target/27537
	PR target/28621
	* config/i386/i386.c (override_options): Always default to 16
	byte stack boundary.

2006-09-11  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/28726
	* sched-deps.c (sched_analyze_reg): New function extracted from...
	(sched_analyze_1): ...here.  Call it to analyze references to
	registers.  Treat again writes to a stack register as writing to the
	register.
	(sched_analyze_2): ...and here.  Call it to analyze references to
	registers.  Treat again reads of a stack register as reading the
	register.

2006-09-11  Hideki Iwamoto  <h-iwamoto@kit.hi-ho.ne.jp>

	* doc/cpp.texi: Fix names of charset options.

2006-09-10  Roger Sayle  <roger@eyesopen.com>
	    Nicolas Setton <setton@adacore.com>

	Backport from mainline
	* dwarf2out.c (convert_cfa_to_fb_loc_list): Handle DW_CFA_set_loc.

2006-09-10  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/28636
	* combine.c (force_to_mode): Test for side-effects before
	substituting by zero.
	(simplify_shift_const): Likewise for zero or other constants.

2006-09-10  Richard Sandiford  <richard@codesourcery.com>

	PR target/29006
	* config/mips/mips-protos.h (mips_mem_fits_mode_p): Declare.
	* config/mips/mips.c (mips_expand_unaligned_store): Use the mode
	returned by mode_for_size, rather than the mode of src itself,
	to choose between 32-bit and 64-bit patterns.
	(mips_mem_fits_mode_p): New function.
	* config/mips/mips.md (mov_<load>l, mov_<load>r): Use it to check
	that the size of the source matches the size of the destination.
	(mov_<store>l, mov_<store>r): Likewise.

2006-09-10  Richard Sandiford  <richard@codesourcery.com>

	PR target/27681

	Backport from mainline:

	2006-05-23  Richard Sandiford  <richard@codesourcery.com>

	* libgcc2.c (LIBGCC2_MAX_UNITS_PER_WORD): New macro.
	(LIBGCC2_UNITS_PER_WORD): Use LIBGCC2_MAX_UNITS_PER_WORD rather than
	MIN_UNITS_PER_WORD to set the default.  Also use it in the guard.

	2006-05-22  Richard Sandiford  <richard@codesourcery.com>

	* mklibgcc.in (lib2funcs): Remove _floatdidf from initial assignment.

	2006-05-19  Richard Sandiford  <richard@codesourcery.com>

	* libgcc2.c (MIN_UNITS_PER_WORD): Move default definition from
	libgcc2.h.
	(LIBGCC2_UNITS_PER_WORD): Provide default definition, using old
	MIN_UNITS_PER_WORD logic from libgcc2.h.  Do nothing if
	LIBGCC2_UNITS_PER_WORD > MIN_UNITS_PER_WORD.
	* libgcc2.h (MIN_UNITS_PER_WORD): Remove definition from here.
	Use LIBGCC2_UNITS_PER_WORD rather than MIN_UNITS_PER_WORD to
	determine the size of Wtype, etc.
	* mklibgcc.in (LIB2_SIDITI_CONV_FUNCS): New argument.
	(swfloatfuncs): New variable.
	(dwfloatfuncs): Likewise.
	(lib2funcs): Remove floating-point conversion functions from
	initial assignment.  Use LIB2_SIDITI_CONV_FUNCS to determine
	the set of conversion routines needed.  Allow entries to specify
	an object name, filename and word size.  Update users accordingly.
	* Makefile.in (libgcc.mk): Pass LIB2_SIDITI_CONV_FUNCS.
	* config/mips/t-mips (LIB2_SIDITI_CONV_FUNCS): Define.

	Revert:

	2006-02-08  Roger Sayle  <roger@eyesopen.com>

	PR target/22209
	* config/fixtfdi.c: New libgcc source file.
	* config/fixunstfdi.c: New source file.
	* config/floatditf.c: New source file.
	* config/floatunditf.c: New souce file.
	* config/mips/t-iris6 (LIB2FUNCS_EXTRA): Include the new source
	files above instead of config/mips/_tilib.c.
	* config/mips/t-linux64 (LIB2FUNCS_EXTRA): Likewise.

2006-09-09  Richard Sandiford  <richard@codesourcery.com>

	PR rtl-optimization/28634
	* reorg.c (fill_slots_from_thread): Do not assume A + X - X == A
	for floating-point modes unless flag_unsafe_math_optimizations.

2006-09-07  Jason Merrill  <jason@redhat.com>

	PR middle-end/27724
	* varasm.c (output_constant): Only strip actual no-op conversions.

2006-09-06  Matthias Klose  <doko@debian.org>

	PR bootstrap/26764
	PR bootstrap/27334
	* Makefile.in (s-macro_list): Conform to POSIX rules in single quoted
	strings.

2006-09-05  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/28386
	* loop.c (biased_biv_may_wrap_p): Rename to biv_may_wrap_p and
	remove 'bias' parameter.
	(maybe_eliminate_biv_1): Adjust for above change.

2006-09-04  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/27616
	* cse.c (table_size): New static variable.
	(new_basic_block): Initialize it to 0.
	(remove_from_table): Decrement it.
	(insert): Increment it.
	(fold_rtx_mem_1): New function, renamed from fold_rtx_mem.
	(fold_rtx_mem): Enforce a cap on the recursion depth.  Call
	fold_rtx_mem_1 if under the cap.
	(fold_rtx) <RTX_COMM_ARITH>: In the associative case, delay a little
	the lookup of the equivalent expression and test for equality of the
	first operand of the equivalent expression before in turn looking up
	an equivalent constant for the second operand.

2006-09-01  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	PR middle-end/28814
	* fold-const.c (fold_binary): Fold temporary to correct
	type before constructing new comparison.

2006-09-01  Roger Sayle  <roger@eyesopen.com>

	PR other/22313
	* dwarf2out.c (add_fde_cfi): Use a set_loc if the current label is
	NULL, otherwise use an advance_loc4 to adjust relative to the 
	current label.
	(output_cfi) <DW_CFA_set_loc>: Update the current label.
	(dwarf2out_switch_text_section): Reset the current label to avoid
	using advance_loc4 over section boundaries.

2006-09-01  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/28683
	* cfgexpand.c (add_reg_br_prob_note): Check if last has exactly
	3 following insns.

2006-08-31  Andreas Krebbel  <krebbel1@de.ibm.com>

	PR target/24367
	* config/s390/s390.md ("movsi", "movdi" expander): Accept rtxes like
	r12 + SYMBOLIC_CONST.

2006-08-25  Joseph S. Myers  <joseph@codesourcery.com>

	PR c/27893
	* gimplify.c (gimplify_decl_expr, gimplify_init_ctor_preeval):
	Treat sizes as variable whenever not INTEGER_CST.

2006-08-25  Fariborz Jahanian  <fjahanian@apple.com>

	PR c/28418
	* c-gimplify.c (gimplify_compound_literal_expr): Don't add
	variable again if DECL_SEEN_IN_BIND_EXPR_P.

2006-08-25  Joseph S. Myers  <joseph@codesourcery.com>

	PR c/28299
	* c-decl.c (start_function): Don't try to process prototype
	information from old declaration that isn't a function.

2006-08-25  Joseph Myers  <joseph@codesourcery.com>

	PR c/27558
	Backport:
	2006-04-20  Jakub Jelinek  <jakub@redhat.com>
	* c-pretty-print.c (pp_c_direct_abstract_declarator): Print
	TYPE_MAX_VALUE (TYPE_DOMAIN (t)) + 1 for ARRAY_TYPE rather
	than plain TYPE_MAX_VALUE (TYPE_DOMAIN (t)).

2006-08-25  Alan Modra  <amodra@bigpond.net.au>

	PR target/27075
	* config/rs6000/rs6000.c (print_operand): Only use e500 %y syntax
	for 8 byte objects.

2006-08-21  Mark Shinwell  <shinwell@codesourcery.com>

	* config/arm/pr-support.c (__gnu_unwind_execute): Insert " + 1" in
	necessary places to pass the correct "number of registers" values
	to _Unwind_VRS_Pop.

2006-08-18  Joseph Myers  <joseph@codesourcery.com>

	PR target/27565
	* config/rs6000/rs6000.h (LOCAL_ALIGNMENT): For SPE, only adjust
	alignment of SPE vector types.

2006-08-17  Sebastian Pop  <pop@cri.ensmp.fr>

	PR middle-end/25211
	PR middle-end/20256
	PR middle-end/26435
	* tree-loop-linear.c (linear_transform_loops): Don't test perfect_nest_p.
	Call rewrite_into_loop_closed_ssa only when something changed.
	* lambda.h (gcc_loopnest_to_lambda_loopnest): Update declaration.
	* lambda-code.c (can_convert_to_perfect_nest): Declared.
	(gcc_loopnest_to_lambda_loopnest): Removed need_perfect_nest parameter.
	Test for perfect_nest_p here.  Fix formating.
	(replace_uses_equiv_to_x_with_y): Fix formating.
	(stmt_uses_op): Removed.
	(can_convert_to_perfect_nest): Removed loopivs parameter.
	Complete the test by checking the scalar dependences.
	(perfect_nestify): Remove the test for can_convert_to_perfect_nest.
	Fix formating.  Don't copy statements in the inner loop: move them to
	the inner loop header.

2006-08-16  Joseph S. Myers  <joseph@codesourcery.com>

	PR c/27697
	* c-typeck.c (build_component_ref): Combine qualifiers of
	structure or union and field.

2006-08-15  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR c/28649
	* c-parser.c (c_parser_compound_statement_nostart): Reset
	parser->error after each statement.

2006-08-14  Andrew Pinski  <pinskia@gmail.com>

	PR middle-end/28075
	* tree-inline.c (setup_one_parameter): Strip useless
	type conversion before adding it to the IR.
	(declare_return_variable): Likewise.

2006-08-13  Andrew MacLeod  <amacleod@redhat.com>

	PR middle-end/27793
	* tree-dfa.c (add_referenced_var): Assert DECL_UID is unique for
	different decls.

2006-08-13  Jakub Jelinek  <jakub@redhat.com>

	PR c++/28677
	Revert:
	2006-06-06  Andrew MacLeod  <amacleod@redhat.com>
	PR middle-end/27793
	* tree-dfa.c (referenced_vars_dup_list): New.  List of duplicate 
	referenced_variables with matching DECL_UID's.
	(find_referenced_vars): Make sure duplicate list is empty to start.
	(add_referenced_var): Add var to duplicate list if required.
	* tree-ssa.c (delete_tree_ssa): Clear var_ann's on duplicates.
	* tree-flow.h (referenced_vars_dup_list): External declaration.

2006-08-13  Matthias Klose  <doko@debian.org>

	* doc/invoke.texi: Fix spelling errors.

2006-08-11  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/23454
	* reorg.c (relax_delay_slots): Update comment.

2006-08-11  Paolo Bonzini  <bonzini@gnu.org>

	PR target/27827
	* config/i386/i386.md: Add peephole2 to avoid "fld %st"
	instructions.

2006-08-11  Richard Guenther  <rguenther@suse.de>

	PR middle-end/28651
	* simplify-rtx.c (simplify_const_relational_operation):
	Simplify A CMP B to A - B CMP 0 only for EQ and NE comparison
	codes.

2006-08-05  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR c/27721
	* c-typeck.c (build_modify_expr): Test earlier for non-lvalues.

	PR c/28136
	* c-parser.c (c_parser_postfix_expression_after_paren_type): Robustify.

2006-08-03  Mark Mitchell  <mark@codesourcery.com>

	PR c++/28148
	* varasm.c (output_constant): Give the front end another chance to
	expand constants, after stripping NOPs.

2006-08-03  David Edelsohn  <edelsohn@gnu.org>

	Backport from mainline
	PR target/27566
	* config/rs6000/rs6000.c (rs6000_legitimize_reload_address): Do
	not reload a SPE symbol_ref into a lo_sum address.

2006-08-03  Steve Ellcey  <sje@cup.hp.com>

	PR rtl-optimization/28221
	Backport from mainline.
	2005-11-30  Nathan Sidwell  <nathan@codesourcery.com>
	* loop-doloop.c (add_test): Only add jump note if we did emit a jump.
	2006-05-01  Zdenek Dvorak  <dvorakz@suse.cz>
	PR rtl-optimization/27291
	* loop-doloop.c (add_test, doloop_modify): Handle the case condition
	is folded to a constant.

2006-08-03  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR c++/28257
	PR c++/28259
	PR c++/28267
	* toplev.c (compile_file): Return early on errorcount or sorrycount.
	* cgraphunit.c (cgraph_finalize_compilation_unit): Likewise.
	(cgraph_optimize): Likewise.

2006-08-02  Janis Johnson  <janis187@us.ibm.com>

	Backport from mainline
	* doc/sourcebuild.texi (Test Directives): Document dg-shouldfail.

2006-08-01  Steven Bosscher  <steven@gcc.gnu.org>

	PR debug/25468
	Backport from mainline
	* config/elfos.h (ASM_OUTPUT_ASCII): Remove 'register' marks.
	Cache the last found '\0' marker to avoid quadratic behavior.

2006-07-29  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/28473
	Backport from mainline
	* convert.c (convert_to_integer): When transforming (T)foo(x) into
	bar(x) check that bar's result type can represent all the values of T.
	* builtins.c (fold_fixed_mathfn): When long and long long are the
	same size, canonicalize llceil*, llfloor*, llround* and llrint*
	functions to their lceil*, lfloor*, lround* and lrint* forms.

2006-07-26  David delsohn  <edelsohn@gnu.org>

	Backport from mainline
	2006-07-14  Eliot Dresselhaus  <eliot@sonic.net>

	PR target/27287
	* config/rs6000/spe.md (frob_di_df_2): Add m->r alternative.

	2006-07-06  David Edelsohn  <edelsohn@gnu.org>

	PR target/28150
	* config/rs6000/rs6000.c (rs6000_legitimate_address): Do not allow
	PRE_{INC,DEC} of TFmode.

	2006-07-06  David Edelsohn  <edelsohn@gnu.org>
		    Alan Modra  <amodra@bigpond.net.au>

	PR target/28170
	* config/rs6000/rs6000.c (insvdi_rshift_rlwimi_p): Correct shiftop
	bounds. Simplify.

2006-07-26  Richard Sandiford  <richard@codesourcery.com>

	PR middle-end/28403
	* optabs.c (expand_doubleword_shift): Wrap the call to
	do_compare_rtx_and_jump with NO_DEFER_POP and OK_DEFER_POP.

2006-07-26  Richard Sandiford  <richard@codesourcery.com>

	PR middle-end/28402
	* optabs.c (expand_binop): Pass next_methods rather than methods
	to expand_doubleword_shift.

2006-07-25  Zdenek Dvorak <dvorakz@suse.cz>

	* tree-chrec.c (chrec_convert_aggressive): Return NULL on failure.

2006-07-24  Richard Guenther  <rguenther@suse.de>

	Backport from mainline
	2006-07-17  Zdenek Dvorak <dvorakz@suse.cz>

	* tree-chrec.c (avoid_arithmetics_in_type_p): New.
	(convert_affine_scev, chrec_convert_aggressive): Use
	avoid_arithmetics_in_type_p.  Do not check for the subtypes
	separately.

2006-07-24  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/28238
	* tree-inline.c (copy_bb): Check if we produced valid
	gimple copying and substituting a stmt.  If not, gimplify
	it.

2006-07-24  Toon Moene  <toon@moene.indiv.nluug.nl>

	* doc/invoke.texi: Remove mention of f77; Reformat table for
	inline parameter options correctly; mention that -malign-double
	is default on x86-64 targets.

2006-07-24  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/27795
	PR tree-optimization/27639
	PR tree-optimization/26719
	Backport from mainline
	2006-05-24  Zdenek Dvorak <dvorakz@suse.cz>

	* tree-vrp.c (adjust_range_with_scev): Use scev_direction and adjust
	call to scev_probably_wraps_p.
	* tree-ssa-loop-niter.c (compare_trees, convert_step_widening,
	used_in_pointer_arithmetic_p, convert_step): Removed.
	(nowrap_type_p): New function.
	(scev_probably_wraps_p): Rewritten.
	* tree-scalar-evolution.c (instantiate_parameters_1): Do not call
	chrec_convert if chrec_convert_aggressive might have been used.
	* tree-chrec.c (convert_affine_scev, chrec_convert_1,
	scev_direction): New functions.
	(chrec_convert): Changed to a wrapper over chrec_convert_1.
	* tree-ssa-loop-ivopts.c (idx_find_step): Use convert_affine_scev
	instead of convert_step.
	* tree-flow.h (scev_probably_wraps_p): Declaration changed.
	(convert_step): Declaration removed.
	(convert_affine_scev, nowrap_type_p, scev_direction): Declare.

2006-07-24  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/28029
	Backport
	2006-02-15 Daniel Berlin  <dberlin@dberlin.org>

	* tree-ssa-alias.c (get_tmt_for): Don't handle TYPE_READONLY
	specially here.

2006-07-24  Roger Sayle  <roger@eyesopen.com>

	PR target/28247
	* gthr-solaris.h: Prototype __gthrw forms of thr_self, mutex_init and
	mutex_destroy even when !_LIBOOBJC.  Remove duplicate prototype of
	the __gthrw form of thr_keycreate.
	(__gthread_key_delete): Silence the unused argument warning.

2006-07-21  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/28283
	* expmed.c (expand_shift): Additionally check that the shift_cost
	is not MAX_COST and that INTVAL(op1) is less than MAX_BITS_PER_WORD
	before implementing a LSHIFT_EXPR as a sequence of additions.
	* config/sh/sh.c (shift_costs): Return MAX_COST to inform the
	middle-end that DImode shifts need to be synthesized by expand.

2006-07-20  Richard Henderson  <rth@redhat.com>

	PR 27889
	* tree-nested.c (create_tmp_var_for): Set DECL_COMPLEX_GIMPLE_REG_P
	if needed.

2006-07-20  Paul Brook  <paul@codesourcery.com>

	Backport from mainline.
	PR 27363
	* cse.c (cse_insn): Add destination addresses to hash table. Check if
	they are invalidated by this instruction.

2006-07-18  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR c/28286
	* c-pragma.c (handle_pragma_pack): Handle invalid constants.

2006-07-18  Andrew Haley  <aph@redhat.com>

	PR tree-optimization/19505
	* tree-cfgcleanup.c (tree_forwarder_block_p): If we have an EH
	edge leaving this block, make sure that the destination of this
	block has only one predecessor.

2006-07-18  Alexandre Oliva  <aoliva@redhat.com>

	PR c/26993
	* c-common.c (handle_weakref_attribute): Ignore attribute in
	the same conditions the alias attribute is ignored.

2006-07-16  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi (sparc-sun-solaris2*): Add GMP version number.

2006-07-12  Paolo Carlini  <pcarlini@suse.de>

	PR libstdc++/27878
	* doc/install.texi (mips-sgi-irix6): Add note about IRIX 6.5.x,
	x < 19, vs wchar_t support.

2006-07-12  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/28187
	* tree-vrp.c (vrp_operand_equal_p): New function.
	(vrp_bitmap_equal_p): Likewise.
	(update_value_range): Use them to compare old and new
	max and min values.

2006-07-11  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/28162
	* fold-const.c (fold_binary): For (-A) * (-B) -> A * B
	make sure to convert the operands to the correct type.

2006-07-08  Matthias Klose  <doko@debian.org>

	* doc/sourcebuild.texi: Fix typo.

2006-07-05  Jason Merrill  <jason@redhat.com>

	PR c++/13983
	PR c++/17519
	* stor-layout.c (finish_record_layout): Copy TYPE_PACKED to variants.

2006-07-04  Paolo Bonzini  <bonzini@gnu.org>

	PR tree-optimization/28218

	* tree-ssa-math-opts.c (execute_cse_reciprocals): Fix calls
	to calculate and free the dominator information.
	    
2006-07-04  Peter O'Gorman  <peter@pogma.com>

	* mklibgcc.in: chmod 644 before ranlib during install.

2006-07-04  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/26991
	Backport from mainline
	2006-02-16  Bernd Schmidt  <bernd.schmidt@analog.com>

	PR rtl-optimization/25636
	* local-alloc.c (update_equiv_regs): Lose a bogus rtx_equal_p test
	when deciding whether an insn is an initializing insn.

2006-07-04  Alan Modra  <amodra@bigpond.net.au>

	PR target/28207
	* config/rs6000/rs6000.c (function_arg_boundary): Double-word align
	128-bit IBM long doubles for ABI_V4.

2006-07-03  Pete Steinmetz  <steinmtz@us.ibm.com>

	Backport from mainline
	* doc/invoke.texi: Add cpu_type power6.
	* config.gcc: Add cpu_type power6.
	* config/rs6000/rs6000.c (rs6000_override_options): Alias power6
	to power5+ with Altivec.
	* config/rs6000/aix52.h (ASM_CPU_SPEC): Add power6.
	* config/rs6000/rs6000.h (ASM_CPU_SPEC): Add power6.

2006-07-01  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/27428
	* c-lex.c (c_lex_with_flags) <CPP_N_INVALID>: Increment errorcount
	to indicate the cpplib has issued an error message for us.

2006-07-01  Martin Michlmayr  <tbm@cyrius.com>

	* doc/gcov.texi (Invoking Gcov): Add a missing word.

2006-06-28  Jason Merrill  <jason@redhat.com>

	PR c++/27768
	* tree-ssa-alias.c (compute_flow_insensitive_aliasing): Add
	may_aliases already in the tag's annotations to the bitmap.

2006-06-25  Eric Botcazou  <ebotcazou@adacore.com>

	PR middle-end/28151
	* fold-const.c (const_binop): Be prepared for self returning zero.
	Simplify code handling complex values.

2006-06-23  Richard Guenther  <rguenther@suse.de>

	PR middle-end/28045
	* fold-const.c (operand_equal_p): Check if the argument types
	have the same precision before stripping NOPs.

2006-06-21  Richard Henderson  <rth@redhat.com>

	PR target/26347
	PR target/27082
	* config/alpha/predicates.md (small_symbolic_operand): Deny weak
	symbols.
	(global_symbolic_operand): Allow weak symbols, even if local_p.

2006-06-21  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/27781
	* Makefile.in (ipa-pure-const.o): Add $(TARGET_H) dependency.
	* ipa-pure-const.c (target.h): Include.
	(analyze_function): Do not analyze functions that do not
	bind locally.

2006-06-21  Jakub Jelinek  <jakub@redhat.com>

	* varasm.c (mergeable_string_section): Check for embedded NULs and
	NUL termination in the first int_size_in_bytes (TREE_TYPE (decl))
	rather than TREE_STRING_LENGTH bytes.

2006-06-20  Roger Sayle  <roger@eyesopen.com>

	PR target/27861
	* expmed.c (expand_shift): On SHIFT_COUNT_TRUNCATED targets, we may
	have stripped a SUBREG from the shift count, so we may need to
	convert_to_mode back to the type's mode before calling make_tree.
	Use new_amount instead of amount to avoid expanding a tree twice.

2006-06-18  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/27802
	* reg-stack.c (subst_stack_regs): Handle noreturn function calls
	that (would) return their results in stack registers.

2006-06-16  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/27830
	* tree-inline.c (copy_body_r): For copying the operand
	of an ADDR_EXPR make sure to fold &* afterwards.

2006-06-14  Roger Sayle  <roger@eyesopen.com>

	PR target/27858
	Revert incorrect fix for PR target/27158
	2006-05-11  Roger Sayle  <roger@eyesopen.com>
	* reload.c (find_reloads_toplev): Only return the simplified SUBREG
	of a reg_equiv_constant if the result is a legitimate constant.

2006-06-14  Roger Sayle  <roger@eyesopen.com>

	PR target/27158
	* config/rs6000/rs6000.c (const_vector_elt_as_int): New function to
	extract a CONST_VECTOR element and interpret it as an integer.
	(vspltis_constant): Use const_vector_elt_as_int instead of the
	macro CONST_VECTOR_ELT in order to handle FP vector modes.
	* config/rs6000/predicates.md (easy_vector_const): Consider
	floating point ALTIVEC_VECTOR_MODEs via easy_altivec_constant.

2006-06-14  Andreas Krebbel  <krebbel1@de.ibm.com>

	PR middle-end/27959
	* reload1.c (reload): Remove registers returned by update_eliminables
	from used_spill_regs.

2005-06-13  Bernd Schmidt  <bernd.schmidt@analog.com>

	PR bootstrap/22541
	From Dan Kegel <dank@kegel.com>:
	* Makefile.in: Strip "dir/../" combinations from SYSTEM_INCLUDE_DIR.

2006-06-13  Paolo Bonzini  <bonzini@gnu.org>

	PR middle-end/27733
	* expmed.c (struct alg_hash_entry): Fix type of field T
	to match synth_mult argument.
	(NUM_ALG_HASH_ENTRIES): Make it bigger for 64-bit HOST_WIDE_INT.

2006-06-12  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR target/27421
	* config/i386/i386.c (classify_argument): Skip fields with invalid
	types in unions.

2006-06-09  Ralf Corsepius  <ralf.corsepius@rtems.org>

	* config/mips/t-rtems: Add EL/EB multilib variants.

2006-06-07  Uros Bizjak  <uros@kss-loka.si>

	PR target/27790
	* config/i386/i386.c (ix86_expand_int_vcond): Force cop0
	into register for (code == GTU).

2006-06-06  Andrew MacLeod  <amacleod@redhat.com>

	PR middle-end/27793
	* tree-dfa.c (referenced_vars_dup_list): New.  List of duplicate 
	referenced_variables with matching DECL_UID's.
	(find_referenced_vars): Make sure duplicate list is empty to start.
	(add_referenced_var): Add var to duplicate list if required.
	* tree-ssa.c (delete_tree_ssa): Clear var_ann's on duplicates.
	* tree-flow.h (referenced_vars_dup_list): External declaration.

2006-06-06  Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/27842
	* config/rs6000/altivec.md (UNSPEC_VSLW): Remove.
	("altivec_vspltisw_v4sf", "altivec_vslw_v4sf"): Remove.
	("mulv4sf3", "absv4sf3", "negv4sf3"): Adapt users to use
	V4SImode temporaries and operations instead.

2006-06-05  Roger Sayle  <roger@eyesopen.com>

	PR target/26223
	* config/i386/i386.c (construct_container): Split static issued_error
	flag into issued_sse_arg_error, issued_sse_ret_error and
	issued_x87_ret_error.  Issue a daignostic if the x86-64 ABI
	requires the use of x87 registers and the user explicitly
	specified the -mno-80387 command line option.

2006-06-05  Joseph S. Myers  <joseph@codesourcery.com>

	PR c/25161
	PR c/27020
	* c-decl.c (grokdeclarator): Disallow variably modified types at
	file scope.  Avoid marking shared array type of constant size as
	VLA.

2006-06-04  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR c++/27601
	* c-common.c (fold_offsetof_1): Handle static members.

2006-06-01  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.c (rs6000_gimplify_va_arg): Consume all
	fp regs if the last fp arg doesn't fit in regs.

2006-05-31  Jie Zhang  <jie.zhang@analog.com>

	* config/bfin/bfin.c (bfin_delegitimize_address): New.
	(TARGET_DELEGITIMIZE_ADDRESS): Define.

2006-05-30  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR c/27718
	* c-typeck.c (c_expr_sizeof_type): Handle invalid types.

2006-05-29  Diego Novillo  <dnovillo@redhat.com>

	PR 26242
	* passes.texi: Add documentation for pass_vrp,
	pass_fre, pass_store_ccp, pass_copy_prop,
	pass_store_copy_prop, pass_merge_phi, pass_nrv,
	pass_return_slot, pass_object_sizes, pass_lim,
	pass_linear_transform, pass_empty_loop, pass_complete_unroll,
	and pass_stdarg.

2006-05-29  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR c++/27451
	* stmt.c (expand_asm_operands): Skip asm statement with erroneous
	clobbers.

	PR c/26818
	* c-decl.c (finish_struct): Skip erroneous fields.

2006-05-28  Kazu Hirata  <kazu@codesourcery.com>

	PR tree-optimization/26622.
	* fold-const.c (fold_ternary) <COND_EXPR>: Call fold_convert
	on arg1.

2006-05-26  Eric Botcazou  <ebotcazou@adacore.com>

	* doc/invoke.texi (Optimize Options): Document that -funit-at-a-time
	is enabled at -O and above.

2006-05-26  Jakub Jelinek  <jakub@redhat.com>

	PR target/27758
	Backported from mainline
	2006-01-25  Andrew Pinski  <pinskia@physics.uc.edu>

	PR target/25758
	* config/i386/i386.c (output_pic_addr_const) <case SYMBOL_REF>:
	Use output_addr_const instead of assemble_name.

2006-05-26  Richard Guenther  <rguenther@suse.de>

	PR middle-end/27743
	* fold-const.c (fold_binary): Do not look at the stripped
	op0 for (a OP c1) OP c2 to a OP (c1+c2) shift optimization.

2006-05-24  Mark Mitchell  <mark@codesourcery.com>

	* DEV-PHASE: Set to prerelease.
	* BASE-VER: Increment.

2006-05-24  Release Manager

	* GCC 4.1.1 released.

2006-05-22  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/install.texi (Configuration): Remove reference to CrossGCC
	FAQ which was gone.
	(Building): Ditto.

2006-05-17  H.J. Lu  <hongjiu.lu@intel.com>

	* Makefile.in: Undo the last 2 changes.
	* optc-gen.awk: Likewise.

	* common.opt: Undo the last change.
	* doc/options.texi: Likewise.
	* gcc.c: Likewise.
	* opts.c: Likewise.
	* opts.h: Likewise.

	* opts-common.c: Removed.

2005-05-17  Bernd Schmidt  <bernd.schmidt@analog.com>

	PR middle-end/27620
	* expr.c (safe_from_p): Handle CONSTRUCTOR again.

2006-05-17  Zdenek Dvorak  <dvorakz@suse.cz>

	PR tree-optimization/27548
	* tree-scalar-evolution.c (scev_const_prop): Do not prolong life
	range of ssa names that appear on abnormal edges.
	* tree-ssa-loop-ivopts.c (contains_abnormal_ssa_name_p): Export.
	* tree-flow.h (contains_abnormal_ssa_name_p): Declare.

2006-05-17  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/27549
	Backported from mainline

	2006-05-01  Zdenek Dvorak  <dvorakz@suse.cz>

	PR tree-optimization/27283
	* tree-ssa-loop-ivopts.c (struct nfe_cache_elt): Store just trees,
	not whole # of iteration descriptions.
	(niter_for_exit): Return just # of iterations.  Fail if # of iterations
	uses abnormal ssa name.
	(niter_for_single_dom_exit): Ditto.
	(find_induction_variables, may_eliminate_iv): Expect niter_for_exit to
	return just the number of iterations.
	(add_iv_outer_candidates, may_replace_final_value): Likewise.

2006-05-16  H.J. Lu  <hongjiu.lu@intel.com>

	* Makefile.in (GCC_OBJS): Replace options.o with gcc-options.o.
	(gcc-options.o): New rule.

	* optc-gen.awk: Protect variables for gcc-options.o with
	#ifdef GCC_DRIVER/#endif.

2006-05-16  Roger Sayle  <roger@eyesopen.com>

	PR target/26600
	* config/i386/i386.c (legitimate_constant_p) <CONST_DOUBLE>: TImode
	integer constants other than zero are only legitimate on TARGET_64BIT.
	<CONST_VECTOR> Only zero vectors are legitimate.
	(ix86_cannot_force_const_mem): Integral and vector constants can
	always be put in the constant pool.

2006-05-16  Andrew MacLeod  <amacleod@redhat.com>

	PR c++/26757
	* tree-dfa.c (struct walk_state): Remove.
	(add_referenced_var): Change Parameters.
	(find_referenced_vars): Done use a walk_state.
	(find_vars_r): Unused parameter and change parms to add_referenced_var.
	(referenced_var_insert): Assert same UID has not been inserted.
	(add_referenced_var): Check if var exists via referenced_var table.
	(get_virtual_var): Call add_referenced_var with new parameter.

2006-05-16  H.J. Lu  <hongjiu.lu@intel.com>

	PR driver/26885
	* Makefile.in (GCC_OBJS): New.
	(OBJS-common): Add opts-common.o.
	(xgcc$(exeext)): Replace gcc.o with $(GCC_OBJS).
	(cpp$(exeext)): Likewise.
	(gcc.o): Also depend on opts.h.
	(opts-common.o): New.

	* common.opt (gcoff): Add Negative(gdwarf-2).
	(gdwarf-2): Add Negative(gstabs).
	(gstabs): Add Negative(gstabs+).
	(gstabs+): Add Negative(gvms).
	(gvms): Add Negative(gxcoff).
	(gxcoff): Add Negative(gxcoff+).
	(gxcoff+): Add Negative(gcoff).
	* config/i386/i386.opt (m32): Add Negative(m64).
	(m64): Add Negative(m32).

	* doc/options.texi: Document the Negative option.

	* gcc.c: Include "opts.h".
	(main): Call prune_options after expandargv.

	* optc-gen.awk: Generate common declarations for all flag
	variables in options.c. Output the neg_index field.

	* opts.c (find_opt): Moved to ...
	* opts-common.c: Here. New file.

	* opts.h (cl_option): Add a neg_index field.
	(find_opt): New.
	(prune_options): Likewise.

2006-05-16  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/27603
	* tree-ssa-loop-niter.c (infer_loop_bounds_from_undefined):
	Do computation in original type, do division only for nonzero
	steps.

2006-05-15  Andreas Krebbel  <krebbel1@de.ibm.com>

	* expmed.c (store_bit_field): Handle paradoxical subregs on big endian
	machines.

2006-05-15  Andreas Krebbel  <krebbel1@de.ibm.com>

	PR rtl-optimization/14261
	* ifcvt.c (noce_emit_move_insn): Call store_bit_field if the resulting
	move would be an INSV insn.
	(noce_process_if_block): Don't optimize if the destination is a 
	ZERO_EXTRACT which can't be handled by noce_emit_move_insn.

2006-05-15  Roger Sayle  <roger@eyesopen.com>

	PR rtl-optimization/22563
	Backports from mainline
	* expmed.c (store_fixed_bit_field): When using AND and IOR to store
	a fixed width bitfield, always force the intermediates into pseudos.
	Also check whether the bitsize is valid for the machine's "insv"
	instruction before moving the target into a pseudo for use with
	the insv.
	* config/i386/predicates.md (const8_operand): New predicate.
	* config/i386/i386.md (extv, extzv, insv): Use the new
	const8_operand predicate where appropriate.

2006-05-13  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/26729
	* fold-const.c (fold_truthop): Check integer_nonzerop instead of
	!integer_zerop to avoid problems with TREE_OVERFLOW.

2005-05-13  Zdenek Dvorak  <dvorakz@suse.cz>

	PR rtl-optimization/27335
	* loop-unroll.c (peel_loops_completely): Use loops->parray to walk the
	loops.

2006-05-12  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390/s390.c (s390_const_ok_for_constraint_p): Disallow -4G for
	On contraint.
	* config/s390/s390.md: Adjust comment describing On constraint.

2006-05-11  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR target/27421
	* config/i386/i386.c (classify_argument): Skip fields with invalid
	types.

	PR middle-end/27384
	* fold-const.c (size_binop): Move sanity check for arguments to
	the beginning of the function.

	PR middle-end/27488
	* fold-const.c (tree_expr_nonnegative_p): Return early on invalid
	expression.

2006-05-11  Roger Sayle  <roger@eyesopen.com>

	PR target/27158
	* reload.c (find_reloads_toplev): Only return the simplified SUBREG
	of a reg_equiv_constant if the result is a legitimate constant.

2006-05-09  Steve Ellcey  <sje@cup.hp.com>

	PR bootstrap/26872
	* config.gcc (hppa[12]*-*-hpux10*): Set gas to yes.
	(hppa*64*-*-hpux11*): Ditto.
	(hppa[12]*-*-hpux11*): Ditto.

2006-05-09  David Edelsohn  <edelsohn@gnu.org>

	PR target/26545
	* config/rs6000/aix41.h (TARGET_64BIT): Define.

2006-05-09  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/27136
	* tree-ssa-loop-niter.c (get_val_for): Correct function
	comment, assert requirements.
	(loop_niter_by_eval): Stop processing if the iterated
	value did not simplify.

2006-05-09  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/27409
	* tree-ssa-structalias.c (get_constraint_for_component_ref):
	Do not try to find zero-sized subvars.

2006-05-08  Alan Modra  <amodra@bigpond.net.au>

	PR middle-end/27260
	* builtins.c (expand_builtin_memset): Expand val in original mode.

2006-05-06   Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/27151
	* tree-vect-transform.c (vectorizable_condition): Punt on
	values that have a different type than the condition.

2006-05-04  David Edelsohn  <edelsohn@gnu.org>

	PR target/26481
	* config/rs6000/rs6000.md (stmsi_power): Mark clobber constraint
	with output modifier.

2006-05-04  Richard Sandiford  <richard@codesourcery.com>

	PR target/26765
	* config/mips/mips.c (mips_symbolic_address_p): Return true
	for SYMBOL_TLSGD, SYMBOL_TLSLDM, SYMBOL_DTPREL, SYMBOL_TPREL,
	SYMBOL_GOTTPREL, and SYMBOL_TLS.

2006-05-04  David Edelsohn  <edelsohn@gnu.org>

	PR target/26481
	* config/rs6000/rs6000.md (store_multiple_power): Delete.
	(stmsi[345678]_power): New.

2006-05-04  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/27285

	Backport from mainline:

	2006-03-28  Zdenek Dvorak  <dvorakz@suse.cz>

	PR tree-optimization/25985
	* tree-ssa-loop-niter.c (number_of_iterations_le,
	number_of_iterations_ne): Make comments more precise.
	(number_of_iterations_cond): Add only_exit argument.  Use the
	fact that signed variables do not overflow only when only_exit
	is true.
	(loop_only_exit_p): New.
	(number_of_iterations_exit): Pass result of loop_only_exit_p to
	number_of_iterations_cond.

2006-05-02  Jeff Law  <law@redhat.com>

	PR tree-optimization/27364
	* tree-vrp.c (vrp_int_const_binop): Fix detection of overflow from
	multiply expressions.

2006-05-02  Roger Sayle  <roger@eyesopen.com>

	PR c/25309
	* c-typeck.c (struct spelling): Make I an unsigned HOST_WIDE_INT.
	(push_array_bounds): Delete prototype.  Change BOUNDS argument to
	an unsigned HOST_WIDE_INT.
	(print_spelling): Use HOST_WIDE_INT_PRINT_UNSIGNED to output the
	array index.
	(really_start_incremental_init): No need to call convert because
	bitsize_zero_node is already of type bitsizetype.
	(push_init_level): Extract the value of constructor_index as an
	unsigned HOST_WIDE_INT quantity, using tree_low_cst.
	(process_init_element): Likewise.

2006-05-02  Kazu Hirata  <kazu@codesourcery.com>

	PR target/27387
	* arm.c (arm_output_mi_thunk): Use pc-relative addressing when
	-mthumb -fPIC are used.

2006-05-01  Kazu Hirata  <kazu@codesourcery.com>

	PR target/27374
	* config/arm/vfp.md (*arm_movdi_vfp): Correct the output
	templates for case 3 and 4.

2006-05-01  Richard Guenther  <rguenther@suse.de>

	PR middle-end/26565
	* builtins.c (get_pointer_alignment): Handle component
	references for field alignment.

2006-04-28  Richard Guenther  <rguenther@suse.de>

	PR target/26826
	* reload.c (push_reload): Guard calls to get_secondary_mem
	for memory subregs.

2006-04-28  Andrew Pinski  <pinskia@gcc.gnu.org>
	Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/27236
	* tree-inline.c (copy_body_r): Make sure to copy
	TREE_THIS_VOLATILE flag.

2006-04-28  Richard Guenther  <rguenther@suse.de>

	PR middle-end/26869
	* tree-complex.c (update_parameter_components): Don't handle
	unused parameters which have no default def.

2006-04-28  Andrew Pinski  <pinskia@gcc.gnu.org>
	Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/27218
	* tree-inline.c (expand_call_inline): Strip useless type
	conversions for the return slot address.

2006-04-27  Richard Guenther  <rguenther@suse.de>

	PR rtl-optimization/26685
	* params.def (PARAM_MAX_CSE_INSNS): Correct typo that named
	this one "max-flow-memory-locations".

2006-04-25  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/26865
	* tree-ssa-structalias.c (find_func_aliases): Check that anyoffsetrhs
	type is pointer or array type.

2006-04-24  Roger Sayle  <roger@eyesopen.com>

	PR target/26961
	* fold-const.c (fold_ternary): When converting "A ? B : C" into either
	"A op B" or "A op C", we may need to convert A to the type of B and C.

2006-04-23  Roger Sayle  <roger@eyesopen.com>

	PR target/21283
	* config/fr30/fr30.md (define_split): Avoid calling gen_lowpart on
	a SImode SUBREG of a floating point register after no_new_pseudos.

2006-04-23  Roger Sayle  <roger@eyesopen.com>

	* config/fr30/fr30.md (addsi_small_int): Use REGNO_PTR_FRAME_P to
	identify potentially eliminable registers to additionally catch
	VIRTUAL_INCOMING_ARGS_REGNUM.
	(addsi3): Update the conditions on when to use addsi_small_int.

2006-04-23  Eric Botcazou  <ebotcazou@adacore.com>

	* tree-tailcall.c (pass_tail_recursion): Use gate_tail_calls too.

2006-04-21  Carlos O'Donell  <carlos@codesourcery.com>
	
	Backport from mainline:
	2006-04-19  Carlos O'Donell  <carlos@codesourcery.com>
		    Nathan Sidwell  <nathan@codesourcery.com>
	PR c/26774
	* stor-layout.c (update_alignment_for_field): Do not align 
	ERROR_MARK nodes.
	(place_union_field): Place union field at the start of the union.
	(place_field): Move ERROR_MARK check later, and use the current
	allocation position to maintain monotonicity.

2006-04-21  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR c/25875
	* c-typeck.c (digest_init): Robustify.

2006-04-21  Steve Ellcey  <sje@cup.hp.com>

	* config/pa/t-pa64: Add dependencies on $(GCC_PASSES).

2006-04-21  Paul Brook  <paul@codesourcery.com>

	Backport from mainline.
	* config/arm/arm.c (arm_override_options): Error on iWMMXt and
	hardware floating point.

2006-04-20  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR mudflap/26789
	* tree-mudflap.c (mudflap_finish_file): Skip function when there were
	errors.

2006-04-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/27182
	* config/sh/sh.md (movsicc_true+3): Tweak condition for the case
	that the last insn has the REG_INC note.

2006-04-19  Jeff Law  <law@redhat.com>

	PR tree-optimization/26854
	* tree-ssa-dse.c (dse_optimize_stmt): Use has_single_use rather
	than num_imm_uses.
	* tree-ssa-dom.c (simplify_rhs_and_lookup_avail_expr): Similarly.

2006-04-18  Jeff Law  <law@redhat.com>

	PR tree-optimization/27087
	* tree-ssa-copy.c (may_propagate_copy): Test flow sensitive
	alias information too.

2006-04-18  Andreas Krebbel  <krebbel1@de.ibm.com>

	* builtins.c (expand_builtin_strcmp): Cover label definition of 
	do_libcall with HAVE_cmpstrnsi.

2006-04-18  Paolo Bonzini  <bonzini@gnu.org>

	PR tree-optimization/26643

	Backport from mainline:
	2006-03-29  Zdenek Dvorak <dvorakz@suse.cz>

	PR tree-optimization/26643
	* tree-ssa-loop-ivopts.c (find_interesting_uses_address): Do not handle
	bit_field_refs.

2006-04-18  Paolo Bonzini  <bonzini@gnu.org>

	PR tree-optimization/26821

	Backport from mainline:

	2006-04-18  Paolo Bonzini  <bonzini@gnu.org>

	PR tree-optimization/26821
	* tree-ssa-math-opts.c (get_constant_one): New.
	(insert_reciprocals): Use it.

	2006-02-02  Paolo Bonzini  <bonzini@gnu.org>
	    
	* tree-flow-inline.h (bsi_after_labels): Rewrite, return
	what its name says.
	* lambda-code.c (perfect_nestify): Use bsi_insert_before on
	bsi_after_labels iterator.
	* tree-if-conv.c (find_phi_replacement_condition,
	replace_phi_with_cond_modify_expr): Likewise.
	* tree-scalar-evolution.c (scev_const_prop): Likewise.
	* tree-ssa-loop-ivopts.c (compute_phi_arg_on_exit): Likewise.   

2006-04-18  Alan Modra  <amodra@bigpond.net.au>

	PR middle-end/27095
	* builtins.c (expand_builtin_memset): Stabilize args before expansion
	and emit libcall here in case the builtin fails.
	(expand_builtin_strcmp): Always emit the libcall here on failure.

2006-04-16  Uros Bizjak  <uros@kss-loka.si>

	PR middle-end/27134
	* builtins.c (expand_builtin_int_roundingfn): Use expand_expr()
	to expand fallback builtin function call.

2006-04-14  Alexey Starovoytov  <alexey.starovoytov@sun.com>
	    Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c (emit_and_preserve): Allocate space for the
	register save area.

2006-04-13  Paolo Bonzini  <bonzini@gnu.org>
	    Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/27006
	* config/rs6000/rs6000.h (EASY_VECTOR_15_ADD_SELF): Require n
	to be even.

2006-04-13  Alan Modra  <amodra@bigpond.net.au>

	PR target/26459
	* config/rs6000/rs6000.c (rs6000_legitimize_reload_address): Don't
	optimize to lo_sum for DFmode if !TARGET_FPRS.

2006-04-07  Jan Hubicka  <jh@suse.cz>

	* ipa-inline.c (cgraph_early_inlining): Collect garbage.

2006-04-11  Mark Mitchell  <mark@codesourcery.com>

	PR target/26459
	* config/rs6000/e500-double.h (SUB3TARGET_OVERRIDE_OPTIONS): Test
	rs6000_explicit_options.float_gprs.

2006-04-10  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi (*-*-solaris2*): Point to the configure page.

2006-04-10  Jakub Jelinek  <jakub@redhat.com>

	PR debug/27057
	* dwarf2out.c (is_symbol_die): Return true also for namespaces.

2006-04-09  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/26508
	* config.gcc (hppa*64*-*-hpux11*): Add 'libgcc_stub.a' to extra_parts.
	* pa64-hpux.h (LIB_SPEC): Don't append milli.a.
	(LINK_GCC_C_SEQUENCE_SPEC): Define.  Append milli.a here.
	(PA_CXA_FINALIZE_STUB, PA_JV_REGISTERCLASSES_STUB): Delete defines.
	(PA_INIT_FINI_HACK): Rename to PA_CRTBEGIN_HACK.
	(PA_CRTBEGIN_HACK): Ensure __do_global_ctors_aux is placed in text
	section.  Delete PA_CXA_FINALIZE_STUB and PA_JV_REGISTERCLASSES_STUB
	stubs.  Add ".align 8" directives before all ".dword" directives.
	(GTHREAD_USE_WEAK): Revise comment.
	(TARGET_ATTRIBUTE_WEAK): Define.
	* pa/t-pa64 (LIBGCCSTUB_OBJS): Add new rules for stublib.c, rfi-stub.o,
	dfi-stub.o, cxaf-stub.o and jvrc-stub.o.
	* stublib.c: New file.

2006-04-09  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/install.texi (Prerequisites): Refine some wording on
	bootstrapping and ksh.
	Move the version numbers of DejaGnu here from the testing section
	and fix casing of names.
	Fix markup and clarify wording for autogen requirements.
	Refer to GCJ instead of just java.
	Refer to SVN instead of CVS.
	Describe diffutils as useful instead of necessary.
	(Downloading the source): Refer to SVN instead of CVS.
	Adjust a link to our web site accordingly.
	(Configuration): Fix casing of Bison.
	(Specific): Avoid reference to CVS.
	(Building): Refer to SVN instead of CVS.  
	Fix a sentence on the use of Bison and remove duplicate (and
	incorrect) version number of Bison requirement.

2006-04-08  Matthias Klose  <doko@debian.org>

	* Makefile.in (unprotoize.o): Same dependencies as for protoize.o.

2006-04-07  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/26919
	* ipa-inline.c (cgraph_decide_inlining_incrementally): Fix argument
	to cgraph_estimate_size_after_inlining.

2006-04-05  Sebastian Pop  <pop@cri.ensmp.fr>

	PR tree-optimization/26996
	* tree-scalar-evolution.c (analyze_scalar_evolution_1): Don't analyze
	VECTOR_TYPE variables.

2006-04-05  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/26763
	* fold-const.c (fold_binary): Fold PTR + CST CMP PTR + CST
	only for EQ_EXPR and NE_EXPR.

2006-04-04  Paul Brook  <paul@codesourcery.com>

	Backport form mainline.
	2006-01-14  Zdenek Dvorak <dvorakz@suse.cz>
	* tree-ssa-loop-niter.c (number_of_iterations_cond): Split into several
	functions.
	(number_of_iterations_ne, number_of_iterations_lt_to_ne,
	assert_no_overflow_lt, assert_loop_rolls_lt, number_of_iterations_lt,
	number_of_iterations_le): New functions.
	(number_of_iterations_special): Removed.
	(number_of_iterations_exit): Do not use number_of_iterations_special.
	* tree.c (unsigned_type_for): Always return integer type.

	2005-01-06  Zdenek Dvorak <dvorakz@suse.cz>
	PR tree-optimization/18527
	* tree-ssa-loop-niter.c (number_of_iterations_cond,
	number_of_iterations_special, number_of_iterations_exit):
	Move base and step of an iv to a single structure.  Add
	no_overflow flag, and use it in # of iterations analysis.
	* tree-scalar-evolution.c (analyze_scalar_evolution_in_loop): Add
	folded_casts argument.
	(simple_iv): Pass base and step in a structure.  Set no_overflow
	flag.
	(scev_const_prop): Add argument to analyze_scalar_evolution_in_loop.
	Evaluate expensiveness of computing # of iterations instead of
	the final expression.
	* tree-scalar-evolution.h (affine_iv): New structure.
	(simple_iv): Declaration changed.
	* tree-chrec.c (chrec_apply): Handle chrecs containing symbols.
	* tree-ssa-loop-ivopts.c (determine_biv_step, find_givs_in_stmt_scev,
	find_givs_in_stmt): Changed due to simple_iv change.

2006-04-03  Paolo Bonzini  <bonzini@gnu.org>

	PR tree-optimization/26830
	* tree-cfg.c (tree_duplicate_sese_region): Do not update SSA.
	* tree-ssa-loop-ch.c (copy_loop_headers): Count successfully duplicated
	headers and, if there was any, update SSA at the end.
	
	Backport from mainline:
	2006-03-30  Paolo Bonzini  <bonzini@gnu.org>

	* tree-ssa-copy.c (copy_prop_visit_assignment): Do not check loop depth.
	(copy_prop_visit_stmt): Remove write-only variable ann.
	(init_copy_prop): Check variable loop depth here.  Do not simulate
	memory-tag and virtual operand PHIs except for store copy prop.


2006-03-31  H.J. Lu  <hongjiu.lu@intel.com>

	PR testsuite/25741
	Backport from mainline
	2006-01-16  H.J. Lu  <hongjiu.lu@intel.com>

	* Makefile.in (check-%): Depend on site.exp instead of
	$(TESTSUITEDIR)/site.exp. Run "runtest" in separate language
	directories.

	2006-01-17  Shantonu Sen  <ssen@opendarwin.org>

	* Makefile.in (check-%, check-consistency): Use $${srcdir}
	instead of $(srcdir) and ${srcdir}.

2006-03-31  Richard Guenther  <rguenther@suse.de>

	PR bootstrap/26936
	Backport from mainline.
	2006-02-25  Juergen Weigert  <jw@suse.de>
		Richard Guenther  <rguenther@suse.de>
 
	* scan-decls.c (scan_decls): Don't fetch new statement after CPP_EOF.

2006-03-31  Alan Modra  <amodra@bigpond.net.au>

	PR target/26459
	* config/rs6000/rs6000.h (CANNOT_CHANGE_MODE_CLASS): Limit 2003-12-08
	change to FLOAT_REGS.

	* config/rs6000/rs6000.c (rs6000_explicit_options): Add ieee.
	(rs6000_override_options): Use it.
	(rs6000_handle_option): Set it.  Set rs6000_explicit_options.abi
	only for -mabi=spe/no-spe and -mabi=altivec.

2006-03-30  Jie Zhang  <jie.zhang@analog.com>

	* config/bfin/bfin.c (single_move_for_strmov): Renamed to...
	(single_move_for_movmem): ... this. Also change all uses.
	(bfin_expand_strmov): Renamed to...
	(bfin_expand_movmem): ... this. Also change all uses.
	* config/bfin/bfin.md (movstrsi): Renamed to...
	(movstrsi): ...this.

2006-03-28  Daniel Berlin  <dberlin@dberlin.org>

	* tree-ssa-alias.c (create_sft): Initially inherit TREE_ADDRESSABLE
	from parent_var.

2006-03-27  Alan Modra  <amodra@bigpond.net.au>

	PR target/26459
	* config/rs6000/rs6000.md (DF reg move peephole): Prevent
	peephole removing spe frob_di_df_2.

2006-03-24  Alan Modra  <amodra@bigpond.net.au>

	PR target/26607
	* config/rs6000/darwin-ldouble.c: Don't compile when __NO_FPRS__
	or __LITTLE_ENDIAN__.

2006-03-23  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_legitimate_constant_p): Reject
	tls symbols.

	PR target/26347
	* config/alpha/predicates.md (local_symbolic_operand): Reject
	weak symbols.

2006-03-22  Jie Zhang  <jie.zhang@analog.com>

	* config/bfin/bfin.h (ASM_FORMAT_PRIVATE_NAME): Remove.

2006-03-21  Jason Merrill  <jason@redhat.com>

	* builtins.c (expand_builtin_fork_or_exec): Fix pasto.

	PR middle-end/20297
	* expr.c (init_block_move_fn): Force default visibility.
	(init_block_clear_fn): Likewise.
	* builtins.c (expand_builtin_fork_or_exec): Likewise.
	* targhooks.c (default_external_stack_protect_fail): Likewise.

2006-03-16  David Edelsohn  <edelsohn@gnu.org>

	Backport from mainline.
	* config/rs6000/rs6000.c (rs6000_init_builtins): Change
	decl libname for clog to __clog on AIX.

2006-03-16  Steve Ellcey  <sje@cup.hp.com>

	PR target/25917
	Backport from mainline.
	* config/ia64/predicates.md (extr_len_operand): New predicate.
	* config/ia64/ia64.md (extv): Tighten constraints.
	(extzv): Ditto.
	(*tbit_and_2): Ditto.
	(*tbit_and_3): Ditto.
	(*tbit_or_2): Ditto.
	(*tbit_or_3): Ditto.
	(*bit_zero): Ditto.
	(*bit_one): Ditto.

2006-03-16  Paul Brook  <paul@codesourcery.com>

	Backport from mainline.
	* config/arm/arm.c (minipool_pad): New.
	(add_minipool_forward_ref): Include pool alignment padding in address
	calculation.
	(push_minipool_fix): Set minipool_pad.
	(minipool_pad): Ditto.

2006-03-14  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/19543
	Backport from mainline.
	* varasm.c (compare_constant) <INTEGER_CST>: Integer constants are
	only equivalent if the have both the same mode and precision.

2006-03-14  Roger Sayle  <roger@eyesopen.com>

	PR other/26489
	Backport from mainline.
	* gthr-posix.h (__gthrw2): Define to take three parameters, the
	declared name, the weak reference name, and the typeof name.
	(__gthrw): Avoid expanding the declared name suffix.
	(__gthrw3): New Tru64 specific macro to simplify the OSF/1 decls.

2006-03-14  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/26557
	* stmt.c (emit_case_nodes): Handle the case where the index is a
	CONST_INT, where the comparison mode is specified by the index type.

2006-03-14  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa/pa32-linux.h (CRT_CALL_STATIC_FUNCTION): Fix typo.

2006-03-14  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/26672
	* tree-ssa-propagate.c (set_rhs): Don't walk DEFs if not in
	SSA form.

2006-03-13  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa/pa32-linux.h (CRT_CALL_STATIC_FUNCTION): Define when CRTSTUFFS_O
	is defined.

2006-03-13  Jie Zhang  <jie.zhang@analog.com>

	* config/bfin/uclinux.h: Define _GNU_SOURCE in CPLUSPLUS_CPP_SPEC.

2006-03-13  Bernd Schmidt  <bernd.schmidt@analog.com>

	* config/bfin/lib1funcs.asm (___umodsi3): Use stack to save contents
	of RETS.
	* config/bfin/bfin.h (TARGET_CPU_CPP_BUILTINS): If
	TARGET_ID_SHARED_LIBRARY, define __ID_SHARED_LIB__.
	* config/bfin/crti.S: Use it instead of __PIC__.
	* config/bfin/crtn.S: Likewise.

	* config/bfin/bfin.md (call_value_symbol, sibcall_value_symbol,
	call_symbol, sibcall_symbol): Disallow if TARGET_ID_SHARED_LIBRARY,
	not if flag_pic.
	Lose 'G' modifier for call operand.
	* config/bfin/bfin.c (print_operand) <case SYMBOL_REF>: Don't
	recognize 'G' modifier.

2006-03-13  Eric Botcazou  <ebotcazou@adacore.com>

	PR middle-end/18859
	* stmt.c (expand_case): Discard empty ranges.

2006-03-10  Jason Merrill  <jason@redhat.com>

	PR c/26004
	* gimplify.c (gimplify_modify_expr_rhs): Don't do return slot opt if 
	the target was declared 'register'.

2006-03-09  Roger Sayle  <roger@eyesopen.com>

	PR tree-optimization/26524
	* tree-scalar-evolution.c (interpret_rhs_modify_expr): Use
	fold_convert to create a constant of the appropriate type.

2006-03-07  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/26587
	* tree-ssa-structalias.c (handle_ptr_arith): Handle MINUS_EXPR.

2006-03-03  Steve Ellcey  <sje@cup.hp.com>

	PR rtl-optimization/26345
	PR target/19061
	* config/ia64/predicates.md (basereg_operand): Don't look in subregs.

2006-03-02  Alan Modra  <amodra@bigpond.net.au>

	PR target/26453
	* config/rs6000/rs6000.c (rs6000_output_function_epilogue): Don't
	output traceback table for thunks.  Localise rs6000_stack_info call.

2006-02-28  David Edelsohn  <edelsohn@gnu.org>

	* doc/install.texi: Require GNU tar version 1.14.

2006-02-28  Mark Mitchell  <mark@codesourcery.com>

	* BASE-VER: 4.1.1.
	* DEV-PHASE: Prerelease.

2006-02-28  Release Manager

	* GCC 4.1.0 released.

2006-02-23  Mark Mitchell  <mark@codesourcery.com>

	Backport:
	2006-02-20  Roger Sayle  <roger@eyesopen.com>
	* gthr-posix.h: On Tru64, map __gthr_foo as a weak reference to
	__foo and not foo when _PTHREAD_USE_MANGLED_NAMES_ is defined.

2006-02-23  Mark Mitchell  <mark@codesourcery.com>

	Backport:
	2006-02-21  Jakub Jelinek  <jakub@redhat.com>
	PR middle-end/26379
	* combine.c (simplify_shift_const_1): Disable nested shifts
	optimization for vector shifts.

2006-02-23  Mark Mitchell  <mark@codesourcery.com>

	Backport:
	2006-02-16  Denis Nagorny <denis_nagorny@linux.intel.com>
	PR rtl-optimization/25603
	* reload.c (reg_inc_found_and_valid_p): New. Check REG_INC note.
	(regno_clobbered_p): Use it. Reusing SETS argument for REG_INC case.
	* reload1.c (choose_reload_regs): Added call of regno_clobbered_p 
	with new meaning of SETS.

2006-02-19  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* doc/install.texi: Add missing `@samp'.

2006-02-19  David Edelsohn  <edelsohn@gnu.org>

	PR target/26350
	* config/rs6000/rs6000.md (extenddftf2): Force 0.0 to validized
	MEM for ABI_V4 pic.

2006-02-18  Mark Wielaard  <mark@klomp.org>

	* doc/contrib.texi (Contributors): Add classpath/libgcj hackers
	who added new 4.1 features, bug fixes and integration support.

2006-02-18  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* doc/install.texi (hppa*-hp-hpux*): Update for 4.1.0.

2006-02-18  Olivier Hainque  <hainque@adacore.com>

	PR ada/13408
	* pa.h (WIDEST_HARDWARE_FP_SIZE): Define.

2006-02-18  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/26334
	* stmt.c (decl_overlaps_hard_reg_set_p): Use DECL_HARD_REGISTER
	instead of DECL_REGISTER.

2006-02-17  Roger Sayle  <roger@eyesopen.com>
	    Richard Sandiford  <richard@codesourcery.com>

	PR target/22209
	* config/mips/mips.h (MIN_UNITS_PER_WORD): Don't define for libgcc.
	* config/mips/_tilib.c: Remove.
	* config/fixtfdi.c: New libgcc source file.
	* config/fixunstfdi.c: New source file.
	* config/floatditf.c: New source file.
	* config/floatunditf.c: New souce file.
	* config/mips/t-iris6 (LIB2FUNCS_EXTRA): Include the new source
	files above instead of config/mips/_tilib.c.
	* config/mips/t-linux64 (LIB2FUNCS_EXTRA): Likewise.

2006-02-17  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/26300
	* combine.c (make_extraction): Bail out if ORIG_POS is negative.

2005-02-16  Zdenek Dvorak  <dvorakz@suse.cz>

	PR tree-optimization/26209
	* tree-ssa-loop.c (pass_scev_cprop): Add TODO_cleanup_cfg.
	* tree-cfgcleanup.c (cleanup_control_flow): Remove dead
	eh edges.
	* tree-cfg.c (replace_uses_by): Do not alter cfg.

	* tree-cfgcleanup.c (cleanup_tree_cfg_loop): Call scev_reset if cfg
	changes.
	* Makefile.in (tree-cfgcleanup.o): Add SCEV_H dependency.

2006-02-15  J"orn Rennecke <joern.rennecke@st.com>

	PR middle-end/25335
	* reload1.c (gen_reload): Also use find_replacement in UNARY_P case.

2006-02-15  Hans-Peter Nilsson  <hp@axis.com>

	PR target/23424
	* config/cris/predicates.md ("cris_bdap_sign_extend_operand"):
	Reenable.

2006-02-14  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/26255
	* pa.md: Create separate HI and QI move patterns for 32-bit and 64-bit
	with hardware float support, and software float support.  Add fcpy
	alternative to hardware patterns.  Add alternatives to copy between
	general and floating-point registers to the 32-bit pattern.
	* pa32-regs.h (VALID_FP_MODE_P): Allow QImode and HImode.
	* pa64-regs.h (VALID_FP_MODE_P): Likewise.

2006-02-14  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	PR bootstrap/26053
	* configure.ac (HAVE_COMDAT_GROUP): Don't assume non-GNU linkers
	support COMDAT group.
	* configure: Regenerate.

2006-02-14  Michael Matz  <matz@suse.de>

	PR middle-end/22275

	* stor-layout.c (layout_decl): Zero-width bitfields aren't
	influenced by maximum_field_alignment or DECL_PACKED.
	(update_alignment_for_field): Ditto.
	(place_field): Ditto.
	* doc/extend.texi (<#pragma pack>, <Type Attributes>): Document
	this behaviour.

2006-02-14  Michael Matz  <matz@suse.de>

	* tree-ssa-structalias.c: Include <params.h>.
	* Makefile.in (tree-ssa-structalias.o): Adjust dependencies.

2006-02-14  Daniel Berlin  <dberlin@dberlin.org>

	Fix PR tree-optimization/26260

	* doc/invoke.texi (max-fields-for-field-sensitive): Document
	param.
	* params.h (MAX_FIELDS_FOR_FIELD_SENSITIVE): New.
	* params.def (PARAM_MAX_FIELDS_FOR_FIELD_SENSITIVE): Ditto.
	* tree-ssa-structalias.c (create_variable_info_for): Use
	MAX_FIELDS_FOR_FIELD_SENSITIVE.
	
2006-02-14  J"orn Rennecke <joern.rennecke@st.com>

	PR target/26141
	* sh.c (sh_gimplify_va_arg_expr): Don't change the result type when
	computing the effective result type.

2006-02-14  J"orn Rennecke <joern.rennecke@st.com>

	PR inline-asm/16194
	* tree.h (decl_overlaps_hard_reg_set_p) Don't declare.
	(tree_overlaps_hard_reg_set): Declare.
	* stmt.c (decl_overlaps_hard_reg_set_p): Now static.  Change return
	type and signature to match function type expected by walk_tree.
	(tree_overlaps_hard_reg_set): New function.
	(decl_conflicts_with_clobbers_p): Rename to:
	(tree_conflicts_with_clobbers_p).  Take HARD_REG_SET * argument.
	Use tree_overlaps_hard_reg_set.  Changed caller.
	* doc/tm.texi (TARGET_MD_ASM_CLOBBERS): Replace
	decl_overlaps_hard_reg_set_p with tree_overlaps_hard_reg_set.
	* cris.c (cris_md_asm_clobbers): Likewise.

2006-02-14  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/26258
	* tree-ssa-structalias.c (find_func_aliases): Handle aggregates
	in PHI argument processing.

2006-02-13  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa/quadlib.c: Use defines instead of enum qfcmp_magic.

2006-02-13  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/26092
	* gimplify.c (gimplify_call_expr): Don't call get_callee_fndecl
	twice if decl is a builtin.  When trying again, call get_callee_fndecl
	first to verify it is still a builtin.

2006-02-11  Jason Merrill  <jason@redhat.com>

	PR tree-opt/24365
	* tree-inline.c (declare_return_variable): Just don't use the
	modify target if it's a gimple complex reg and the return slot
	isn't.

2006-02-11  David Edelsohn  <edelsohn@gnu.org>

	* doc/invoke.texi (xl-compat): Document conversion and support
	routine names.

2006-02-11  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* doc/contrib.texi: Update my entry.

2006-02-11  Jakub Jelinek  <jakub@redhat.com>

	PR target/25864
	Backport from mainline

	2006-02-06  Aldy Hernandez  <aldyh@redhat.com>

	* config/s390/s390.c (TARGET_MANGLE_FUNDAMENTAL_TYPE): Define.
	(s390_mangle_fundamental_type): New.
	* config/s390/linux.h (TARGET_ALTERNATE_LONG_DOUBLE_MANGLING):
	Define.

	* config/alpha/alpha.c (TARGET_MANGLE_FUNDAMENTAL_TYPE): Define.
	(alpha_mangle_fundamental_type): New.
	* config/alpha/linux.h (TARGET_ALTERNATE_LONG_DOUBLE_MANGLING):
	Define.

	* config/sparc/linux.h (TARGET_ALTERNATE_LONG_DOUBLE_MANGLING):
	Define.
	* config/sparc/linux64.h (TARGET_ALTERNATE_LONG_DOUBLE_MANGLING):
	Define.
	* config/sparc/sparc.c (TARGET_MANGLE_FUNDAMENTAL_TYPE): Define.
	(sparc_mangle_fundamental_type): New.

2006-02-10  Jakub Jelinek  <jakub@redhat.com>

	PR target/25864
	Backport from mainline

	2006-02-04  David Edelsohn  <edelsohn@gnu.org>
		    Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/rs6000.c (rs6000_mangle_fundamental_type): Mangle
	IBM extended float format long double as "g" on powerpc*-linux.

	2006-02-01  Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/sysv4.h (SUBTARGET_OVERRIDE_OPTIONS): For
	-msoft-float -mlong-double-128 only issue a warning, but don't
	swich to DFmode long double.

	2006-01-28  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/aix43.h (SUBTARGET_OVERRIDE_OPTIONS): -msoft-float
	and -mlong-double-128 are incompatible.
	* config/rs6000/aix52.h (SUBTARGET_OVERRIDE_OPTIONS): Same.
	* config/rs6000/t-aix43 (LIB2FUNCS_EXTRA): Add ppc64-fp.c.
	(TARGET_LIBGCC2_CFLAGS): Define.
	* config/rs6000/t-aix52 (LIB2FUNCS_EXTRA): Same.
	(TARGET_LIBGCC2_CFLAGS): Same.
	* config/rs6000/ppc64-fp.c: Compile for 64-bit AIX.

	2006-01-27  Jakub Jelinek  <jakub@redhat.com>

	* libgcc-std.ver: Add GCC_4.1.0 symbol version.
	* config/rs6000/t-linux64 (TARGET_LIBGCC2_CFLAGS): Only append
	-mno-minimal-toc to previous content.
	(bispecs): Remove goal.
	* config/rs6000/ppc64-fp.c: Define TMODES before including fp-bit.h.
	* config/rs6000/darwin-ldouble.c: Don't provide _xlq*@GCC_3.4
	compatibility aliases on powerpc-*-*gnu*.
	* config/rs6000/libgcc-ppc-glibc.ver: New file.
	* config/rs6000/t-ppccomm (SHLIB_MAPFILES): Append
	libgcc-ppc-glibc.ver on powerpc*-*-*gnu*.
	(TARGET_LIBGCC2_CFLAGS): Append -specs=ldblspecs.
	(ldblspecs): New goal.
	* config/rs6000/t-linux64 (SHLIB_MAPFILES): Removed.
	* mklibgcc.in: If $TPBIT is empty, don't compile _sf_to_tf and
	_df_to_tf.
	* config/fp-bit.h (TMODES): Don't define if none of TFLOAT,
	L_sf_to_tf or L_df_to_tf is defined.

	2006-01-27  David Edelsohn  <edelsohn@gnu.org>
		    Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/linux.h (POWERPC_LINUX): Define.
	* config/rs6000/linux64.h (POWERPC_LINUX): Define.
	* config/rs6000/darwin-ldouble.c: Build on 32-bit PowerPC.
	* config/rs6000/darwin.h (TARGET_IEEEQUAD): Define to zero.
	* config/rs6000/aix.h (TARGET_IEEEQUAD): Define to zero.
	* config/rs6000/rs6000.c (rs6000_ieeequad): New variable.
	(rs6000_override_options): Initialize rs6000_ieeequad.
	Initialize TFmode format to ibm_extended_format if not
	TARGET_IEEEQUAD.
	(rs6000_handle_option): Accept -mabi= ibmlongdouble and
	ieeelongdouble.
	(rs6000_emit_move): Move !TARGET_IEEEQUAD as two parts.
	(rs6000_return_in_memory): Only return IEEEQUAD in memory.
	(function_arg_advance): IBM long double passed in two FPRs, not
	split.
	(function_arg): IBM long double passed in FPRs.
	(rs6000_pass_by_reference): Only IEEEQUAD passed by reference.
	(rs6000_gimplify_va_arg): IBM long double passed in two FPRs.
	Only multireg GPR aligned.
	(rs6000_init_libfuncs): Enable IBM long double functions if not
	IEEEQUAD.
	(rs6000_generate_compare): Use IBM long double compare if not
	TARGET_IEEEQUAD.
	* config/rs6000/rs6000.h (rs6000_ieeequad): Declare.
	(TARGET_IEEEQUAD): Define.
	(CANNOT_CHANGE_MODE_CLASS): Any mode larger than doubleword if
	not TARGET_IEEEQUAD.
	* config/rs6000/rs6000.md: Enable TFmode patterns if
	!TARGET_IEEEQUAD.
	* config/rs6000/t-ppccomm (LIB2FUNCS_EXTRA): Add darwin-ldouble.c.
	* config/rs6000/svr4.h (SUBTARGET_OVERRIDE_OPTIONS): -msoft-float
	and -mlong-double-128 are incompatible.
	* doc/invoke.texi (-mabi): Collect options together.  Add
	ibmlongdouble and ieeelongdouble.

2006-02-08  Jason Merrill  <jason@redhat.com>

	PR c++/25979
	* tree.def: Elaborate on difference from MODIFY_EXPR.
	* doc/c-tree.texi (INIT_EXPR): Likewise.
	* gimplify.c (internal_get_tmp_var): Use INIT_EXPR.
	(gimplify_decl_expr, gimplify_init_ctor_eval): Likewise.
	(gimplify_target_expr): Likewise.
	(gimplify_cond_expr): Remove target handling.
	(gimplify_modify_expr): Don't clobber INIT_EXPR code here.
	(gimplify_expr): Clobber it here.
	(gimplify_modify_expr_rhs): Push assignment into COND_EXPR here.
	Do return slot optimization if we have an INIT_EXPR.

	PR tree-opt/24365
	* tree-inline.c (declare_return_variable): Also clear 
	DECL_COMPLEX_GIMPLE_REG_P as needed in the modify_dest case.

	PR c++/16405
	* gimplify.c (gimplify_modify_expr_rhs): Re-enable *& handling.

	PR middle-end/22439
	* gimplify.c (gimplify_one_sizepos): Fix typo.

2006-02-09  Andrew Pinski  <pinskia@physics.uc.edu>

	PR tree-opt/25251
	* tree-cfg.c (cleanup_dead_labels): Also don't remove
	forced labels.

2006-02-09  Andrew Pinski  <pinskia@physics.uc.edu>

	* tree-flow-inline.h (var_can_have_subvars): 
	Volatile variables should not have subvariables.

2006-02-09  Diego Novillo  <dnovillo@redhat.com>

	PR 26180
	* tree-vrp.c (vrp_int_const_binop): Detect overflow when
	multiplying unsigned values.
	Tidy comments.

2006-02-09  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c (tls_call_delay): Fix oversight.

2006-02-07  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/26109
	* pa.c (attr_length_indirect_call): Don't return length 8 for distances
	>= 240000 when generating code for SOM runtime.
	(output_indirect_call): Don't use "b,l" instruction for indirect calls
	to $$dyncall when generating code for SOM runtime..

2006-02-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sol26.h (CPP_SUBTARGET_SPEC): Accept -pthread.
	* config/sol2.h (CPP_SUBTARGET_SPEC): Likewise.
	(LIB_SPEC): Likewise.
	* doc/invoke.texi (SPARC options): Document -pthread.

2006-02-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* configure.ac (TLS assembler check): Do not enable TLS by
	default on SPARC/Solaris before version 10.
	* configure: Regenerate.

2006-02-07  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/24444
	* config/ia64/unwind-ia64.c: Revert last change.
	* config/ia64/ia64.h (ARG_POINTER_CFA_OFFSET): Removed.
	(INCOMING_FRAME_SP_OFFSET): Define.

2006-02-06  Andreas Tobler  <a.tobler@schweiz.ch>

	* config/sparc/freebsd.h (ENDFILE_SPEC): Add space to separate
	object files.

2006-02-06  Andrew Pinski  <pinskia@physics.uc.edu>

	PR target/23359
	* config/i386/i386.md (trap): Use ASM_SHORT instead of .word.

2006-02-06  Jakub Jelinek  <jakub@redhat.com>

	* config.gcc (s390-*-linux*): Add s390/t-linux to tmake_file.
	(s390x-*-linux*): Likewise.
	* config/s390/t-linux64 (SHLIB_MAPFILES): Removed.
	* config/s390/t-linux: New file.

2006-02-05  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sol2-bi.h (SPARC_DEFAULT_CMODEL): Set to CM_MEDMID.

2006-02-05  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa/x-ada-hpux10, pa/t-pa-hpux10, pa/t-pa-hpux11: New files.
	* config.gcc (hppa[12]*-*-hpux10*): Use pa/t-pa-hpux10 instead of
	pa/t-pa.
	* config.gcc (hppa[12]*-*-hpux11*): Use pa/t-pa-hpux11 instead of
	pa/t-pa.
	* config.host (hppa*-*-hpux10*): Use pa/x-ada-hpux10 instead of
	pa/x-ada.
	* pa/t-pa-hpux: Add lib2funcs.asm and quadlib.c rules.
	* pa/t-pa64: Delete quadlib.c rule.
	* pa/x-ada: Revert last change.
	* pa/t-pa: Revert last change.  Delete quadlib.c rule.

2006-02-04  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/24444
	* config/ia64/ia64.c: Include debug.h.
	(MAX_ARTIFICIAL_LABEL_BYTES): New.
	(ia64_label_after_insn, ia64_dwarf2out_def_steady_cfa): New.
	(IA64_CHANGE_CFA_IN_EPILOGUE): Define to 0.
	(process_epilogue, process_set, process_for_unwind_directive):
	Output unwind info only if requested.  Add CFA info if requested.
	Add new arguments as needed.  Adjust callers.
	* config/ia64/ia64.h (ARG_POINTER_CFA_OFFSET): Override
	incorrect default.
	(DWARF2_FRAME_INFO): Define to zero.
	* config/ia64/unwind-ia64.c: Remove code that compensated for
	the CFA offset error fixed above.
	* config/ia64/t-ia64 (ia64.o): Depend on debug.h.
	* dwarf2out.c (DWARF2_FRAME_INFO): Define default.
	(dwarf2out_do_frame): Require nonzero DWARF2_UNWIND_INFO for
	-funwind-tables and -fexceptions to enable frame info.
	(dwarf2out_frame_init): Define initial CFA even if
	DWARF2_UNWIND_INFO is disabled.  Call initial_return_save if
	DWARF2_UNWIND_INFO is nonzero, not just defined.
	(dwarf2out_frame_finish): Output non-EH call frame info only
	if DWARF2_FRAME_INFO is nonzero.
	(convert_cfa_to_loc_list,
	compute_frame_pointer_to_cfa_displacement): Define even if
	unwind info is not supported.
	(gen_subprogram_die): Use the above unconditionally.  Remove
	legacy alternate code.
	* toplev.c (compile_file): Compile in call to
	dwarf2out_frame_finish if DWARF2_DEBUGGING_INFO is defined.
	(lang_dependent_init): Ditto for dwarf2out_frame_init.

2006-02-03  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/25926
	* pa/x-ada (X_ADA_CFLAGS): Define _X_HPUX10 on HP-UX 10.
	* pa/t-pa (TARGET_LIBGCC2_CFLAGS): Define _T_HPUX10 on HP-UX 10.

2006-02-03  Richard Henderson  <rth@redhat.com>

	PR target/26090
	* config/ia64/sysv4.h (TARGET_ASM_SELECT_RTX_SECTION,
	TARGET_ASM_SELECT_SECTION, TARGET_ASM_UNIQUE_SECTION,
	TARGET_ASM_SELECT_RTX_SECTION, TARGET_RWRELOC): Copy from
	the hpux definition.

2006-02-03  Jason Merrill  <jason@redhat.com>

	PR c++/25979
	* gimplify.c (gimplify_modify_expr_rhs): Disable *& optimization for now.

	PR middle-end/25977
	* gimplify.c (gimplify_modify_expr_rhs): It's not always safe to do RVO
	on the return slot if it's an NRV.

2006-01-31  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/26001
	* expr.c (expand_expr_real_1) <case ARRAY_REF>:
	Use the corrected index for the character
	out of the string constant.

2006-02-03  Steve Ellcey  <sje@cup.hp.com>

	PR middle-end/24901
	* fold-const.c (fold_checksum_tree): Change type of buf.

2006-02-03  Alan Modra  <amodra@bigpond.net.au>

	PR target/25960
	* config/rs6000/darwin-ldouble.c (__gcc_qadd): Preserve -0.0 result.

2006-02-03  Andreas Krebbel  <krebbel1@de.ibm.com>
	    Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/25864
	* config/s390/2084.md ("x_fsimptf", "x_fmultf", "x_fdivtf",
	"x_floadtf", "x_ftrunctf", "x_ftruncdf"): New insn reservations.
	* config/s390/fixdfdi.h (__fixunstfdi, __fixtfdi): New functions.
	* config/s390/s390.c (struct processor_costs): Add mxbr, sqxbr, dxbr 
	and dxr fields.
	(z900_cost, z990_cost, z9_109_cost): Values for the new fields added.
	(s390_rtx_costs): Use the new fields to calculate rtx costs.
	(s390_secondary_input_reload_class, s390_secondary_output_reload_class):
	Define secondary reloads for TFmode moves.
	(constant_modes): Add TFmode.
	(NR_C_MODES): Set to 8.
	* config/s390/s390.h (TARGET_CPU_CPP_BUILTINS): Add __LONG_DOUBLE_128__
	builtin define.
	(LONG_DOUBLE_TYPE_SIZE): Set to 128 or 64.
	(LIBGCC2_LONG_DOUBLE_TYPE_SIZE, WIDEST_HARDWARE_FP_SIZE): Define.
	(HARD_REGNO_NREGS, HARD_REGNO_MODE_OK, CLASS_MAX_NREGS, 
	CANNOT_CHANGE_MODE_CLASS): Consider TFmode.
	* config/s390/s390.md ("type" attribute): Add fsimptf, floadtf, fmultf, 
	fdivtf, fsqrttf, ftrunctf, ftruncdf as possible values.
	(FPR mode macro): Add TFmode.
	(DSF mode macro): New.
	(<de>, <dee> mode attributes): Removed.
	(<xde>, <xdee>, <RRe>, <RXe>, <Rf> mode attributes): New.
	("*cmp<mode>_ccs_0", "*cmp<mode>_ccs_0_ibm", "*cmp<mode>_ccs", 
	"*cmp<mode>_ccs_ibm", "fix_trunc<FPR:mode><GPR:mode>2_ieee", 
	"floatdi<mode>2", "floatsi<mode>2_ieee", "*add<mode>3", 
	"*add<mode>3_cc", "*add<mode>3_cconly", "*add<mode>3_ibm", 
	"*sub<mode>3", "*sub<mode>3_cc", "*sub<mode>3_cconly", 
	"*sub<mode>3_ibm", "*mul<mode>3_ibm", "*fmadd<mode>", "*fmsub<mode>",
	"*div<mode>3", "*div<mode>3_ibm", "*neg<mode>2_cc", 
	"*neg<mode>2_cconly", "*neg<mode>2", "*neg<mode>2_ibm", 
	"*abs<mode>2_cc", "*abs<mode>2_cconly", "*abs<mode>2",
	"*abs<mode>2_ibm", "*negabs<mode>2_cc", "*negabs<mode>2_cconly", 
	"*negabs<mode>2", "sqrt<mode>2"):
	Changed <de> to <xde>. R constraint replaced by <Rf>.
	("*mul<mode>3"): Changed <dee> to <xdee>. R constraint replaced by 
	<Rf>.
	("fix_trunc<FPR:mode>di2"): 'FPR:' removed.
	("*fmadd<mode>", "*fmsub<mode>"): FPR mode replaced by DSF.
	("*movtf_64", "*movtf_31"): New insn definitions followed by 5 
	splitters.
	("movtf", "reload_outtf", "reload_intf", "trunctfdf2", "trunctfsf2", 
	"extenddftf2", "extendsftf2"): New expanders.
	("*trunctfdf2_ieee", "*trunctfdf2_ibm", "*trunctfsf2_ieee", 
	"*trunctfsf2_ibm", "*extenddftf2_ieee", "*extenddftf2_ibm",
	"*extendsftf2_ieee", "*extendsftf2_ibm"): New insn patterns.
	* config/s390/s390.opt (mlong-double-128, mlong-double-64):
	New options.
	* config/s390/t-crtstuff (TARGET_LIBGCC2_CFLAGS): Macro defined.
	* config/s390/libgcc-glibc.ver (__divtc3, __multc3, __powitf2, 
	__fixtfti, __fixunstfti, __floattitf, __fixtfdi, __fixunstfdi,
	__floatditf): Add a GCC_4.1.0 symbol version tag.
	* doc/invoke.texi (-mlong-double-128, -mlong-double-64): Document
	the new options.

2006-01-31  Jakub Jelinek  <jakub@redhat.com>

	* config/s390/s390.c (init_alignment_context): Set
	ALIAS_SET_MEMORY_BARRIER on the MEM.

2006-01-31  Carlos O'Donell  <carlos@codesourcery.com>

	* optabs.c (prepare_cmp_insn): If unbiased and unsigned then bias
	the comparison routine return.

2006-01-31  Nathan Sidwell  <nathan@codesourcery.com>

	* config/m68k/lb1sf68.asm: Use moveq to load small constants.

2006-01-31  Richard Guenther  <rguenther@suse.de>

	Backport
	2006-01-03  Adrian Straetling  <straetling@de.ibm.com>

	* builtins.c (get_builtin_sync_mem): New function.
	(expand_builtin_sync_operation, expand_builtin_compare_and_swap,
	expand_builtin_lock_test_and_set, expand_builtin_lock_release):
	Call get_builtin_sync_mem to generate mem rtx.

	2006-01-25  Richard Henderson <rth@redhat.com>

	* alias.h (ALIAS_SET_MEMORY_BARRIER): New.
	* alias.c (true_dependence): Respect it.
	(canon_true_dependence, write_dependence_p): Likewise.
	* builtins.c (get_builtin_sync_mem): Set it.

2006-01-30  Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/26018
	* config/s390/s390.c (struct machine_function): New flag
	decomposed_literal_pool_addresses_ok_p.
	(s390_reorg): Set it before final stage of literal pool transforms.
	(s390_decompose_address): Only accept displacements of the form
	(minus (label_ref ...) (label_ref ...)) if that flag is set.

2006-01-30  J"orn Rennecke <joern.rennecke@st.com>

	Merged from mainline r107469:
	* caller-save.c: (this_insn_sets): Move into:
	(save_call_clobbered_regs).
	(mark_set_regs): Get this_insn_sets from data.

	(save_call_clobbered_regs): Take sets of the return value by
	sibcalls into account.

2006-01-30  J"orn Rennecke <joern.rennecke@st.com>

	PR target/14798:
	* sh.c (pragma_interrupt, trap_exit, sp_switch): Remove variable.
	(pragma_trap, pragma_nosave_low_regs): Likewise.
	(current_function_anonymous_args): Likewise.
	(sh_deferred_function_attributes): New variable.
	(sh_deferred_function_attributes_tail): Likewise.
	(print_operand): For '@', look up trap_exit attribute.
	(calc_live_regs): Look up trapa_handler attribute.  For trapa
	handlers, save/restore fpscr, but don't do any other
	interrupt-specific saves.
	Don't save r0..r7 if the nosave_low_regs attribute is in effect.
	Fix check for partially saved registers to check for SHmedia.
	(sh_expand_prologue, sh_expand_epilogue): Look up sp_switch attribute.
	(sh_output_function_epilogue): Don't clear any of the removed
	variables.
	(sh_insert_attributes): Don't check pragma_interrupt.
	Insert deferred attributes.  Check that interrupt attribute is
	present for other attributes that require its presence.
	(sh_attribute_table): Add new attributes trapa_handler and
	nosave_low_regs.
	(sh_handle_sp_switch_attribute, sh_handle_trap_exit_attribute):
	Don't check for pragma_interrupt.  Don't store argument.
	* sh.h (pragma_interrupt, sp_switch): Don't declare.
	(sh_deferred_function_attributes): Declare.
	(sh_deferred_function_attributes_tail): Likewise.
	* sh.md (sp_switch_1): Add operand.  Change generator caller.
	(sh_pr_interrupt, sh_pr_trapa, sh_pr_nosave_low_regs): Remove.
	(*return_i): Don't use when trap_exit attribute is in effect.
	(*return_trapa): New insn pattern.
	* sh-c.c: New file.
	* config.gcc (sh[123456ble]*-* | sh-*-*): New trailer stanza,
	setting c_target_objs and cxx_target_objs.
	* t-sh: Add rule for sh-c.o.

	* config/sh/sh.c (sh_cfun_trap_exit_p): New function.
	* sh-protos.h (sh_cfun_trap_exit_p): Declare.

2006-01-29  Eric Botcazou  <ebotcazou@adacore.com>

	Revert

	2005-11-09  Eric Botcazou  <ebotcazou@adacore.com>
	* tree.c (build_qualified_type): Chain the new type to the original
	type's TYPE_NEXT_PTR_TO or TYPE_NEXT_REF_TO linked lists if it is
	a POINTER_TYPE or a REFERENCE_TYPE respectively.
	(build_pointer_type_for_mode): Only return unqualified types.
	(build_reference_type_for_mode): Likewise.

2006-01-28  Hans-Peter Nilsson  <hp@axis.com>

	PR target/25706
	* config/cris/cris.md ("*extopqihi_side", "*extop<mode>si_side")
	("*extop<mode>si_swap_side_biap", "*extop<mode>si_swap_side",
	("*extopqihi", "*extop<mode>si", "*extop<mode>si_swap"): Use %E
	output pattern modifier, not %e.
	* config/cris/cris.c (cris_op_str): Update comment about pattern
	modifier.
	(cris_print_operand) <case 'e'>: Clear cris_output_insn_is_bound
	before falling through into...
	<case 'E'>: Redefined from old 'e' case.

	PR target/25718
	* config/cris/cris.md ("uminsi3"): Don't use 8- or 16-bit sizes
	for a negative bound.

	PR target/25947
	* config/cris/cris.c (cris_order_for_addsi3): New function.
	* config/cris/cris-protos.h: Prototype it.
	* config/cris/cris.md (split for "move.S1 [rx=rx+i],ry")
	(split for "move.S1 ry,[rx=rx+i]", split for "clear.[bwd] [rx=rx+i]")
	(split for "mov(s|u).S1 [rx=rx+i],ry", split for "op.S1 [rx=rx+i],ry")
	(split for "op.S1 [rx=rx+i],ry (swapped)")
	(split for "op(s|u).S1 [rx=rx+i],ry")
	(split for "op(s|u).S1 [rx=rx+i],ry (swapped, plus or bound)"):
	Apply cris_order_for_addsi3 when generating addsi3 insns.

2006-01-26 Alexandre Oliva  <aoliva@redhat.com>

	PR other/24829
	PR target/24831
	* gthr-dce.h: Do not gthrw-ify pthread_once_init,
	pthread_key_delete.  From John David Anglin.  gthrw-ify
	pthread_getunique_np only if it it's not a macro.  Delete
	UNUSED macro.
	(__gthread_objc_condition_allocate, __gthread_objc_condition_deallocate,
	__gthread_objc_condition_wait, __gthread_objc_condition_broadcast,
	__gthread_objc_condition_signal, __gthread_key_delete): Add
	"__attribute__ ((__unused__))" to unused arguments.
	(__gthread_recursive_mutex_init_function): Add missing return.
	* gthr-dce.h, gthr-tpf.h, gthr-solaris.h, gthr-posix.h,
	gthr-posix95.h: Use macro-based approach for name redirection
	on targets missing weakref.

2006-01-26  Alexandre Oliva  <aoliva@redhat.com>

	PR c/25892
	* c.opt (Wpointer-sign): Init to -1.
	* c-opts.c (c_common_handle_option): Set to 1 on OPT_Wall and
	OPT_pedantic, to 0 otherwise.
	* doc/invoke.texi: Update.

2006-01-24  David Daney  <ddaney@avtrex.com>

	PR java/25816
	* configure.ac (enable_tls): New enable option.
	(HAVE_AS_TLS): Don't do assembler check if enable_tls set.
	* configure: Regenerate.
	* doc/install.texi (--enable-tls): Document new option.
	(--disable-tls): Ditto.

2006-01-23  Richard Guenther  <rguenther@suse.de>
	Steven Bosscher <stevenb.gcc@gmail.com>

	PR rtl-optimization/24626
	* cfgloopmanip.c (lv_adjust_loop_entry_edge): Don't set
	EDGE_TRUE_VALUE if in RTL mode.

	Revert
	2005-03-30 Mostafa Hagog <mustafa@il.ibm.com>
	* cfgrtl.c (rtl_verify_flow_info_1): Fix.

2006-01-23  Steven Bosscher  <stevenb.gcc@gmail.com>
	Jan Hubicka  <jh@suse.cz>
	Richard Guenther  <rguenther@suse.de>

	PR rtl-optimization/25654
	* cfgexpand.c (aggregate_contains_union_type): New function.
	(add_alias_set_conflicts): Call it.  Make sure to add conflicts
	for structure variables that contain a union type.

2006-01-21  Joseph S. Myers  <joseph@codesourcery.com>

	* gcc.c (process_command), gcov.c (print_version), gcov-dump.c
	(print_version), mips-tdump.c (main), mips-tfile.c (main): Update
	copyright notice dates.

2006-01-19  Paul Brook  <paul@codesourcery.com>

	* config/arm/arm.c (arm_compute_func_type): Treat all functions
	as nothrow when unwinding tables are disabled.

2006-01-19  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR testsuite/25171
	* c-decl.c (check_bitfield_type_and_width): Don't issue pedwarn "type
	of bit-field" when in system header.

2006-01-19  Richard Sandiford  <richard@codesourcery.com>

	PR c/25805
	* c-decl.c (add_flexible_array_elts_to_size): New function.
	(finish_decl): Use it.

2006-01-18  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/25731
	* config.gcc (hppa*-*-linux*, hppa[12]*-*-hpux10*, hppa*64*-*-hpux11*,
	hppa[12]*-*-hpux11*): Override default shared libgcc version for both
	sjlj and dwarf2 exception handling.
	* pa/t-hpux-shlib (SHLIB_SOVERSION): New make variable.
	Rework to allow overriding SHLIB_EXT and SHLIB_SOVERSION.
	* pa/pa.c (function_value): Treat complex and vector types as
	aggregates.
	(function_arg): Likewise.  Only pass scalar floats in the floating
	point argument registers.
	* pa/t-slibgcc-dwarf-ver: New file.
	* pa/t-slibgcc-sjlj-ver: New file.
	* pa/t-slibgcc-elf-ver: Delete file.

2006-01-17  Jakub Jelinek  <jakub@redhat.com>

	PR c/25682
	* c-typeck.c (build_unary_op): Fold offsetof-like expressions
	even when the pointer is not NULL.

2006-01-16  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.md: Disparage copies between general and floating-point registers
	in 32-bit move patterns.

2006-01-16  Steven Bosscher  <stevenb.gcc@gmail.com>
	Richard Guenther  <rguenther@suse.de>

	PR rtl-optimization/24257
	* gcse.c (find_moveable_store): Only consider a store movable
	when the SET_SRC of the insn can be assigned to a register.

2006-01-15  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/25168
	* tree.c (get_file_function_name_long): Concatenate the first global
	object name with a string derived from the input filename of the object
	for type "F".

2006-01-13  Andrew Pinski  <pinskia@physics.uc.edu>

	PR tree-opt/24365
	* tree-inline.c (declare_return_variable): If the return variable
	was marked as a non gimple complex, set the return slot variable
	to be a non gimple comple variable.

2006-01-11  Paolo Bonzini  <bonzini@gnu.org>

	PR tree-optimization/23109
	PR tree-optimization/23948
	PR tree-optimization/24123

	* Makefile.in (tree-ssa-math-opts.o): Adjust dependencies.
	* tree-cfg.c (single_noncomplex_succ): New.
	* tree-flow.h (single_noncomplex_succ): Declare it.
	* tree-ssa-math-opts.c (enum place_reciprocal): Remove.
	* tree-ssa-math-opts.c (enum place_reciprocal): Remove.
	(struct occurrence, occ_head, occ_pool, is_divide_by, compute_merit,
	insert_bb, register_division_in, insert_reciprocals,
	replace_reciprocal, free_bb): New.
	(execute_cse_reciprocals_1): Rewritten.
	(execute_cse_reciprocals): Adjust calls to execute_cse_reciprocals_1.
	Do not commit any edge insertion.  Always compute dominators and
	create the allocation pool.
	* target-def.h (TARGET_MIN_DIVISIONS_FOR_RECIP_MUL): New.
	* target.h (struct gcc_target): Add min_divistions_for_recip_mul.
	* targhooks.c (default_min_divistions_for_recip_mul): New.
	* targhooks.h (default_min_divistions_for_recip_mul): New prototype.
	* passes.c (init_optimization_passes): Run recip after tree loop
	optimizations.
	* doc/tm.texi (Misc): Document TARGET_MIN_DIVISIONS_FOR_RECIP_MUL.

2006-01-11  Jan Hubicka  <jh@suse.cz>

	PR target/25042
	* i386.c (ix86_init_mmx_sse_builtins): Do not delcare float128

2006-01-10  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/20754
	* config/pa/pa.md: Create separate 32 and 64-bit move patterns
	for SI, DI, SF and DF modes.  Add alternatives to copy between
	general and floating point registers to the 32-bit patterns.
	* config/pa/pa-64.h (SECONDARY_MEMORY_NEEDED_RTX): Delete undefine.
	* config/pa/pa.h (SECONDARY_MEMORY_NEEDED_RTX): Delete define.
	(SECONDARY_MEMORY_NEEDED): Secondary memory is only needed when
	generating 64-bit code.
	* config/pa/pa.c (output_move_double): Handle copies between general
	and floating registers.

2006-01-10  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/25367
	* config/sparc/sparc.h (HARD_REGNO_RENAME_OK): New macro.

2006-01-10  Jan Beulich  <jbeulich@novell.com>

	* config/i386/netware.h (TARGET_SUBTARGET_DEFAULT): Include
	MASK_ALIGN_DOUBLE.
	* config/i386/nwld.h (LINK_SPEC): Add --extensions:GNU option.
	* config/i386/t-nwld (SHLIB_LINK): Insert spaces between expr
	arguments.

2006-01-09  Kazu Hirata  <kazu@codesourcery.com>

	PR tree-optimization/25125
	* convert.c (convert_to_integer): Don't narrow the type of a
	PLUX_EXPR or MINUS_EXPR if !flag_wrapv and the unwidened type
	is signed.

2006-01-08  Ian Lance Taylor  <ian@airs.com>
	    David Edelsohn  <edelsohn@gnu.org>

	PR rtl-optimization/25662
	* optabs.c (simplify_expand_binop): Use simplify_binary_operation
	for constant operands instead of simplify_gen_binary.

2006-01-04  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/pmm_malloc.h (posix_memalign): If __cplusplus,
	make the prototype extern "C" and add throw ().

	PR target/25554
	* config/i386/i386.md (testqi_ext_3): Ensure len is positive
	and pos non-negative and pos + len <= 32.
	(testqi_ext_3_rex64): Ensure len is positive and pos non-negative,
	drop pos + len < HOST_BITS_PER_WIDE_INT test.
	(testqi_ext_3* splitter): Handle pos + len == HOST_BITS_PER_WIDE_INT.

	PR c/25559
	* c-common.c (handle_vector_size_attribute): Reject zero vector size
	as well as sizes not multiple of component size.

	PR debug/25562
	* function.c (instantiate_expr): New function.
	(instantiate_decls_1, instantiate_decls): If DECL_HAS_VALUE_EXPR_P,
	walk its DECL_VALUE_EXPR with instantiate_expr.

	* dwarf2out.c (loc_descriptor_from_tree_1): Don't add
	DW_OP_deref{,_size} if address isn't going to be added.

2006-01-03  Steven Bosscher  <stevenb.gcc@gmail.com>

	* fold-const.c (operand_equal_p): Accept a NULL operand 0 for
	COMPONENT_REFs.
	* emit-rtl.c (mem_attrs_htab_eq): Use iterative_hash_expr for
	hashing trees instead of a pointer hash.
	(mem_attrs_htab_eq): Do a deep compare instead of a pointer
	compare for MEM_EXPR.

	PR rtl-optimization/25130
	* cse.c (exp_equiv_p): Compare MEM_ATTRS instead of MEM_ALIAS_SET
	when comparing MEMs for GCSE

2006-01-03  Richard Guenther  <rguenther@suse.de>

	PR c/25183
	* stmt.c (add_case_node): Make sure to clear overflow flags
	from ranges.

2005-12-30  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR fortran/25586
	* pa.md: Remove REG_POINTER check from REG+REG peephole2 floating-point
	store patterns.

2005-12-29  Daniel Jacobowitz  <dan@codesourcery.com>
	Paul Brook  <paul@codesourcery.com>

	* config/m68k/m68k.c (m68k_output_pic_call): Don't use bsr.l for
	!TARGET_68020.
	* config/m68k/t-m68kelf (EXTRA_PARTS): Remove.
	(EXTRA_MULTILIB_PARTS): Set.
	* config/m68k/t-uclinux (EXTRA_PARTS): Remove.
	(EXTRA_MULTILIB_PARTS): Set.

2005-12-29  Hans-Peter Nilsson  <hp@axis.com>

	PR target/24342
	* config/cris/cris.c (cris_split_movdx): Add REG_INC notes for
	emitted insns with post-increments.
	(cris_expand_epilogue): Ditto.

2005-12-29  Alan Modra  <amodra@bigpond.net.au>

	PR target/25572
	* config/rs6000/rs6000.c (create_TOC_reference): Set regs_ever_live.

2005-12-26  Mark Mitchell  <mark@codesourcery.com>

	PR c++/23171, c++/23172, c++/25417.
	* c-decl.c (compound_literal_number): Remove.
	(build_compound_literal): Use set_compound_literal_name.
	* c-common.c (compound_literal_number): New variable.
	(set_compound_literal_name): New function.
	* c-common.h (set_compound_literal_name): Declare.
	
2005-12-24  Mark Mitchell  <mark@codesourcery.com>

	PR c++/23171
	* varasm.c (initializer_constant_valid_p): An ADDR_EXPR of a
	CONSTRUCTOR is invalid.

2005-12-23  Ulrich Weigand  <uweigand@de.ibm.com>

	PR rtl-optimization/21041
	* reload.c (find_reloads_subreg_address): Replace paradoxical
	subreg of MEM by widened access only if the resulting memory
	is properly aligned, even on !STRICT_ALIGNMENT targets.

2005-12-23  Jakub Jelinek  <jakub@redhat.com>

	PR target/25005
	* regrename.c (replace_oldest_value_reg): Use validate_change with
	IN_GROUP set to 1 instead of doing direct modifications.
	(copyprop_hardreg_forward_1): Likewise.  If any replace_oldest_*
	replacements have been performed on an instruction, use
	apply_change_group ().

2005-12-23  Alan Modra  <amodra@bigpond.net.au>

	PR rtl-optimization/25432
	* reload1.c (eliminate_regs_in_insn): Update insn code on
	successfully re-recognizing modified insn.

2005-12-22  Andrew Pinski <pinskia@physics.uc.edu>

	PR tree-opt/25513
	* tree-dfa.c (make_rename_temp): Set DECL_COMPLEX_GIMPLE_REG_P complex
	variables.

2005-12-21  Andrew Pinski  <pinskia@physics.uc.edu>

	PR debug/25518
	* dwarf2out.c (dwarf2out_switch_text_section): Declare when
	DWARF2_UNWIND_INFO is defined or when DWARF2_DEBUGGING_INFO is
	defined.

2005-12-20  Zdenek Dvorak  <dvorakz@suse.cz>

	PR tree-optimization/24793
	* tree-ssa-loop-ivopts.c (get_ref_tag): Remember the
	original reference if there are subvars.
	* tree-ssa-operands.c (get_tmr_operands): Handle subvars.

2005-12-21  Steven Bosscher  <stevenb@suse.de>

	PR rtl-optimization/25196
	* postreload-gcse.c (record_last_set_info): Notice stack pointer
	changes in push insns without REG_INC notes.

2005-12-21  Andrew Haley  <aph@redhat.com>

	PR middle-end/25121
	* recog.c (peephole2_optimize): Don't peephole any
	RTX_FRAME_RELATED_P insns.

2005-12-20  Richard Guenther  <rguenther@suse.de>

	PR middle-end/24306
	* builtins.c (std_gimplify_va_arg_expr): Do not align
	va frame for zero sized types.
	* config/i386/i386.c (ix86_gimplify_va_arg): Likewise.

2005-12-19  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/22313
	* dwarf2out.c (dwarf2out_switch_text_section): Export.
	* debug.h (dwarf2out_switch_text_section): Prototype.
	* final.c (final_scan_insn): Call dwarf2out_switch_text_section
	if we need to call it for dwarf2 unwind info.

2005-12-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR rtl-optimization/24982
	* reload.c (refers_to_regno_for_reload_p): Take
	reg_equiv_invariant and reg_equiv_init into account.
	* reload.h (reg_equiv_invariant): Declare.

2005-12-19  Paolo Bonzini  <bonzini@gnu.org>

	PR target/25180
	* config/rs6000/predicates.md (logical_const_operand): Split
	out of logical_operand.
	(logical_operand): Use it.
	* config/rs6000/rs6000.md (cmp -> xor peephole2): Use
	logical_const_operand.

2005-12-19  Nathan Sidwell  <nathan@codesourcery.com>

	* config/mt/mt.md (decrement_and_branch_until_zero): Add another
	scratch.  Correct its reload split. Adjust its peephole.
	(nop): Use 'nop'.
	* config/mt/mt.c (MT_INT_ARG_FIRST): Remove.
	(mt_asm_output_opcode, mt_print_operand): Use 'nop'.
	(mt_function_arg_slotno): Use FIRST_ARG_REGNUM.
	(mt_builtin_saveregs): Replace with ...
	(mt_setup_incoming_varargs): ... here.  Save just the varadic
	args.
	(mt_va_start): Remove.
	(mt_reorg_hazard): Ignore USE insns.  Don't call set_noop_p.
	(mt_machine_reorg): Split all insns here.
	(TARGET_SETUP_INCOMING_VARARGS): Override.
	* config/mt/mt.h (TARGET_CPU_CPP_BUILTINS): Define __mt__ only.
	Set to CPU type.
	(EXPAND_BUILTIN_VA_START): Remove.

2005-12-18  Andreas Krebbel  <krebbel1@de.ibm.com>

	* tree-cfg.c (tree_flow_call_edges_add): Check for empty basic blocks.

2005-12-18  Jan Hubicka  <jh@suse.cz>

	PR rtl-optimization/25224
	* tree-ssa-loop-unswitch.c (tree_unswitch_single_loop): Free copy
	tables.

2005-12-18  Dorit Nuzman  <dorit@il.ibm.com>

	PR tree-optimization/24378
	* tree-vect-transform.c (vect_transform_loop): Create single-predecessor
	basic-block after loop-versioning.

2005-12-17  Steven Bosscher  <stevenb@suse.de>

	PR rtl-optimization/23837
	* optabs.c (expand_binop): For a multi-word rotate, never emit
	a REG_NO_CONFLICT block.

2005-12-16  Nathan Sidwell  <nathan@codesourcery.com>

	Second part of MS1->MT renaming
	* config/mt/mt.md (doloop_end): Call mt_add_loop.
	(movqi, movhi): Call mt_set_memflags.
	(*movdf_internal): Call mt_split_words. 
	(reload_inqi, reload_outqi, reload_inhi, reload_outhi): Call
	mt_set_memflags.
	(cmpsi): Store to mt_compare_op[01].
	(beq, bne, bge, bgt, ble, blt, bgeu, bgtu, bleu, bltu, bunge,
	bungt, bunle, bunlt): Call mt_emit_cbranch.
	(prologue): Call mt_expand_prologue.
	(epilogu): Call mt_expend_epilogue.
	(eh_return): Call mt_expand_eh_return.
	(eh_epilogue): Call me_emit_eh_epilogue.
	(conditional_trap): Store to mt_compare_op[01].
	* config/mt/crti.asm: Adjust comment.
	* config/mt/crtn.asm: Adjust comment.
	* config/mt/mt.c (MT_INT_ARG_FIRST): Renamed.
	(mt_compare_op0, mt_compare_op1): Renamed.
	(current_frame_info, zero_frame_info): Adjust type.
	(mt_ucmpsi3_libcall): Renamed.
	(mt_flag_delayed_branch): Renamed.
	(mt_struct_value_rtx, mt_return_addr_rtx): Renamed.
	(mt_nops_required, mt_nop_reasons): Renamed.
	(mt_asm_output_opcode, mt_get_attr_type, mt_final_prescan_insn,
	mt_debug_stack, mt_print_operand_simple_address,
	mt_print_operand_address, mt_print_operand): Renamed, adjusted.
	(mt_init_cumulative_args, mt_function_arg_slotno, mt_function_arg,
	mt_function_arg_advance, mt_arg_partial_bytes,
	mt_pass_by_reference, mt_function_arg_boundary,
	mt_reg_ok_for_base_p, mt_legitimate_simple_address_p,
	mt_legitimate_address_p): Renamed, adjusted.
	(mt_cpu): Renamed.
	(mt_init_machine_status, mt_override_options, mt_builtin_saveregs,
	mt_va_start, mt_compute_frame_size, mt_emit_save_restore,
	mt_emit_save_fp, mt_emit_save_regs, mt_interrupt_function_p, 
	mt_expand_prologue, mt_epilogue_uses, mt_expand_epilogue,
	mt_expand_eh_return, mt_emit_eh_prologue,
	mt_handl_interrupt_attribute): Renamed, adjusted.
	(mt_attribute_table): Renamed, adjusted.
	(mt_initial_elimination_offset, mt_generate_compare,
	mt_emit_cbranch, mt_set_memflags_1, mt_set_memflags,
	mt_secondary_reload_class, mt_function_value, mt_split_words,
	mt_pass_in_stack, mt_add_loop, mt_loop_nesting, mt_block_length,
	mt_scan_loop, mt_reorg_loops): Renamed, adjusted.
	(mt_labels): Renamed.
	(mt_add_branches, mt_check_delay_slot, mt_reorg_hazard,
	mt_machine_reorg): Renamed, adjusted.
	(mt_attribute_table: Renamed.
	(TARGET_ATTRIBUTE_TABLE, TARGET_STRUCT_VALUE_RTX,
	TARGET_PASS_BY_REFERENCE, TARGET_MUST_PASS_IN_STACK,
	TARGET_ARG_PARTIAL_BYTES, TARGET_MACHINE_DEPENDENT_REORG): Adjust.
	* config/mt/mt.opt (march): Set mt_cpu_string.
	* config/mt/mt.h (mt_ucmpsi3_libcall, mt_cpu): Renamed.
	(TARGET_CPU_CPP_BUILTINS): Adjust.
	(TARGET_MS1_64_001, TARGET_MS1_16_002, TARGET_MS1_16_003,
	TARGET_MS2): Adjust.
	(TARGET_VERSION, OVERRIDE_OPTIONS, SECONDARY_RELOAD_CLASS): Adjust.
	(MT_MIN_INT): Renamed.
	(RETURN_ADDR_RTX): Adjust.
	(struct mt_frame_info): Renamed.
	(current_frame_info): Adjust type.
	(INITIAL_ELIMINATION_OFFSET): Adjust.
	(MT_NUM_ARG_REGS): Renamed.
	(REG_PARM_STACK_SPACE, FUNCTION_ARG, INIT_CUMULATVE_ARGS,
	FUNCTION_ARG_ADVANCE, FUNCTION_ARG_BOUNDARY, FUNCTION_VALUE,
	LIBCALL_VALUE, EPILOGUE_USES, EXPAND_BUILTIN_VA_START,
	GO_IF_LEGITIMATE_ADDRESS, REG_OK_FOR_BASE_P, ASM_OUTPUT_OPCODE,
	FINAL_REPSCAN_INSN, PRINT_OPERAND, PRINT_OPERAND_ADDRESS): Adjust.
	(mt_compare_op0, mt_compare_op1): Renamed.
	* config/mt/mt-protos.h: Rename prototypes.

	* config/mt/mt.c (mt_override_options): Require lower case
	architectures.  Revert accidental default to ms2.
	* config/mt/mt.h (ASM_SPEC, LIBSPEC, STARTFILE_SPEC,
	ENDFILE_SPEC): Require lower case architectures.  Revert default
	to ms2.

	* doc/invoke.texi (MT Options): Rename and update.
	* doc/md.texi (MorphoTech family): Rename and update.

	* config/mt/t-mt (crti.o, crtn.o): Add multilib options.
	(EXTRA_MULTILIB_PARTS): Define.

	* config/mt/t-mt (MULTILIB_OPTIONS): Add ms2
	(MULTILIB_DIRNAMES): Add ms2.  Prefix ms1 dirs with 'ms1'.
	* config/mt/mt.c (ms1_final_prescan): Use TARGET_MS2,
	TARGET_MS1_64_001 appropriately.
	(ms1_machine_reorg): Use TARGET_MS2.

	2005-12-09  Aldy Hernandez  <aldyh@redhat.com>
	* config/mt/t-mt (MULTILIB_OPTIONS): Define.
	(MULTILIB_DIRNAMES): Define.

	* config.gcc (ms1): Replace with ...
	(mt): ... this.
	* config/ms1: Rename to ...
	* config/mt: ... here.  Rename ms1 files to mt.
	* config/mt/mt.c: Adjust gt-mt.h #include.
	* config/mt/t-mt (LIB1ASMSRCS, LIB2FUNCS_EXTRA): Adjust.
	(crti.o, crtn.o): Adjust file names.

2005-12-16  Andrew Haley  <aph@redhat.com>

	* unwind-dw2-fde-glibc.c (_Unwind_IteratePhdrCallback): Guard
	against prev_cache_entry == NULL when moving a cache entry to the
	head of the list.
	
2005-12-16  Nathan Sidwell  <nathan@codesourcery.com>

	* config/ms1/ms1.c (ms1_reorg_hazard): Don't count noop moves.

2005-12-16  Jakub Jelinek  <jakub@redhat.com>

	PR rtl-optimization/24899
	* loop.c (strength_reduce): Don't reduce giv that is not always
	computable and where add_val or mult_val can trap.

	* doc/invoke.texi (-fdump-tree-*): Remove note about C/C++ only.

2005-12-16  Andreas Krebbel  <krebbel1@de.ibm.com>

	PR 24823
	* flow.c (mark_used_dest_regs): New function.
	(mark_used_regs): Call mark_used_dest_regs.

2005-12-15  Jakub Jelinek  <jakub@redhat.com>

	* varasm.c (default_unique_section_1): Use special section
	names for SECCAT_DATA_REL{,_RO}{,_LOCAL}.

2005-12-15  Jan Hubicka  <jh@suse.cz>

	PR target/24969
	* i386.c (classify_argument): Properly adjust offset of bitfield for
	substructures.

2005-12-15  Eric Botcazou  <ebotcazou@adacore.com>

	PR ada/18659
	PR ada/18819
	* doc/invoke.texi (Optimize Options): Document that
	-ftree-sra is not automatically enabled for the Ada compiler.

2005-12-15  Olivier Hainque  <hainque@adacore.com>

	* stor-layout.c (layout_type): Don't complain about a too small
	an array element type size compared to its alignment when the
	size overflows.

2005-12-14  Jeff Law  <law@redhat.com>

	PR tree-optimization/23838
	* tree-ssa-dse.c (dse_optimize_stmt): Correctly handle PHI nodes which
	represent a use and definition of the same SSA_NAME.

2005-12-14  Ulrich Weigand  <uweigand@de.ibm.com>

	PR rtl-optimization/25310
	* reload1.c (eliminate_regs_in_insn): Handle lowpart SUBREGs
	of the eliminable register when substituting into a PLUS.

2005-12-14  Jakub Jelinek  <jakub@redhat.com>

	PR debug/25023
	* config/i386/i386.c (ix86_force_to_memory): Always use
	SImode push for HImode in -m32.
	(ix86_free_from_memory): Likewise.

	PR target/25254
	PR target/24188
	* config/i386/i386.c (x86_64_elf_select_section): If DECL is not
	DECL_P, call named_section_flags rather than named_section.  Supply
	section flags to it.

2005-12-13  Jakub Jelinek  <jakub@redhat.com>

	PR debug/25023
	PR target/25293
	* expr.c (emit_move_resolve_push): Handle PRE_MODIFY
	and POST_MODIFY with CONST_INT adjustment equal to PUSH_ROUNDING.
	Fix POST_INC/POST_DEC handling if PUSH_ROUNDING is not identity.
	* config/i386/i386.md (pushhi2, pushqi2): Use pushl instead of pushw.
	Set mode to SI, adjust constraints.
	(pushhi2_rex64, pushqi2_rex64): Set mode to DI.
	* config/i386/i386.h (PUSH_ROUNDING): Round up to 4 instead of 2 for
	32-bit code.

2005-12-13  Paul Brook  <paul@codesourcery.com>

	* config/arm/bpabi.h (SUBTARGET_EXTRA_ASM_SPEC): Pass -meabi=gnu for
	apcs/atpcs.

2005-12-13  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/linux64.h (TARGET_ALIGN_NATURAL): Define.

2005-12-12  Alan Modra  <amodra@bigpond.net.au>

	PR target/25212
	* config/rs6000/rs6000.c (legitimate_indexed_address_p): Allow pattern
	generated by reload.
	(print_operand): Check that both operands of indexed address are regs.
	(print_operand_address): Likewise.
	* config/rs6000/rs6000.h (INT_REG_OK_FOR_INDEX_P): Simplify.
	(INT_REG_OK_FOR_BASE_P): Correct.
	* config/rs6000/predicates.md (indexed_or_indirect_operand): Use
	indexed_or_indirect_address.
	(indexed_or_indirect_address): Don't test for base reg.  Call
	address_operand last.  Make it a special predicate.

2005-12-10  Mark Mitchell  <mark@codesourcery.com>

	PR c++/25010
	* ipa-inline.c (cgraph_clone_inlined_nodes): Do not assume that
	DECL_EXTERNAL functions have no bodies.  Tidy.

2005-12-10  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/25258
	* pa.c (som_text_section_asm_op): Use .NSUBSPA directive when changing
	to the text subspace to output debugging information.

2005-12-09  Bernd Schmidt  <bernd.schmidt@analog.com>

	* config/bfin/bfin.c: Include "cgraph.h".
	(bfin_load_pic_reg): Omit loading pic reg if in a local function.
	Return the reg that holds the pointer to the GOT.
	(bfin_expand_prologue): Use return value of bfin_load_pic_reg when
	doing stack checking.

2005-12-09  Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/25311
	* config/s390/s390.c (struct s390_address): New field literal_pool.
	(s390_decompose_address): Compute literal_pool field.  Do not 
	assume register %r13 is always (and solely) used as pool base.
	(s390_extra_constraint_str): Use literal_pool field.

2005-12-09  Thiemo Seufer  <ths@networkno.de>

	* config/mips/mips.c (override_options): Don't allow too small
	integers in FP registers.

2005-12-09  Alan Modra  <amodra@bigpond.net.au>

	PR debug/24908
	* dwarf2out.c (dwarf2out_frame_debug_expr): Don't assert that
	call_used_regs can't be used to save reg in another reg.

2005-12-09  Hans-Peter Nilsson  <hp@axis.com>

	PR target/23424
	* recog.c (constrain_operands): Strip unary operators
	only ifndef KEEP_UNARY_OPERATORS_AT_CONSTRAINT_CHECKING.
	* reload.c (find_reloads): Ditto.
	* config/cris/cris.h (KEEP_UNARY_OPERATORS_AT_CONSTRAINT_CHECKING):
	Define.

2005-12-08  Zdenek Dvorak  <dvorakz@suse.cz>

	PR tree-optimization/25248
	* tree-scalar-evolution.c (follow_ssa_edge_in_rhs): Do not use
	evolution_of_loop from the failed attempt.  Remove handling of
	MULT_EXPR.

2005-12-08  Richard Guenther  <rguenther@suse.de>

	Backport from mainline
	2005-11-28  Richard Guenther  <rguenther@suse.de>

	* c-common.c (strict_aliasing_warning): Handle all
	component-ref like accesses.

	2005-11-24  Richard Guenther  <rguenther@suse.de>
		Dirk Mueller <dmueller@suse.de>

	PR c++/14024
	* c-common.h (strict_aliasing_warning): Declare.
	* c-common.c (strict_aliasing_warning): New function,
	split out from ...
	* c-typeck.c (build_c_cast): ... here.

2005-12-08  Andreas Krebbel  <krebbel1@de.ibm.com>
	    Jakub Jelinek  <jakub@redhat.com>

	PR target/25268
	* config/s390/s390.c (s390_decompose_shift_count): Remove BITS
	argument.  Don't drop outer ANDs.
	(s390_extra_constraint_str, print_shift_count_operand): Adjust callers.
	* config/s390/s390-protos.h (s390_decompose_shift_count): Adjust
	prototype.
	* config/s390/predicates.md (setmem_operand): Remove.
	(shift_count_operand): Rename to...
	(shift_count_or_setmem_operand): ... this.  Adjust
	s390_decompose_shift_count caller.
	* config/s390/s390.md (<shift>di3_31_and, <shift>di3_64_and,
	ashrdi3_cc_31_and, ashrdi3_cconly_31_and, ashrdi3_31_and,
	ashrdi3_cc_64_and, ashrdi3_cconly_64_and, ashrdi3_64_and,
	<shift>si3_and, ashrsi3_cc_and, ashrsi3_cconly_and, ashrsi3_and,
	rotl<mode>3_and, setmem_long_and): New insns.
	(<shift>di3_31, <shift>di3_64, ashrdi3_cc_31, ashrdi3_cconly_31,
	ashrdi3_31, ashrdi3_cc_64, ashrdi3_cconly_64, ashrdi3_64,
	<shift>si3, ashrsi3_cc, ashrsi3_cconly, ashrsi3, rotl<mode>3,
	<shift>di3, ashrdi3): Use shift_count_or_setmem_operand instead
	of shift_count_operand.
	(setmem_long): Use shift_count_or_setmem_operand instead of
	setmem_operand.

2005-12-07  Adrian Straetling  <straetling@de.ibm.com>

	* config/s390/s390.c (s390_expand_atomic): New function.
	Adjust comment of helper functions.
	* config/s390/s390-protos.h (s390_expand_atomic): Declare.
	* config/s390/s390.md ("ATOMIC"): New code macro.
	("atomic"): Corresponding new code attribute.
	("sync_lock_test_and_set[hq]i", 
	"sync_{new_,old_,}{and,ior,xor,add,sub,nand}[hq]i"): New pattern.

2005-12-07  Adrian Straetling  <straetling@de.ibm.com>

	* config/s390/s390.c (s390_expand_mask_and_shift, 
	struct alignment_context, init_alignment_context, 
	s390_expand_cs_hqi): New.
	* config/s390/s390-protos.h (s390_expand_cs_hqi): Declare.
	* config/s390/s390.md ("sync_compare_and_swaphi",
	"sync_compare_and_swapqi"): New pattern.

2005-12-07  Adrian Straetling  <straetling@de.ibm.com>

	  * doc/md.texi: Adapt to implementation.

2005-12-07  Aldy Hernandez  <aldyh@redhat.com>

       PR C++/24138
	* tree.c (integer_all_onesp): Always return true if all bits on.

	* testsuite/g++.dg/init/array0.C: New.

2005-12-06  Andreas Schwab  <schwab@suse.de>

	* opts.c (decode_options): Fix typo in message.

2005-12-06  Alan Modra  <amodra@bigpond.net.au>

	PR other/13873
	* longlong.h: Merge PPC tests from upstream.

2005-12-05  James E Wilson  <wilson@specifix.com>

	PR target/24934
	* opts.c (decode_options): Turn off partitioning if flag_unwind_tables
	is set.

2005-12-05  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/host-darwin.c (segv_handler): Unblock SEGV so
	we don't go into an infinite loop.

2005-12-04  Joseph S. Myers  <joseph@codesourcery.com>

	* doc/invoke.texi, doc/standards.texi: Refer to
	gcc-4.1/c99status.html.

2005-12-02  Jakub Jelinek  <jakub@redhat.com>

	PR target/25199
	* config/i386/i386.md (movqi_1): Only force imovx for alternative
	5 if operand 1 is not aligned.  Undo previous constraint change.
	* config/i386/predicates.md (aligned_operand): Use MEM_ALIGN.

2005-12-02  Alan Modra  <amodra@bigpond.net.au>

	PR middle-end/25176
	* function.c (expand_function_end): Emit blockage for unwinder
	after return label.

2005-12-01  Richard Henderson  <rth@redhat.com>

	* optabs.c (expand_vec_cond_expr): Use EXPAND_NORMAL.

2005-11-30  Dale Johannesen  <dalej@apple.com>
	    Andrew Pinski  <pinskia@physics.uc.edu>

	PR rtl-opt/24930
	* combine.c (find_split_point):  Sign extend bitmask
	when changing bitfield assignment to IOR of AND.

2005-11-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	PR middle-end/25158
	* builtins.c (fold_builtin_fputs): Defer check for missing
	replacement functions.

2005-11-30  Kean Johnston  <jkj@sco.com>

	* config/i386/i386.c: Check the value of SUPPORTS_ONE_ONLY, not
	simply its presense in case targets #define SUPPORTS_ONE_ONLY 0.

2005-11-30  Nathan Sidwell  <nathan@codesourcery.com>

	* config/ms1/ms1.md (decrement_and_branch_until_zero): Add early
	clobber to scratch reg.
	(*decrement_and_branch_until_zero_no_clobber): Remove.
	(decrement_and_branch peephole): Add dummy scratch reg to pattern.
	(mulhish3): Use TARGET_MS1_16_003, TARGET_MS2.
	* config/ms1/ms1.opt (mmul): Remove.
	* config/ms1/ms1.h (ASM_SPEC): Cope with uppercase arch names.
	(LINK_SPEC, STARTFILE_SPEC, ENDFILE_SPEC): Default to 16-002.

2005-11-30  Jeff Law  <law@redhat.com>

	* tree-ssa-uncprop.c (associate_equivalences_with_edges): Properly
	handle SSA_NAME_OCCURS_IN_ABNORMAL_PHI.

2005-11-28  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/21166
	* c-decl.c (finish_struct):  Only set DECL_PACKED on a field
	when its natural alignment is > BITS_PER_UNIT.
	* stor-layout.c (finalize_type_size): Revert my patch of 2005-08-08.
	* c-common.c (handle_packed_attribute): Ignore packing on a field
	whose type is naturally char aligned.

2005-11-30  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/ia64.c (ia64_expand_tls_address): Add ORIG_OP1 argument.
	Move ADDEND_{HI,LO} computation into TLS_MODEL_INITIAL_EXEC case.
	(ia64_expand_move): Adjust caller.

	* config/ia64/ia64.c (ia64_expand_atomic_op): Only use
	fetchadd{4,8}.acq instruction if CODE is PLUS or MINUS, for MINUS
	negate VAL.

2005-11-29  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	PR middle-end/20109
	PR middle-end/25120
	* builtins.c (init_target_chars): New.
	(expand_builtin_printf, expand_builtin_fprintf,
	expand_builtin_sprintf, fold_builtin_sprintf,
	maybe_emit_sprintf_chk_warning, fold_builtin_sprintf_chk,
	fold_builtin_snprintf_chk, fold_builtin_printf,
	fold_builtin_fprintf): Check for matching format strings using
	the target charset.

2005-11-28  Alexandre Oliva  <aoliva@redhat.com>

	PR libfortran/24991
	* config/darwin.c (machopic_indirection_name,
	machopic_output_indirection): Follow transparent alias chain.

2005-11-28  Alexandre Oliva  <aoliva@redhat.com>

	* varasm.c (ultimate_transparent_alias_target): Add comment.

2005-11-26  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/21309
	* expmed.c (choose_mult_variant): Return immediately when mult_cost
	is less than zero.  Limit mult_cost to a reasonable upper bound for
	the synthetic multiplication sequence.

2005-11-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	PR middle-end/25022
	* builtins.c (expand_builtin_printf, expand_builtin_fprintf,
	fold_builtin_fputs, fold_builtin_printf, fold_builtin_fprintf):
	Lookup the explicit replacement functions for any unlocked
	stdio builtin transformations.

2005-11-25  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* fold-const.c (negate_mathfn_p): Fix comment.

2005-11-22  Eric Botcazou  <ebotcazou@adacore.com>

	PR middle-end/22561
	* tree-ssa-structalias.c (get_constraint_for): Handle ARRAY_RANGE_REF.

2005-11-22  Kazu Hirata  <kazu@codesourcery.com>

	PR target/23435
	* m68k.md (zero_extendsidi2): Force operands[1] to a register
	if both operands[0] and operands[1] are memory.

2005-11-22  Jan Hubicka  <jh@suse.cz>

	PR tree-optimization/24653
	* tree-ssa-ccp.c (ccp_fold): Strip down useless conversions.

2005-11-23  Alan Modra  <amodra@bigpond.net.au>

	PR target/24954
	* config/rs6000/predicates.md (easy_vector_constant_add_self): Fix
	typo last change.

2005-11-22  Alan Modra  <amodra@bigpond.net.au>

	PR middle-end/24950
	* expmed.c (store_bit_field): Don't attempt to insv a field
	larger than the reg.

2005-11-22  Alan Modra  <amodra@bigpond.net.au>

	PR target/24954
	* config/rs6000/predicated.md (easy_vector_constant_add_self): Use
	explicit sign extension, not a (char) cast.

2005-11-21  Joel Sherrill <joel.sherrill@oarcorp.com>

	* config/arm/rtems-elf.h: Added definition of LINK_GCC_C_SEQUENCE_SPEC
	which matches behavior of gcc 4.0 and older for RTEMS targets.  The
	default now includes a linker group which makes the RTEMS one nest.

2005-11-21  David Edelsohn  <edelsohn@gnu.org>

	PR target/24953
	* config/rs6000/predicates.md (vrsave_operation): Check
	UNSPEC_VOLATILE value.

2005-11-21  Paolo Bonzini  <bonzini@gnu.org>

	PR target/24951
	* config/rs6000/rs6000.c (output_vec_const_move): Load cst and
	cst2 only for SPE vectors.

2005-11-21  Kazu Hirata  <kazu@codesourcery.com>

	PR middle-end/20583
	* cse.c (cse_insn): Reject invalid forms of CONST earlier.

2005-11-20  Ian Lance Taylor  <ian@airs.com>

	PR rtl-optimization/24883
	* combine.c (combinable_i3pat): When checking whether the
	destination of i3 is used in i3, consider paradoxical subregs.

2005-11-20  Richard Henderson  <rth@redhat.com>

	PR 24931
	* tree-sra.c (struct sra_elt): Add all_no_warning.
	(struct sra_walk_fns) <use>: Add use_all argument.
	(sra_walk_expr): Pass it.
	(sra_walk_modify_expr): Likewise.
	(scalarize_ldst): Likewise.
	(scan_use): Update for new argument.
	(mark_no_warning): New.
	(scalarize_use): Use it.

2005-11-19  Richard Henderson  <rth@redhat.com>

	PR tree-opt/24665
	* tree-gimple.c (is_gimple_id): Export.
	* tree-gimple.h (is_gimple_id): Declare.
	* tree-ssa-ccp.c (ccp_decl_initial_min_invariant): New.
	(get_default_value): Use it.
	(maybe_fold_stmt_indirect): Likewise.

2005-11-20  Andreas Schwab  <schwab@suse.de>

	PR target/24757
	* config/ia64/ia64.c (ia64_expand_atomic_op): Fix condition of cmp
	insn.

2005-11-19  Hans-Peter Nilsson  <hp@axis.com>

	PR middle-end/24912
	PR middle-end/24750
	* reload.c (find_reloads_address_1): Mention dependency on
	gen_reload.
	* reload1.c (gen_reload): For IN with an unary operation, try
	moving inner expression to OUT if trivial SET is not valid.
	Confirm that the result is valid.  Move common code block into...
	(emit_insn_if_valid_for_reload): New function.

2005-11-19  Jakub Jelinek  <jakub@redhat.com>

	* gcc.c (version_compare_spec_function): Use '%s' rather than %qs in
	fatal format string.

2005-11-18  Mark Mitchell  <mark@codesourcery.com>

	* DEV-PHASE: Change to prerelease.

2005-11-18  James E Wilson  <wilson@specifix.com>

	* builtins.c (fold_builtin_strstr): Pass s1 through fold_convert before
	returning it.

2005-11-18  Mike Stump  <mrs@apple.com>

	* c-common.c (handle_cleanup_attribute): Use a lang hook for lookup_name.
	* config/darwin-c.c (darwin_pragma_unused): Likewise.
	* c-decl.c (lookup_name_two) Remove.
	* c-tree.h (lookup_name_two): Remove.
	* c-objc-common.h (LANG_HOOKS_LOOKUP_NAME): Add.
	* langhooks-def.h (LANG_HOOKS_LOOKUP_NAME): Add.
	(LANG_HOOKS_DECLS): Add initializer for LANG_HOOKS_LOOKUP_NAME.
	* langhooks.h (lang_hooks_for_decls): Add lookup_name.
	
2005-11-18  Richard Earnshaw  <richard.earnshaw@arm.com>

	PR target/24914
	* arm.c (arm_hard_regno_mode_ok): Co-processor registers aren't ok
	when not generating code to use that co-processor.

2005-11-18  James A. Morrison  <phython@gcc.gnu.org>

	* tree-flow.h (reserve_phi_args_for_new_edge, create_phi_node,
	add_phi_arg, remove_phi_args, remove_phi_node phi_reverse): Mention that
	these functions are now in tree-phinodes.c.

2005-11-18  Jie Zhang  <jie.zhang@analog.com>

	* config/bfin/bfin.md (trap): New pattern.

2005-11-18  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree-ssa-dom.c (extract_range_from_cond): Deal with variable bounds
	on types.

	* expr.c (expand_expr_real): Don't call record_block_change unless
	ib_boundaries_block is non-null

	* postreload.c (reload_cse_move2add): Don't try to work with BImode.

	* fold-const.c (build_range_check): Use proper type for subtraction
	when merging lower bound.

2005-11-18  Zdenek Dvorak  <dvorakz@suse.cz>

	PR rtl-optimization/24497
	* loop-unroll.c (apply_opt_in_copies): Do not verify equality of
	the copied insn.

2005-11-18  Zdenek Dvorak  <dvorakz@suse.cz>

	* tree-scalar-evolution.c (expression_expensive_p): New function.
	(scev_const_prop): Use compute_overall_effect_of_inner_loop.

2005-11-18  Bernd Schmidt  <bernd.schmidt@analog.com>

	* config/bfin/crtlibid.s: New file.

2005-11-17  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/24348
	* config.gcc (hppa*-*-hpux*): Add pa/t-slibgcc-elf-ver to tmake config
	when not using sjlj exceptions.
	* config/pa/pa64-hpux.h (LIB_SPEC): Add -lpthread in static links.
	* config/pa/pa-hpux11.h (LIB_SPEC): Likewise.
	* config/pa/som.h (ASM_PREFERRED_EH_DATA_FORMAT): Delete define.
	* config/pa/linux-unwind.h (pa32_fallback_frame_state): Use
	DWARF_ALT_FRAME_RETURN_COLUMN instead of column 0 as return column.
	* config/pa/pa-hpux.h (MD_UNWIND_SUPPORT): New define.
	* config/pa/pa-linux.h (INCOMING_RETURN_ADDR_RTX,
	DWARF_FRAME_RETURN_COLUMN, ASM_PREFERRED_EH_DATA_FORMAT,
	ASM_MAYBE_OUTPUT_ENCODED_ADDR_RTX): Delete defines.
	* config/pa/pa.h (ARG_POINTER_CFA_OFFSET): Delete.
	(FRAME_POINTER_CFA_OFFSET, INCOMING_RETURN_ADDR_RTX,
	DWARF_FRAME_RETURN_COLUMN, DWARF_ALT_FRAME_RETURN_COLUMN,
	ASM_PREFERRED_EH_DATA_FORMAT, ASM_MAYBE_OUTPUT_ENCODED_ADDR_RTX): New
	defines.
	* config/pa/hpux-unwind.h: New file.

2005-11-17  Alexandre Oliva  <aoliva@redhat.com>

	* config/rs6000/rs6000.h (ASM_OUTPUT_WEAKREF): Define.
	* defaults.h (ASM_OUTPUT_WEAKREF): Add decl argument.
	* varasm.c (do_assemble_alias): Adjust call.
	(weak_finish): Don't use ASM_WEAKEN_LABEL if ASM_WEAKEN_DECL
	is defined.
	* doc/tm.texi (ASM_OUTPUT_WEAKREF): Document it.

2005-11-17  James E Wilson  <wilson@specifix.com>

	* tree.def (FUNCTION_DECL): Correct typo in comment.

2005-11-17  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (dw_cfi_oprnd_struct): Reduce dw_cfi_reg_num to int.
	(lookup_cfa_1): Apply data alignment to DW_CFA_def_cfa_offset_sf
	and DW_CFA_def_cfa_sf.
	(def_cfa_1): Use DW_CFA_def_cfa_offset_sf with negative values.
	(dbx_reg_number): Don't assert particular registers here.
	(based_loc_descr): ... do it here instead.  Fold in ...
	(eliminate_reg_to_offset): ... this function.
	(compute_frame_pointer_to_cfa_displacement): Fold in the effects
	of eliminate_reg_to_offset; use FRAME_POINTER_CFA_OFFSET.
	* unwind-dw2.c (execute_cfa_program): Apply data align factor
	to DW_CFA_def_cfa_offset_sf and DW_CFA_def_cfa_sf.
	* function.c (instantiate_new_reg): Use FRAME_POINTER_CFA_OFFSET.
	(instantiate_virtual_regs): Likewise.
	* var-tracking.c (adjust_stack_reference): Likewise.
	* doc/tm.texi (FRAME_POINTER_CFA_OFFSET): New.

2005-11-17  Bernd Schmidt  <bernd.schmidt@analog.com>

	* config/bfin/elf.h (STARTFILE_SPEC): Add "crtlibid%O%s"
	* config/bfin/uclinux.h (STARFILE_SPEC): Likewise.
	* config/bfin/t-bfin-elf (EXTRA_PARTS, EXTRA_MULTILIB_PARTS): Add
	crtlibid.o.
	($(T)crtlibid.o): New rule.

2005-11-16  Richard Guenther  <rguenther@suse.de>

	PR middle-end/24851
	* fold-const.c (extract_array_ref): Return byte offset
	in all cases.
	(fold_binary): Fold &x[a] CMP &x[b] to
	a*sizeof(*x) CMP b*sizeof(*x) to get correct overflow
	behavior.

2005-11-16  Richard Henderson  <rth@redhat.com>

	PR middle-end/23497
	* tree-ssa.c (warn_uninitialized_var): Skip real and imaginary
	parts of an SSA_NAME.

2005-11-16  Richard Earnshaw  <richard.earnshaw@arm.com>

	PR target/24861
	* arm.md (split for movsf with immediate): Restrict split to insns
	that set a general register.

2005-11-16  Daniel Jacobowitz  <dan@codesourcery.com>

	* config/ia64/unwind-ia64.c (uw_advance_context): New.  Call
	uw_update_context.
	* unwind-dw2.c (uw_advance_context): Likewise.
	* unwind-sjlj.c (uw_advance_context): Likewise.  Also call
	_Unwind_SjLj_Unregister.
	* unwind.inc (_Unwind_ForcedUnwind_Phase2): Call uw_advance_context.

2005-11-16  Daniel Jacobowitz  <dan@codesourcery.com>

	* unwind-sjlj.c (_Unwind_GetCFA): Handle the builtin_setjmp case.

2005-11-16  Eric Botcazou  <ebotcazou@adacore.com>

	* config/alpha/alpha.c (alpha_init_builtins): Use type_for_mode
	langhook to get a DImode integer type.

2005-11-16  Richard Henderson  <rth@redhat.com>
	    J"orn Rennecke <joern.rennecke@st.com>
	    Ulrich Weigand  <uweigand@de.ibm.com>

	PR rtl-opt/24160
	PR target/24621
	* reload1.c (reg_equiv_invariant): New.
	(reload): Allocate, initialize, and free it.
	(calculate_needs_all_insns): Check it when skipping equivalence
	setting insns.
	(alter_reg): Likewise.
	(eliminate_regs_1): Rename from eliminate_regs.  Add new
	may_use_invariant argument; only use reg_equiv_invariant when true.
	(eliminate_regs): New.
	(eliminate_regs_in_insn): Use eliminate_regs_1; track when we're in
	a context for which may_use_invariant may be true.

2005-11-16  Eric Botcazou  <ebotcazou@adacore.com>

	* fold-const.c (const_binop): Don't constant fold the operation
	if the result has overflowed and flag_trapping_math.
	* simplify-rtx.c (simplify_const_binary_operation): Likewise.

2005-11-16  Daniel Jacobowitz  <dan@codesourcery.com>

	* config/arm/unwind-arm.c (abort): Add prototype here.
	(UCB_FORCED_STOP_ARG): Correct typo in macro argument.
	(struct phase1_vrs): Add prev_sp.
	(unwind_phase2_forced): Save the original core registers instead of
	modifying entry_vrs.  Take a new flag argument for resuming unwinding
	and set action flags accordingly.  Always set _US_END_OF_STACK when
	get_eit_entry fails.  Unwind before calling the stop function.
	(_Unwind_GetCFA): New function.
	(__gnu_Unwind_ForcedUnwind): Update call to unwind_phase2_forced.
	(__gnu_Unwind_Resume_or_Rethrow): Likewise.
	(__gnu_Unwind_Resume): Do not unwind here for forced unwinding;
	just call unwind_phase2_forced.
	(_Unwind_GetDataRelBase, _Unwind_GetTextRelBase): Move to here.
	* config/arm/unwind-arm.h (abort): Remove prototype.
	(_Unwind_GetDataRelBase, _Unwind_GetTextRelBase): Change to
	prototypes.
	(_Unwind_GetCFA): New prototype.
	* config/arm/pr-support.c (abort): Add prototype here.
	* unwind-c.c (PERSONALITY_FUNCTION) [__ARM_EABI_UNWINDER__]: Handle
	forced unwinding.
	* config/arm/arm.c (arm_expand_prologue, thumb_expand_prologue): Do
	not schedule the prologue with non-call exceptions and EABI.

2005-11-16  Nathan Sidwell  <nathan@codesourcery.com>

	* config/arm/unwind-arm.h: Reorder interface function declarations.
	(_URC_END_OF_STACK): New enumeration value.
	(_US_UNWIND_ACTION_MASK, _US_FORCE_UNWIND, _US_END_OF_STACK): Likewise.
	(struct _Unwind_Control_Block): Document reserved field use.
	(_Unwind_Stop_Fn): New typedef.
	(_Unwind_ForcedUnwind): Declare.
	(_Unwind_Resume_or_Rethrow): Declare.
	* config/arm/libunwind.S (UNWIND_WRAPER): Add nargs
	argument.  Adjust.
	(_Unwind_Resume_or_Rethrow, _Unwind_ForcedUnwind): New.
	* config/arm/unwind-arm.c (UCB_FORCED_STOP_FN)
	(UCB_FORCED_STOP_ARG): New.
	(search_EIT_table): Update boundary condition checks.
	(get_eit_entry): Return _URC_END_OF_STACK when cannot unwind.
	(unwind_phase2): Replace for with do..while.
	(unwind_phase2_forced): New.
	(__gnu_Unwind_RaiseException): Replace for with do..while.
	(__gnu_Unwind_ForcedUnwind): New.
	(__gnu_Unwind_Resume): Set FORCE_UNWIND flag, if forced unwinding.
	Use appropriate phase2 unwinder.
	(__gnu_Unwind_Resume_or_Rethrow): New.
	(__gnu_unwind_pr_common): Cope with forced unwinding.

2005-11-16  David Edelsohn  <edelsohn@gnu.org>

	PR target/24772
	* config/rs6000/predicates.md (vrsave_operation): SET_SRC is a VEC.

	* config/rs6000/rs6000.md (btruncsf2, ceilsf2, floorsf2,
	roundsf2): Remove "s" from mnemonic.

2005-11-16  Bernd Schmidt  <bernd.schmidt@analog.com>

	* config/bfin/crti.s (__init, __fini): Use appropriate prologue if
	__PIC__ is defined.
	* config/bfin/crtn.s: Change epilogues to match.
	* config/bfin/t-bfin-elf (EXTRA_MULTILIB_PARTS): Define.
	* config/bfin/bfin.h (TARGET_CPU_CPP_BUILTINS): If flag_pic, define
	__PIC__ and __pic__.

2005-11-16  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR 24357
	* doc/invoke.texi: Distinguish between free and fixed form instead of
	Fortran and Fortran 90/95.  Remove ratfor from the list of supported
	languages.
	* gcc.c (default_compilers): Remove double entries, add entries for
	suffixes '.F90' and '.F95'.

2005-11-16  Eric Botcazou <ebotcazou@adacore.com>

	* config/alpha/alpha.c (alpha_expand_prologue): Fix off-by-one bug
	in the stack probing loop.

2005-11-15  David Edelsohn  <edelsohn@gnu.org>

	* configure.ac: Use .machine power5 not power5x.
	* configure: Regenerate.

2005-11-15  Mike Stump  <mrs@apple.com>

	* c-decl.c (lookup_name_two): Add.
	* c-tree.h (lookup_name_two): Likewise.
	* c-common.c (handle_cleanup_attribute): Use lookup_name_two instead.
	* config/darwin-c.c (darwin_pragma_unused): Likewise.

2005-11-16  Alan Modra  <amodra@bigpond.net.au>

	PR rtl-optimization/23392
	* regrename.c (enum scan_actions) Add mark_access.
	(scan_actions_name): Ditto.
	(scan_rtx_reg): Handle mark_access.
	(scan_rtx_address): Do nothing for mark_access.
	(build_def_use): Mark source registers in REG_FRAME_RELATED_EXPR
	and regs in REG_INC notes before closing chains for dead regs.
	Mark destination regs in REG_FRAME_RELATED_EXPR notes after
	opening chains for new writes.

2005-11-15  David Edelsohn  <edelsohn@gnu.org>

	* c.opt (ffixed-line-length-none): New.

2005-11-15  Steve Ellcey  <sje@cup.hp.com>

	* mklibgcc.in: Change contents of eh_dummy.c.

2005-11-15  Daniel Jacobowitz  <dan@codesourcery.com>

	* loop.c (scan_loop): Do not insert temporaries for hard registers.

2005-11-15  Daniel Jacobowitz  <dan@codesourcery.com>

	* config/arm/lib1funcs.asm (div0) [L_dvmd_lnx]: Call raise instead
	of making syscalls.
	* config/arm/linux-eabi.h (CLEAR_INSN_CACHE): Define.  Set r7 also.

2005-11-15  Jan Hubicka  <jh@suse.cz>

	* invoke.texi (large-unit-insns): Document.
	* ipa-inline.c (cgraph_decide_inlining): Use large-unit-insns param.
	* params.def (large-unit-insns): New param.

2005-11-15  Hans-Peter Nilsson  <hp@axis.com>

	PR target/24869
	* config/cris/cris.md ("*mov_sidesisf_mem"): Do not match
	special register for operand 3.  Reindent constraints to align
	them vertically.

2005-11-14  David Edelsohn  <edelsohn@gnu.org>

	* doc/invoke.texi (RS/6000 and PowerPC Options): Add -mmfcrf,
	-mpopcntb, -mfprnd. Add -mcpu=power5+.
	* configure.ac: Add test for FP rounding instructions.
	* configure: Regenerate.
	* config.in: Regenerate.
	* config/rs6000/rs6000-c.c (rs6000_cpu_cpp_builtins): Define
	_ARCH_PPCSQ, _ARCH_PPCGR, _ARCH_PWR4, _ARCH_PWR5, _ARCH_PWR5X if
	features enabled.
	* config/rs6000/rs6000.opt (mfprnd): New.
	* config/rs6000/rs6000.c (processor_target_table): Add power5+.
	(POWERPC_MASKS): Add MASK_POPCNTB and MASK_FPRND.
	* config/rs6000/aix52.h (ASM_CPU_SPEC): Add -mpower5+.
	* config/rs6000/rs6000.h (ASM_CPU_SPEC): Add -mpower5+.
	(TARGET_FPRND): New.
	* config/rs6000/rs6000.md (UNSPEC_FRIM, UNSPEC_FRIN, UNSPEC_FRIP,
	UNSPEC_FRIZ): New.
	(btrunc<mode>2): New.
	(ceil<mode>2): New.
	(floor<mode>2): New.
	(round<mode>2): New.

2005-11-14  Geoffrey Keating  <geoffk@apple.com>

	* gcc.c (version_compare_spec_function): Use fatal() rather than
	abort().

	* config/rs6000/darwin.h (DARWIN_CRT2_SPEC): New.
	(SUBTARGET_EXTRA_SPECS): Define %(darwin_crt2).
	* config/i386/darwin.h (SUBTARGET_EXTRA_SPECS): Define %(darwin_crt2)
	as empty.
	* config/darwin.h (STARTFILE_SPEC): Use %(darwin_crt2) to possibly
	link in crt2.o.
	
	* config/darwin.h (REAL_LIBGCC_SPEC): Link in shared libgcc depending
	on -mmacosx-version-min setting.

2005-11-14  Diego Novillo  <dnovillo@redhat.com>

	PR 24840
	* tree-vrp.c (infer_value_range): Return false if STMT is a
	block terminator and its basic block has no successors.

2005-11-14  Mike Stump  <mrs@apple.com>

	* config/i386/i386.c (override_options): -masm=intel isn't
	supported on darwin.
	* doc/invoke.texi (i386 and x86-64 Options): Likewise.

2005-11-15  Joseph S. Myers  <joseph@codesourcery.com>

	* crtstuff.c: Undefine gid_t, pid_t, rlim_t, ssize_t, uid_t and
	vfork after including auto-host.h.

2005-11-15  Alan Modra  <amodra@bigpond.net.au>

	PR rtl-optimization/22002
	* combine.c (distribute_notes): Detect cases where a reg dies
	two or more times in a bb, including on the insn we are combining,
	and place the death note on the correct range.

2005-11-14  Dale Johannesen  <dalej@apple.com>

	* expmed.c (store_bit_field):  Add offset unconditionally for
	memory targets.
	(extract_bit_field):  Don't force extzv or extv operand into
	a register if field is too big.

2005-11-14  Daniel Jacobowitz  <dan@codesourcery.com>

	* config/arm/arm.c (pic_labelno): New.
	(arm_load_pic_register): Use an UNSPEC_PIC_LABEL instead of a
	LABEL_REF.  Pass only the labelno to PIC insns.
	(arm_call_tls_get_addr, legitimize_tls_address): Likewise.
	(arm_output_addr_const_extra): Handle UNSPEC_PIC_LABEL.
	* arm.md (UNSPEC_PIC_LABEL): New constant.
	(pic_add_dot_plus_four, pic_add_dot_plus_eight)
	(tls_load_dot_plus_eight): Expect a labelno instead of a LABEL_REF.
	Use the correct label prefix.

2005-11-14  Daniel Jacobowitz  <dan@codesourcery.com>

	* config/arm/arm.c (legitimize_tls_address): Use correct rtx for
	REQ_EQUIV note.

2005-11-14  Richard Earnshaw  <richard.earnshaw@arm.com>

	* loop-invariant.c: Include tm_p.h.
	* Makefile.in: Updated.

2005-11-13  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (store_reg): Revise generation of frame notes in large frames.
	(set_reg_plus_d): Likewise.

2005-11-13  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/24709
	* tree-ssa-operands.c (verify_imm_links): Increase limit for infinite
	loop check.

2005-11-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* gthr-posix95.h: Remove declaration of pthread_mutexattr_settype
	and duplicate declaration of pthread_self.

2005-11-13  Eric Botcazou  <ebotcazou@adacore.com>
	    Ian Lance Taylor  <ian@airs.com>

	PR middle-end/24003
	* calls.c (expand_call): If TARGET is a MEM and some part of the
	argument area has been saved, force TARGET to a register.

2005-11-13  Razya Ladelsky <razya@il.ibm.com>

	* ipa-prop.c (ipa_callsite_compute_param ): Removed obsolete type 
	checking.

2005-11-13  Jason Merrill  <jason@redhat.com>

	PR c++/22489
	* dwarf2out.c (gen_subprogram_die): Force a declaration die for
	lazily declared methods.
	(force_decl_die): Stop if forcing out the context already make a
	DIE for the decl.
	(force_type_die): Likewise.

2005-11-13  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/24820
	* builtins.c (integer_valued_real_p): Add break in
	REAL_CST having TREE_OVERFLOW set.

2005-11-13  Zdenek Dvorak  <dvorakz@suse.cz>

	* tree-ssa-loop-ivopts.c (get_address_cost): Prevent splitting
	addressing modes during calculation of costs.

2005-11-12  Eric Botcazou  <ebotcazou@adacore.com>

	* function.c (assign_stack_local_1): Restrict sanity check
	on frame size overflow to 32-bit and above platforms.

2005-11-12  Hans-Peter Nilsson  <hp@axis.com>

	* config/cris/cris.h (LEGITIMIZE_RELOAD_ADDRESS): Define.
	* config/cris/cris.c: Include reload.h.
	(cris_initial_elimination_offset): New function.
	* config/cris/cris-protos.h: (cris_initial_elimination_offset):
	Prototype.

2005-11-12  Richard Guenther  <rguenther@suse.de>

	* gcse.c (find_rtx_in_ldst): Handle NULL pre_ldst_table.

2005-11-12  Jan Hubicka  <jh@suse.cz>

	* expr.c (expand_expr_real_1): <MAX_EXPR, MIN_EXPR>: Canonicalize
	to compare against 0 when possible.

2005-11-12  Jie Zhang  <jie.zhang@analog.com>

	* config/bfin/bfin.h (REGISTER_NAMES, SHORT_REGISTER_NAMES,
	HIGH_REGISTER_NAMES, FIXED_REGISTERS, CALL_USED_REGISTERS,
	REG_ALLOC_ORDER, enum reg_class): Rearrange I/B/L registers.
	* config/bfin/bfin.md: Redefine REG_ constants for I/B/L registers
	in the new order.

2005-11-12  Hans-Peter Nilsson  <hp@axis.com>

	* recog.c (constrain_operands) <case 'g'>: For a match, require
	that a non-register matches general_operand when strict >= 0.

2005-11-11  Steven Bosscher  <stevenb@suse.de>

	* loop-invariant.c (move_loop_invariants): Fix a thinko in the
	previous checkin.

2005-11-11  Daniel Jacobowitz  <dan@codesourcery.com>

	* tree-ssa-dse.c (struct address_walk_data, memory_ssa_name_same)
	(memory_address_same): New.
	(dse_optimize_stmt): Call memory_address_same.

2005-11-12  Hans-Peter Nilsson  <hp@axis.com>

	PR middle-end/24750
	* reload.c (find_reloads_address_1) <case TRUNCATE, SIGN_EXTEND,
	ZERO_EXTEND>: New cases.

2005-11-11  Daniel Jacobowitz  <dan@codesourcery.com>

	* longlong.h (__clz_tab): Always provide.

2005-11-11  Steven Bosscher  <stevenb@suse.de>

	PR 24265
	* loop-invariant.c (may_assign_reg_p): Make sure a hard register
	can be assigned to.
	(find_invariant_insn): Do the cheapest check, may_assign_reg_p,
	before check_maybe_invariant.
	(move_invariant_reg): Use gen_move_insn instead of replacing
	SET_DEST with the temporary for the invariant.
	(move_loop_invariants): If checking is enabled, do internal
	consistency checks after completing the pass.

2005-11-11  David Edelsohn  <edelsohn@gnu.org>

	PR 24644
	* common.opt (Wvolatile-register-var): New.
	* varasm.c (make_decl_rtl): Only emit warning when option
	specified.  Clarify warning message.
	* doc/invoke.texi (Wvolatile-register-var): Document new option.

	* doc/md.texi (copysign): Document standard named pattern.

2005-11-11  Jie Zhang  <jie.zhang@analog.com>

	* config/bfin/bfin.c (bfin_expand_strmov): Correctly move the trailing
	bytes when align is 2.
	* config/bfin/bfin.md (rep_movsi, rep_movhi): Make LSETUP be followed
	by the first instruction of the loop.

2005-11-11  Jason Merrill  <jason@redhat.com>

	PR c++/24686
	* gimplify.c (gimplify_cleanup_point_expr): Also save and restore 
	the cleanup list.

2005-11-11  Zdenek Dvorak  <dvorakz@suse.cz>

	PR rtl-optimization/22509
	* local-alloc.c (memref_used_between_p): Check whether a function call
	could not reference the memref.

2005-11-11  Ulrich Weigand  <uweigand@de.ibm.com>

	* postreload.c (reload_cse_simplify_operands): Fix bug in sorting
	algorithm so as to choose the best, not the worst, alternative.
	Reset accumulated register class before processing next alternative.

2005-11-11  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/24445
	* calls.c (expand_call): Copy a return value to a plain register
	if needed.

2005-11-10  Alexandre Oliva  <aoliva@redhat.com>

	PR target/24778
	* varasm.c (assemble_name): Recompute name only for transparent
	aliases.

2005-11-10  Hans-Peter Nilsson  <hp@axis.com>

	* tree-ssa-structalias.c (heapvar_lookup): Fix typo: stmt to from.

2005-11-04  Jeff Law  <law@redhat.com>

	PR middle-end/23181
	* tree-ssa-dom.c (simplify_rhs_and_lookup_avail_expr): Do not
	perform reassociation if the parent statement will not die as
	a result of the optimization.

2005-11-10  Daniel Berlin  <dberlin@dberlin.org>

	* tree-ssa-alias.c (compute_may_aliases): Remove call to 
	delete_old_heap_vars.
	* tree-dfa.c (referenced_var_remove): Remove function.
	* tree-ssa.c (init_tree_ssa): Call init_alias_heapvars.
	(delete_tree_ssa): Remove call to delete_old_heapvars.
	Add call to delete_alias_heapvars.
	* tree-flow.h (referenced_var_remove): Remove prototype
	(init_alias_heapvars): New prototype.
	(delete_alias_heapvars): Ditto.
	* Makefile.in (tree-ssa-structalias.o): Add
	gt-tree-ssa-structalias.o
	(GTFILES): Add tree-ssa-structalias.h and
	tree-ssa-structalias.c.
	(s-gtype): Add gt-tree-ssa-structalias.h.
	* tree-ssa-structalias.c (heapvars): Remove.
	(oldheapvars): Remove.
	(heapvar_for_stmt): New variable.
	(heapvar_lookup): New function.
	(heapvar_insert): Ditto.
	(get_constraint_for): See if we have an old heapvar
	to reuse.
	(init_alias_heapvars): New function.
	(delete_alias_heapvars): Ditto.
	Add include of gt-tree-ssa-structalias.h.

2005-11-10  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR middle-end/22127
	* calls.c (special_function_p): Set ECF_RETURNS_TWICE for getcontext.

2005-11-10  Eric Botcazou  <ebotcazou@adacore.com>

	* tree.c (int_fits_type_p): Only look at the base type
	if it has the same precision as the original type.

2005-11-10  Jakub Jelinek  <jakub@redhat.com>

	PR other/4372
	* varasm.c (assemble_alias): Use %q+D in the error
	message instead of %J and %qD.

2005-11-10  Richard Guenther  <rguenther@suse.de>

	* gcse.c (free_ldst_entry): Only free hashtable if
	it exists.

2005-11-09  Eric Botcazou  <ebotcazou@adacore.com>

	* function.c (assign_stack_local_1): Issue an error message if
	the frame size overflows in the signed target arithmetics.

2005-11-09  Eric Botcazou  <ebotcazou@adacore.com>

	* tree.c (build_qualified_type): Chain the new type to the original
	type's TYPE_NEXT_PTR_TO or TYPE_NEXT_REF_TO linked lists if it is
	a POINTER_TYPE or a REFERENCE_TYPE respectively.
	(build_pointer_type_for_mode): Only return unqualified types.
	(build_reference_type_for_mode): Likewise.

2005-11-09  Jakub Jelinek  <jakub@redhat.com>

	* Makefile.in (gnucompare): Do comparison of all files using one of
	the chosen methods and only afterwards decide if just warning should
	be issued or comparison failure raised.

2005-11-09  Eric Botcazou  <ebotcazou@adacore.com>

	* ifcvt.c (noce_get_alt_condition): Use prev_nonnote_insn.
	(noce_try_abs): Negate if the comparison is reversed.
	Look only one instruction backwards for a REG_EQUAL note.

2005-11-09  Alexandre Oliva  <aoliva@redhat.com>

	PR other/4372
	* gthr-dce.h, gthr-posix.h, gthr-posix95.h, gthr-solaris.h,
	gthr-tpf.h: Define __gthrw.  For all identifiers that might
	be weak, introduce weakrefs or non-weak aliases with __gthrw,
	and prefix all uses with __ghtrw.

2005-11-09  Alexandre Oliva  <aoliva@redhat.com>

	PR other/4372
	* tree.h (IDENTIFIER_TRANSPARENT_ALIAS): New.
	(TREE_DEPRECATED): Adjust comment.  Check for a DECL.
	* c-common.c (handle_weakref_attribute): New.
	(c_common_attribute_table): Add weakref.
	* configure.ac (HAVE_GAS_WEAKREF): Check for weakref support
	in the assembler.
	* configure, config.in: Rebuilt.
	* defaults.h (ASM_OUTPUT_WEAKREF): Define if HAVE_GAS_WEAKREF.
	* doc/extend.texi: Document weakref attribute.
	* varasm.c (ultimate_transparent_alias_target): New
	(assemble_name): Use it.
	(weak_finish_1): Split out of...
	(weak_finish): ... and deal with weakrefs in...
	(weakref_targets): ... new list.
	(globalize_decl): Clean up weakref_targets.
	(do_assemble_alias): Handle weakrefs.
	(finish_aliases_1): Do not reject weakrefs to external symbols.
	(assemble_alias): Handle weakrefs.

2005-11-09  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/24716
	* tree-scalar-evolution.c (analyze_evolution_in_loop): Use
	t_bool to track results from follow_ssa_edge.

2005-11-09  Eric Botcazou  <ebotcazou@adacore.com>

	* final.c (force_source_line): New global variable.
	(final_scan_insn): Set it to true instead of clearing last_filename.
	(notice_source_line): Return true if force_source_line is true,
	unless source info is absent.

2005-11-09  Andrew Pinski  <pinskia@physics.uc.edu>

	PR c/24644
	* dwarf2-out.c (add_name_and_src_coords_attributes): Don't add
	a linkage name for a variable if it a register variable.
	* c-decl.c (grokdeclarator): Global register variables
	should be set as PUBLIC.

2005-11-09  Andreas Krebbel  <krebbel1@de.ibm.com>

	PR 24624
	* config/s390/s390.c (struct s390_frame_layout): New fields 
	first_save_gpr_slot and last_save_gpr_slot.
	(cfun_grps_save_area_size, s390_frame_info, s390_emit_prologue,  
	s390_emit_epilogue, s390_initial_elimination_offset): Replaced 
	first_save_gpr and last_save_gpr with the _slot variants.
	(s390_register_info): Calculate first_save_gpr_slot and 
	last_save_gpr_slot using regs_ever_live.

2005-11-09  Andreas Krebbel  <krebbel1@de.ibm.com>

	PR 24623
	* config/s390/s390.c (s390_regs_ever_clobbered): Only save live eh regs
	for a function containing a landing pad.

2005-11-09  Andreas Krebbel  <krebbel1@de.ibm.com>

	PR 24034
	* flow.c (mark_set_1): Handle CLOBBERs like SETs if the register
	is live afterwards.

2005-11-08  Bernd Schmidt  <bernd.schmidt@analog.com>

	* config/bfin/t-bfin-elf (MULTILIB_OPTIONS, MULTILIB_DEFAULTS,
	MULTILIB_DIRNAMES, MULTILIB_EXCEPTIONS): New.

2005-11-09  Nathan Sidwell  <nathan@codesourcery.com>

	Add ms2 support
	* config/ms1/ms1.md (UNSPEC_BLOCKAGE, UNSPEC_EI, UNSPEC_DI): New
	constants.
	(call,load,store): New insn types.
	(mem_access, branch_access): Adjust reservation conditions.
	(define_delay): Adjust condition.
	(decrement_and_branch_until_zero): Allow for ms2.  Set branch
	type.
	(*decrement_and_rbanch_until_zero_no_clobber): Allow for ms2.
	(*movqi_internal,*movsi_internal,*movsf_internal): Use load,store
	insn type.
	(call_internal, call_value_internal, return_internal,
	return_interrupt_internal, eh_return_internal, indirect_jump,
	tablejump): Set call insn type.
	(blockage, ei, di): Use appropriate unspec const.
	* config/ms1/ms1.c (ms1_flag_delayed_branch): New.
	(ms1_get_attr_type): Adjust to give load & store types.
	(ms1_final_prescan_insn): Adjust for new insn types.  Don't look
	backwards past a barrier.
	(ms1_override_options): Accept ms2 arch.  Copy and reset delayed
	branch scheduling.
	(struct branch_info, struct label_info): New.
	(ms1_labels): New.
	(ms1_add_branches, ms1_check_delay_slot, ms1_reorg_hazard): New.
	(ms1_machine_reorg): New.
	(TARGET_MACHINE_DEPENDENT_REORG): Override.
	* config/ms1/crtn.asm: Add nop for ms2 JAL hazard.
	* config/ms1/ms1.h (processor_type): Add PROCESSOR_MS2.
	(ASM_SPEC, LIB_SPEC, STARTFILE_SPEC, ENDFILE_SPEC): Add ms2.
	(TARGET_MS2): New.

2005-11-09  Per Bothner  <per@bothner.com>
	    Uros Bizjak  <uros@kss-loka.si>
	
	PR c/24101
	* toplev.c (process_options): Initialize debug_hooks early
	in case lang_hooks.post_options ends up calling a debug_hook.

2005-11-08  Jakub Jelinek  <jakub@redhat.com>

	* dwarf2out.c (multiple_reg_loc_descriptor): Don't assume
	DBX_REGISTER_NUMBER being contiguous.

2005-11-08  James A. Morrison  <phython@gcc.gnu.org>
	    Diego Novillo  <dnovillo@redhat.com>

	PR 23046
	* tree-vrp.c (register_edge_assert_for): Do not register
	always-false predicates.

2005-11-08  Devang Patel <dpatel@apple.com>

	PR tree-optimization/23115
	* tree-if-conv.c (find_phi_replacement_condition): Check domninated_by
	relation.

2005-11-08  Joseph S. Myers  <joseph@codesourcery.com>

	* config/rs6000/t-fprules (MULTILIB_MATCHES_FLOAT): Include
	-mcpu=440.

2005-11-08  Daniel Berlin  <dberlin@dberlin.org>

	Fix PR tree-optimization/23382

	* tree-ssa-alias.c (compute_may_aliases): Call
	delete_old_heap_vars.
	* tree-dfa.c (referenced_var_remove): New function.
	* tree-ssa.c (delete_tree_ssa): Call delete_old_heap_vars.
	* tree-flow.h (referenced_var_remove): Add prototype.
	(delete_old_heap_vars): Ditto.
	* tree-ssa-structalias.c (heapvars): New variable.
	(oldheapvars): Ditto.
	(get_constraint_for): Put heap vars on heapvars list.
	(delete_old_heap_vars): New function.
	
2005-11-08  Jason Merrill  <jason@redhat.com>

	* tree.h (CALL_FROM_THUNK_P): Add CALL_EXPR_CHECK.

2005-11-08  Uros Bizjak  <uros@kss-loka.si>

	PR target/19340
	* reg-stack.c (reg_to_stack): Update register liveness also
	for flag_sched2_use_traces.

2005-11-08  Alan Modra  <amodra@bigpond.net.au>

	PR target/23704
	* config/rs6000/rs6000.c (rs6000_handle_option <OPT_m64>): Don't
	override prior explicit -mno-powerpc-gfxopt.

2005-11-07  Eric Botcazou  <ebotcazou@adacore.com>

	* expmed.c (extract_bit_field): Do not use insv/extv/extzv patterns
	if the bitsize is zero.
	* doc/md.texi (Standard Pattern Names): Document it.

	* config/ia64/ia64.c (ia64_pass_by_reference): Delete.
	(TARGET_PASS_BY_REFERENCE): Likewise.

2005-11-07  Ian Lance Taylor  <ian@airs.com>

	PR rtl-optimization/24683
	* config/i386/i386.c (legitimize_pic_address): If constant operand
	to PLUS is too large, put it in a register.

2005-11-07  Jie Zhang  <jie.zhang@analog.com>

	* configure.ac: Enable checking assembler dwarf2 support for bfin
	target.
	* configure: Regenerate.

2005-11-07  Paolo Bonzini  <bonzini@gnu.org>

	PR target/24230

	* config/rs6000/rs6000.c (easy_vector_splat_const, easy_vector_same,
	gen_easy_vector_constant_add_self): Delete.
	(vspltis_constant, easy_altivec_constant, gen_easy_altivec_constant):
	New.
	(output_vec_const_move): Use gen_easy_altivec_constant.
	(rs6000_expand_vector_init): Do not emit a set of a VEC_DUPLICATE.
	* config/rs6000/predicates.md (easy_vector_constant): Reorganize tests.
	(easy_vector_constant_add_self): Rewritten.
	* config/rs6000/rs6000-protos.h (easy_vector_splat_const,
	easy_vector_same, gen_easy_vector_constant_add_self): Remove prototype.
	(easy_altivec_constant, gen_easy_altivec_constant): Add prototype.
	* config/rs6000/altivec.md (easy_vector_constant_add_self splitters):
	Macroize and adjust for the other changes.

2005-11-07  Paolo Bonzini  <bonzini@gnu.org>

	PR c/24599

	* c-typeck.c (build_c_cast): Try using a shared constant, and see
	if TREE_OVERFLOW or TREE_CONSTANT_OVERFLOW really changed.

2005-11-07  Jakub Jelinek  <jakub@redhat.com>

	PR rtl-optimization/23567
	* ifcvt.c (noce_mem_write_may_trap_or_fault_p): New function.
	(noce_process_if_block): Don't do any optimizations except
	if (cond) x = x; if !set_b and write into orig_x may trap
	or fault.  Remove the MEM_READONLY_P check.

2005-11-06  Diego Novillo  <dnovillo@redhat.com>

	PR 24670
	* tree-vrp.c (fix_equivalence_set): New.
	(extract_range_from_assert): Call it.

2005-11-05  Ian Lance Taylor  <ian@airs.com>

	PR target/22432
	* combine.c (apply_distributive_law): Don't distribute across a
	vector mode subreg.

2005-11-05  Kazu Hirata  <kazu@codesourcery.com>

	* c-typeck.c, config/i386/netware.h, config/m32c/cond.md,
	config/ms1/ms1.h, config/rs6000/predicates.md,
	config/s390/s390.c, params.def, postreload-gcse.c,
	tree-flow-inline.h, tree-ssa-operands.c, tree-vectorizer.c,
	tree-vrp.c, tree.c: Fix comment typos.
	* doc/invoke.texi: Fix typos.

2005-11-05  Sebastian Pop  <pop@cri.ensmp.fr>

	* lambda-code.c (lambda_transform_legal_p): Use DDR_NUM_DIST_VECTS
	for testing whether the data_dependence_relation contains distance
	vectors.  Iterate over all distance vectors of the ddr.
	* lambda.h: Define a vec of lambda_vector pointers.
	* tree-data-ref.c (dump_data_dependence_relation,
	dump_data_dependence_direction): Iterate over all distance and
	direction vectors of the ddr.
	(initialize_data_dependence_relation): Initialize DDR_DIR_VECTS and
	DDR_DIST_VECTS.
	(build_classic_dist_vector, build_classic_dir_vector): Push a set
	of distance/direction vectors instead of a single one.
	* tree-data-ref.h (dir_vects, dist_vects): Replace dir/dist 
	lambda_vectors with a vec of lambda_vectors.
	(DDR_DIR_VECT, DDR_DIST_VECT): Redefined as operations on vec.
	(DDR_DIR_VECTS, DDR_DIST_VECTS, DDR_NUM_DIR_VECTS,
	DDR_NUM_DIST_VECTS): New.
	* tree-loop-linear.c (gather_interchange_stats): Test for the
	existence of distance vectors only after having checked that there
	is a dependence.  Iterate over all distance vectors of the ddr.
	(linear_transform_loops): Use dump_data_dependence_relation.
	* tree-vect-analyze.c (vect_analyze_data_ref_dependence): Test for
	distance vectors using DDR_NUM_DIST_VECTS.  Iterate over all the
	distance vectors of the ddr.

2005-11-05  Bernd Schmidt  <bernd.schmidt@analog.com>

	* config/bfin/bfin.c (n_dregs_to_save, n_pregs_to_save,
	expand_prologue_reg_save, expand_epilogue_reg_restore): New argument
	IS_INTHANDLER; all callers changed.
	(n_regs_saved_by_prologue): Take interrupt handler attributes into
	account.
	(do_link, do_unlink): New argument ALL; all callers changed.
	(expand_interrupt_handler_prologue, expand_interrupt_handler_epilogue):
	If function isn't leaf, save and restore all registers.
	(bfin_function_ok_for_sibcall): Only true if not an interrupt or
	exception handler.

2005-11-05  Jan Hubicka  <jh@suse.cz>

	PR rtl-optimization/23490
	* doc/invoke.texi (max-predicted-iterations, max-cse-insns,
	max-flow-memory-location): Document.
	* flow.c: Include params.h
	(MAX_MEM_SET_LIST_LEN): Kill.
	(add_to_mem_set_list): Use new param.
	* cse.c (cse_basic_block): Replace 1000 by new param.
	* params.def (PARAM_MAX_PREDICTED_ITERATIONS, PARAM_MAX_CSE_INSNS,
	PARAM_MAX_FLOW_MEMORY_LOCATIONS): New.
	* predict.c (predict_loops): Use new param.
	* predict.def (MAX_PRED_LOOP_ITERATIONS): Remove.

	* ipa-inline.c (cgraph_decide_inlining_of_small_function, 
	cgraph_decide_inlining, cgraph_decide_inlining_incrementally):
	Do not hold memory returned by cgraph_node_name across other call.

2005-11-04  Hans-Peter Nilsson  <hp@axis.com>

	PR target/23424
	* config/cris/predicates.md ("cris_bdap_sign_extend_operand"):
	Disable.

2005-11-04  Jeff Law  <law@redhat.com>

	PR/21883
	* doc/invoke.texi: Document max-jump-thread-duplication-stmts PARAM.
	* tree-ssa-dom.c: Include params.h.
	(thread_across_edge): If there are too many statements in the
	target block, then do not thread through it.
	* Makefile.in (tree-ssa-dom.o): Depend on $(PARAMS_H).
	* params.def (PARAM_MAX_JUMP_THREAD_DUPLICATION_STMTS): New PARAM.

2005-11-03  Diego Novillo  <dnovillo@redhat.com>

	PR 24627
	* tree-ssa-dce.c (pass_dce, pass_dce_loop, pass_cd_dce): Use
	TODO_update_ssa instead of TODO_update_ssa_no_phi.

2005-11-04  Sebastian Pop  <pop@cri.ensmp.fr>

	PR/18595
	* tree-scalar-evolution.c (instantiate_parameters_1,
	instantiate_parameters, resolve_mixers): Compute the size of an
	expression to be instantiated and give up the instantiation if the
	size exceeds PARAM_SCEV_MAX_EXPR_SIZE.

2005-11-04  Richard Guenther  <rguenther@suse.de>

	* tree-flow.h (ref_contains_indirect_ref): Rename to
	array_ref_contains_indirect_ref.
	* tree-flow-inline.h (ref_contains_indirect_ref): Likewise.
	(array_ref_contains_indirect_ref): Make comment match the code
	and vice-versa.
	(ref_contains_array_ref): Likewise.
	* tree-ssa-structalias.c (find_func_aliases): Remove call to
	ref_contains_indirect_ref.
	* tree-ssa-loop-niter.c (infer_loop_bounds_from_undefined):
	Rename calls to ref_contains_indirect_ref.

2005-11-04 Paul Brook  <paul@codesourcery.com>

	* config/arm/arm.c (arm_load_pic_register): Pass extra reg to
	gen_pic_add_dot_plus_four and gen_pic_add_dot_plus_eight.
	(arm_call_tls_get_addr, legitimize_tls_address): Likewise.
	* config/arm/arm.md: Use match_operand in peephole input templates
	and match_dup in peephole output templates.

2005-11-04  Daniel Jacobowitz  <dan@codesourcery.com>

	* config/arm/arm.c (arm_init_libfuncs): Use __aeabi_idiv and
	__aeabi_uidiv.

2005-11-04  Mark Mitchell  <mark@codesourcery.com>
	    Daniel Jacobowitz  <dan@codesourcery.com>

	* longlong.h (add_ssaaaa): Clobber condition code register
	in ARM version.
	(sub_ddmmss): Likewise.
	(umul_ppmm): Likewise.

2005-11-04  Daniel Jacobowitz  <dan@codesourcery.com>
	    Paul Brook  <paul@codesourcery.com>
	    Phil Blundell  <pb@reciva.com>

	* configure.ac: Add test for ARM TLS support.
	* configure: Regenerated.
	* config/arm/arm-protos.h (legitimize_tls_address)
	(arm_tls_referenced_p, tls_mentioned_p)
	(arm_output_addr_const_extra): New prototypes.
	(thumb_legitimize_pic_address): Delete.
	* config/arm/arm.c: Include "gt-arm.h".
	(enum tls_reloc): New.
	(arm_cannot_copy_insn_p, arm_tls_symbol_p, load_tls_operand)
	(pcrel_constant_p, get_tls_get_addr, arm_load_tp)
	(arm_call_tls_get_addr, legitimize_tls_address)
	(arm_tls_referenced_p, arm_tls_operand_p_1, tls_mentioned_p)
	(arm_init_tls_builtins, arm_emit_tls_decoration)
	(arm_output_addr_const_extra): New functions.
	(TARGET_CANNOT_COPY_INSN_P, TARGET_CANNOT_FORCE_CONST_MEM)
	(TARGET_HAVE_TLS): Define.
	(target_thread_pointer): New.
	(arm_override_options): Handle -mtp=.
	(legitimize_pic_address): Ignore UNSPECs.
	(arm_legitimate_address_p, thumb_legitimate_address_p): Handle PC
	relative symbols.
	(arm_legitimize_address, thumb_legitimize_address): Handle TLS.
	(tls_get_addr_libfunc): New variable.
	(symbol_mentioned_p, label_mentioned_p): Ignore UNSPEC_TLS.
	(arm_init_builtins): Call arm_init_tls_builtins.
	(arm_expand_builtin): Handle ARM_BUILTIN_THREAD_POINTER.
	(arm_encode_section_info): Call default_encode_section_info.
	* config/arm/arm.h (TARGET_HARD_TP, TARGET_SOFT_TP): Define.
	(enum arm_tp_type): New.
	(target_thread_pointer): Add declaration.
	(LEGITIMATE_CONSTANT_P): Handle TLS.
	(LEGITIMATE_PIC_OPERAND_P): Handle TLS.
	(OUTPUT_ADDR_CONST_EXTRA): Call arm_output_addr_const_extra.
	(enum arm_builtins): Add ARM_BUILTIN_THREAD_POINTER.
	* config/arm/arm.md: Add UNSPEC_TLS.
	(movsi): Handle TLS.
	(pic_add_dot_plus_four, pic_add_dot_plus_eight): Allow for
	non-PIC.
	(tls_load_dot_plus_eight): New insn and a peephole to create it.
	(load_tp_hard, load_tp_soft): New insns.
	* arm.opt: Add -mtp=.
	* doc/invoke.texi (ARM Options): Document -mtp.

2005-11-04  Daniel Jacobowitz  <dan@codesourcery.com>

	* config/arm/lib1funcs.asm: Don't include "libunwind.S".
	* config/arm/libunwind.S: Include "lib1funcs.asm".
	* config/arm/t-bpabi (LIB1ASMFUNCS): Remove _unwind.
	(LIB2ADDEH): Add libunwind.S.
	(LIB2ADDEHDEP): Add lib1funcs.asm.
	* mklibgcc.in: Handle asm files in libgcc_eh.a.

2005-11-04  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/18452
	* c.opt: Add a -lang-fortran option.
	* c-opts.c: Add a lang_fortran flag.
	(c_common_init_options): Handling the -lang-fortran option.
	(c_common_handle_option): Add a case for Fortran options in
	preprocessing. Remove cases for -ffixed-form and
	-ffixed-line-length. Add a case for -lang-fortran.

2005-11-03  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c: Include params.h
	(optimization_options): Set max-grow-copy-bb-insns default to 16.
	(bdesc_2arg): Delete vpkuhss and vpkuwss.
	* config/rs6000/altivec.md (UNSPEC_VPKUHSS): Delete.
	(UNSPEC_VPKUWSS): Delete.
	(altivec_vpkuhss): Delete.
	(altivec_vpkuwss): Delete.
	* config/rs6000/rs6000.md (plus_eqsi): Remove optimize_size from
	final condition.
	(neg_eq0<mode>): Remove final condition.
	(neg_eq<mode>): Remove condition and split-condition.

2005-11-04  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.c (output_toc): Make "offset" HOST_WIDE_INT.
	Use associated print macros.

2005-11-03  Joseph S. Myers  <joseph@codesourcery.com>

	PR c++/17964
	* diagnostic.c (diagnostic_set_info_translated): New function.
	(diagnostic_set_info): Use it.  Add comment.
	* diagnostic.h (diagnostic_set_info_translated): Declare.

2005-11-03  Eric Botcazou  <ebotcazou@adacore.com>

	* dwarf2asm.c (dw2_force_const_mem): Add new parameter 'public'.
	On USE_LINKONCE_INDIRECT platforms, build a DECL_ONE_ONLY indirect
	reference only if 'public' is true.
	(dw2_output_indirect_constant_1): On USE_LINKONCE_INDIRECT platforms,
	emit the .hidden directive only if the indirect reference is public.
	(dw2_asm_output_encoded_addr_rtx): Add new parameter 'public'.
	Pass it to dw2_force_const_mem.
	* dwarf2asm.h (dw2_asm_output_encoded_addr_rtx): New param 'public'.
	* dwarf2out.c (output_cfi): Adjust calls to above function.
	(output_call_frame_info): Likewise.
	* except.c (output_ttype): Pass TREE_PUBLIC of the type_info object
	as 'public' argument to dw2_asm_output_encoded_addr_rtx.

2005-11-03  Zdenek Dvorak  <dvorakz@suse.cz>

	PR tree-optimization/24483
	* tree-ssa-loop-ivopts.c (aff_combination_add_elt): Move rest
	field to elts if possible.

2005-11-03  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/23155
	* gimplifier.c (gimplify_expr): Create a temporary for lvalue
	CONSTRUCTOR.

2005-11-03  Daniel Berlin  <dberlin@dberlin.org>

	Fix PR tree-optimization/24351

	* tree-ssa-structalias.c (struct variable_info): Add
	collapsed_into.
	(get_varinfo_fc): New function to follow collapsing.
	(new_var_info): Set collapsed_to to NULL.
	(dump_constraint): Follow collapsing.
	(build_constraint_graph): Handle collapsing.
	(do_simple_structure_copy): Return false if something bad
	happened.
	(collapse_rest_of_var): New function.
	(do_structure_copy): Collapse if do_simple_structure_copy returns
	false.
	
2005-11-03  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/24589
	* gimplify.c (gimplify_expr) <case CONSTRUCTOR>: Add the
	expressions to a statement list instead of gimplifying them.

2005-11-03  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/23585
	* rtlanal.c (rtx_addr_can_trap_p_1) <PLUS>: Return 0 for an address
	that can't trap plus a constant integer, if the mode has zero size.

2005-11-03  Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/24620
	* config/s390/s390.md ("*insv<mode>_reg_imm"): Accept any CONST_INT
	as operand 2.
	("*insv<mode>_reg_extimm"): Likewise.

2005-11-03  Joseph S. Myers  <joseph@codesourcery.com>

	PR c/24329
	* c-pretty-print.c (pp_c_type_specifier): Do not recurse if
	c_common_type_for_mode returns an unnamed type.

2005-11-02  Richard Henderson  <rth@redhat.com>

	PR target/9350
	PR target/24374
	* dwarf2out.c (dwarf2out_reg_save_reg): New.
	(dwarf2out_frame_debug_expr): Return after dwarf_handle_frame_unspec.
	* function.c (assign_parms): Use calls.internal_arg_pointer.
	(expand_main_function): Remove FORCE_PREFERRED_STACK_BOUNDARY_IN_MAIN
	code.
	* target-def.h (TARGET_INTERNAL_ARG_POINTER): New.
	(TARGET_CALLS): Add it.
	* target.h (struct gcc_target): Add calls.internal_arg_pointer.
	* targhooks.c (default_internal_arg_pointer): New.
	* targhooks.h (default_internal_arg_pointer): Declare.
	* tree.h (dwarf2out_reg_save_reg): Declare.
	* doc/tm.texi (FORCE_PREFERRED_STACK_BOUNDARY_IN_MAIN): Remove.
	* config/i386/i386.c (dbx_register_map): Add return column.
	(dbx64_register_map, svr4_dbx_register_map): Likewise.
	(TARGET_INTERNAL_ARG_POINTER, ix86_internal_arg_pointer): New.
	(TARGET_DWARF_HANDLE_FRAME_UNSPEC, ix86_dwarf_handle_frame_unspec): New.
	(ix86_function_ok_for_sibcall): Disable if force_align_arg_pointer.
	(ix86_save_reg): Save force_align_arg_pointer.
	(ix86_emit_save_regs): Make regno unsigned.
	(ix86_emit_save_regs_using_mov): Likewise.
	(ix86_expand_prologue): Handle force_align_arg_pointer.
	(ix86_expand_epilogue): Likewise.
	* config/i386/i386.h: (dbx_register_map): Update.
	(dbx64_register_map, svr4_dbx_register_map): Update.
	(struct machine_function): Add force_align_arg_pointer.
	* config/i386/i386.md (UNSPEC_REG_SAVE, UNSPEC_DEF_CFA): New.
	(UNSPEC_TP, UNSPEC_TLS_GD, UNSPEC_TLS_LD_BASE): Renumber.
	(TARGET_PUSH_MEMORY peepholes): Disable if RTX_FRAME_RELATED_P.

2005-11-02  Jan Hubicka  <jh@suse.cz>

	PR target/23303
	* i386.md: Add peep2 for simplyfing array accesses.

2005-11-02  Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/24615
	* config/s390/s390-protos.h (s390_decompose_shift_count): Declare.
	* config/s390/s390.c (s390_decompose_shift_count): New function.
	(s390_extra_constraint_str) ['Y']: Use s390_decompose_shift_count.
	(print_shift_count_operand): Use s390_decompose_shift_count.
	* config/s390/predicates.md ("setmem_operand", "shift_count_operand"):
	Use s390_decompose_shift_count.  Do not accept any non-base hard regs.

2005-11-02  Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/24600
	* loop.c (loop_givs_rescan): Use force_operand to expand
	complex GIVs.

2005-11-02  Andrew Pinski  <pinskia@physics.uc.edu>

	PR 22429
	* fold-const.c (build_range_check): Use unsigned when signed
	overflow is undefined also.  If etype is subtype, make sure that
	the subtraction is in the supertype.

2005-11-02  Richard Henderson  <rth@redhat.com>

	PR target/24178
	* config/alpha/alpha.c (get_aligned_mem): Honor alignment given
	by MEM_ALIGN.

2005-11-01  Richard Henderson  <rth@redhat.com>

	PR 21518
	* loop.c (scan_loop): Do not propagate computations to a hard
	register destination with SMALL_REGISTER_CLASSES.

2005-11-01  Joseph S. Myers  <joseph@codesourcery.com>

	* config/rs6000/rs6000.c (rs6000_rtx_costs): Do not add extra
	costs for MULT inside PLUS or MINUS.

2005-11-01  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.h (TRAMPOLINE_TEMPLATE): Add a byte of padding.
	(TRAMPOLINE_SIZE): Round up to 60.
	* config/xtensa/lib2funcs.S (TRAMPOLINE_SIZE): Likewise.

2005-10-31  James E. Wilson  <wilson@specifix.com>

	PR debug/24444
	* dwarf2out.c (convert_cfa_to_loc_list): Put inside DWARF2_UNWIND_INFO
	ifdef.  Put ifdefs around call in gen_subprogram_die.
	(compute_frame_pointer_to_cfa_displacement): Likewise.
	(gen_subprogram_die): Restore old code for when DWARF2_UNWIND_INFO is
	not defined.
	
	PR rtl-optimization/17356
	*  cfgrtl.c (purge_dead_edges): Undo last change.  In EDGE_EH code,
	add check for CALL_INSN if EDGE_ABRNOMAL_CALL true.

2005-10-31  Jan Hubicka  <jh@suse.cz>

	PR middle-end/24093
	* cgraph.c (cgraph_clone_edge, cgraph_clone_node): Watch negative

	PR target/20928
	* i386.c (legitimize_pic_address): Deal with large immediates.

	PR profile/20815
	* coverage.c (coverage_checksum_string): Fix code to stip random seeds
	from symbol names while computing checkup.

	PR profile/24487
	* predict.c (predict_loops): Do not estimate more than
	MAX_PRED_LOOP_ITERATIONS in PRED_LOOP_ITERATIONS heuristic.
	* predict.def (MAX_PRED_LOOP_ITERATIONS): Define.

2005-10-31  Andrew MacLeod  <amacleod@redhat.com>
	
	PR tree-optimization/19097
	* tree-ssa-operands.c (correct_use_link): Don't look for modified stmts.

2005-10-31  J"orn Rennecke <joern.rennecke@st.com>

	* optabs.c (expand_unop): Take TRULY_NOOP_TRUNCATION into account.

2005-10-31  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/23492
	* tree-inline.c (setup_one_parameter): If the init_stmt
	is NULL, don't insert the statement.

2005-10-30  Jan Hubicka  <jh@suse.cz>

	PR tree-optimization/24172
	* tree-inline.c (copy_body_r): Unshare the substituted value first.

2005-10-30  Hans-Peter Nilsson  <hp@bitrange.com>

	* config/mmix/mmix.c (mmix_intval): Correct handling of DFmode
	constants for hosts with long != 32 bits.

2005-10-28  Andreas Krebbel <krebbel1@de.ibm.com>

	PR middle-end/24093
	* ipa-inline.c (craph_decide_recursive_inlining): Fix return value.

2005-10-28  Aldy Hernandez  <aldyh@redhat.com>

	* config/ms1/ms1.h (TARGET_MS1_64_001): New.
	(TARGET_MS1_16_002): New.
	(TARGET_MS1_16_003): New.

	* config/ms1/ms1.md ("decrement_and_branch_until_zero"): Rewrite.
	("*decrement_and_branch_until_zero_no_clobber"): New.
	Add corresponding splitter for decrement_and_branch_until_zero
	instruction.
	Key all decrement_and_branch_until_zero patterns off of
	TARGET_MS1_16_003.

2005-10-28  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/24362
	* tree-complex.c (extract_component): Treat RESULT_DECL
	like the rest of the decls.

2005-10-25  Eric Botcazou  <ebotcazou@adacore.com>

	* config/ia64/ia64.c (ia64_output_function_profiler): Emit an
	indirect call to _mcount if the function needs a static chain.

2005-10-25  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Caroline Tice  <ctice@apple.com>

	PR rtl-optimization/24460
	* dwarf2out.c (have_switched_text_sections): New boolean variable.
	(dwarf2out_switch_text_section): Set it to true instead of
	incrementing separate_line_info_table_in_use.
	(output_loc_list): Additionally test have_switched_text_sections.
	(output_ranges): Likewise.
	(dwarf2out_finish): Likewise.
	* varasm.c (assemble_start_function): Do not call
	insert_section_boundary_note.
	(assemble_end_function): If flag_reorder_blocks_and_partition,
	switch to the function's section before emitting the .size directive.
	* bb-reorder.c (insert_section_boundary_note): Staticify.
	(rest_of_handle_reorder_blocks): Call insert_section_boundary_note.
	* output.h (insert_section_boundary_note): Delete.

2005-10-24  Andrew Pinski  <pinskia@physics.uc.edu>

	PR c/23103
	* c-format.c (check_format_types): Use lang_hooks.types_compatible_p
	instead of pointer equality when comparing types.

2005-10-24  James E. Wilson  <wilson@specifix.com>

	* sched-deps.c (flush_pending_lists): Pass 1 not 0 in first two
	add_dependence_list_and_free calls.

2005-10-24  Steven Bosscher  <stevenb@suse.de>

	* contrib.texi: Add the names of the LLNL folks who donated
	Cray pointer support for gfortran.

2005-10-24  Steven Bosscher  <stevenb@suse.de>

	PR tree-optimization/24225
	* profile.c (branch_prob): Look from end to start through a
	basic block when looking for a locus.

2005-10-24  Richard Henderson  <rth@redhat.com>

	* pa.c (store_reg_modify): Set RTX_FRAME_RELATED_P on each set in
	parallel.
	(hppa_expand_prologue): Likewise.

2005-10-24  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa-linux.h (NO_PROFILE_COUNTERS): Delete define.
	(NO_DEFERRED_PROFILE_COUNTERS): Define.
	* pa.h (NO_PROFILE_COUNTERS): Define.
	* pa.c (NO_DEFERRED_PROFILE_COUNTERS): Define if not defined.
	(funcdef_nos): New vector to hold label numbers of deferred profile
	counters.
	(output_deferred_profile_counters): New function.
	(hppa_profile_hook): Push label number onto funcdef_nos.
	(pa_hpux_file_end): Call output_deferred_profile_counters if
	NO_DEFERRED_PROFILE_COUNTERS is false.

	* pa-protos.h (get_deferred_plabel): New prototype.
	* pa.c (get_plabel): Rename to get_deferred_plabel.  Return plabel.
	Make global.
	(output_call): Adjust calls.

2005-10-24  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.c (rs6000_legitimize_tls_address): Explain
	peculiarity of GOT/TOC section usage.

2005-10-23  Andrew Pinski  <pinskia@physics.uc.edu>

	PR objc/24435
	 * c-common.c (constant_string_class_name): Add documentation.

2005-10-23  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/23832
	* recog.c (peephole2_optimize): Increment peep2_current_count
	only when the slot is empty.

2005-10-23  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR ada/23957
	* except.c (output_function_exception_table): Call
	assemble_external_libcall if we need a personality function.

2005-10-21  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/24460
	* bb-reorder.c (fix_crossing_unconditional_branches): Do not
	set the basic block for barriers.

2005-10-21  Janis Johnson  <janis187@us.ibm.com>

	* var-tracking.c (vt_initialize): Initialize post.

2005-10-21  Devang Patel  <dpatel@apple.com>

	PR/24220
	* c-common.c (vector_types_convertible_p): Check vector element type.
	
2005-10-21  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/sh.c (prepare_move_operands): Handle the address
	constant which is a tls symbolic address plus a constant.

2005-10-21  Andrew Pinski  <pinskia@physics.uc.edu>

	PR driver/24473
	* gcc.c (main): Use the correct counter for erroring out
	about mulitple files.

2005-10-21  Alan Modra  <amodra@bigpond.net.au>

	PR target/24465
	* config/rs6000/rs6000.c (rs6000_legitimize_tls_address): Always
	use r2 for 64-bit tls .got access.

2005-10-21  Paolo Bonzini  <bonzini@gnu.org>

	* dojump.c (do_jump): Handle side-effecting TRUTH_AND_EXPR and
	TRUTH_OR_EXPR.

2005-10-20  Steven Bosscher  <stevenb@suse.de>

	PR tree-optimization/24307
	* tree-cfg.c (tree_find_edge_insert_loc): Handle naked RETURN_EXPR.

2005-10-20  Alexandre Oliva  <aoliva@redhat.com>

	PR middle-end/24295
	* cgraphunit.c (cgraph_varpool_remove_unreferenced_decls): Mark
	alias targets.
	* varasm.c (find_decl_and_mark_needed): After cgraph global info
	is ready, stop marking functions, but still mark variables.

2005-10-20  Richard Guenther  <rguenther@suse.de>

	PR c++/24439
	* fold-const.c (invert_truthvalue): Handle COND_EXPR with
	void type operands.

2005-10-20  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/23585
	* rtlanal.c (rtx_addr_can_trap_p_1): New predicate extracted from...
	(rtx_addr_can_trap_p): ... here.  Invoke rtx_addr_can_trap_p_1.
	(may_trap_p_1): New predicate extracted from...
	(may_trap_p): ... here.  Invoke may_trap_p_1.
	(may_trap_or_fault_p): New predicate.
	* rtl.h (may_trap_or_fault_p): Declare it.
	* reorg.c (steal_delay_list_from_target): Use may_trap_or_fault_p
	instead of may_trap_p.
	(steal_delay_list_from_fallthrough): Likewise.
	(fill_simple_delay_slots): Likewise.
	(fill_slots_from_thread): Likewise.
	* function.c (pad_to_arg_alignment): Rework comment about
	SPARC_STACK_BOUNDARY_HACK.
	* config/sparc/sparc.h: Likewise.

2005-10-19  Adrian Straetling  <straetling@de.ibm.com>

	* config/s390/s390.c (s390_expand_insv): New.
	* config/s390/s390-protos.h (s390_expand_insv): Declare.
	* config/s390/s390.md ("UNSPEC_SETHIGH"): Rename to "UNSPEC_ICM".
	("icm_hi"): Remove mode attribute.
	("*sethigh<mode><mode>"): Rewrite to "sethighpart<mode>".
	Adjust all uses.
	("*extracthi", "*extractqi"): Remove.
	(extv<mode>", "*extzv<mode>"): New.
	("insv", "*insv<mode>_mem_reg", "*insvdi_mem_reghigh",
	"*insv<mode>_reg_imm", "*insv<mode>_reg_extimm"): New.

2005-10-19  Ulrich Weigand  <Ulrich.Weigand@de.ibm.com>

	* cfgexpand.c (discover_nonconstant_array_refs_r,
	discover_nonconstant_array_refs): Move here from tree-outof-ssa.c
	(tree_expand_cfg): Call discover_nonconstant_array_refs.
	* tree-outof-ssa.c (rewrite_out_of_ssa): Remove call to
	discover_nonconstant_array_refs.

2005-10-19  Steven Bosscher  <stevenb@suse.de>

	PR c/23228
	* c-decl.c (pop_scope): Don't warn about an unused variable
	if it is marked with TREE_NO_WARNING.
	(duplicate_decls): Set TREE_NO_WARNING if olddecl and newdecl
	somenow mismatch and olddecl is to be replaced.

2005-10-19  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR middle-end/23199
	* cfgrtl.c (safe_insert_insn_on_edge): Use can_copy_p to detect
	whether registers live on the edge can be saved/restored.

2005-10-19  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/sh.c (fixup_mova): Skip notes.

2005-10-19  Ulrich Weigand  <Ulrich.Weigand@de.ibm.com>

	* config/s390/s390-protos.h (s390_hard_regno_rename_ok): Add prototype.
	* config/s390/s390.c (s390_hard_regno_rename_ok): New function.
	(s390_can_eliminate): Handle BASE_REGNUM elimination.
	(s390_initial_elimination_offset): Likewise.
	(s390_conditional_register_usage): BASE_REGNUM is no longer a fixed
	register on TARGET_ZARCH targets.
	* config/s390/s390.h (HARD_REGNO_RENAME_OK): Define
	(INITIAL_FRAME_POINTER_OFFSET): Remove.
	(REG_ALLOC_ORDER): Move BASE_REGNUM lower.
	(ELIMINABLE_REGS): Add BASE_REGNUM elimination rule.

2005-10-19  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390/s390.md: Comment describing output modifiers updated.
	* config/s390/s390.c (print_operand): Likewise.

2005-10-19  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390/s390.c (override_options): Added check for -mstack-size
	64k limitation.
	* doc/invoke.texi: Mention that limit in the documenation.

2005-10-18  Paolo Bonzini  <bonzini@gnu.org>

	PR #19672
	* dojump.c (do_jump): Handle TRUTH_AND_EXPR and TRUTH_OR_EXPR here.

2005-10-18  Daniel Berlin <dberlin@dberlin.org>

	Fix PR tree-optimization/24231

	* tree-ssa-pre.c (try_look_through_load): Skip abnormal phi names
	(compute_avail): Ditto.

2005-10-18  Richard Henderson  <rth@redhat.com>

	PR target/24428
	* config/i386/i386.c (legitimate_constant_p): Check
	SYMBOL_REF_TLS_MODEL directly.  Don't fallthru to SYMBOL_REF
	if LABEL_REF.
	(legitimate_pic_operand_p): Test SYMBOL_REF_TLS_MODEL directly.
	(legitimate_pic_address_disp_p): Reorg CONST checking to make
	sure SYMBOL_REF_TLS_MODEL is tested.  Test SYMBOL_REF_TLS_MODEL
	directly.
	(print_operand_address): Likewise.
	* config/i386/predicates.md (x86_64_immediate_operand): Test
	SYMBOL_REF_TLS_MODEL properly inside CONST.
	(x86_64_zext_immediate_operand): Likewise.
	(global_dynamic_symbolic_operand, local_dynamic_symbolic_operand,
	initial_exec_symbolic_operand, local_exec_symbolic_operand): Remove.
	* config/i386/i386-protos.h: Remove predicates.md entries.

2005-10-18  Danny Smith  <dannysmith@users.sourceforge.net>

	* config/i386/winnt-cxx.c (i386_pe_adjust_class_at_definition):
	Check that elements of TYPE_METHODS are FUNCTION_DECLs.

2005-10-17  Alexey Starovoytov  <alexey.starovoytov@sun.com>
	    Ian Lance Taylor <ian@airs.com>

	PR middle-end/23522
	* fold-const.c (fold_widened_comparison): Do not allow range based
	constant folding when right operand cannot be unwidened.

2005-10-17  Richard Henderson  <rth@redhat.com>

	* builtins.c (expand_builtin_synchronize): Build a new-style asm
	with a memory clobber.

2005-10-17  James E Wilson  <wilson@specifix.com>

	PR rtl-optimization/17356
	* cfgrtl.c (purge_dead_edges): Check for EDGE_ABNORMAL_CALL before
	checking for EDGE_EH.

2005-10-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c (function_arg_slotno): In 64-bit mode, align
	the slot on an even boundary for any type with 16-byte alignment.

2005-10-17  Hans-Peter Nilsson  <hp@axis.com>

	PR target/23424
	* md.texi (Modifiers) <%>: Clarify that % doesn't work
	after register allocation.

2005-10-17  DJ Delorie  <dj@redhat.com>

	* config/m32c/m32c.c (m32c_pushm_popm): Don't mark epilogue insns
	as frame related.

2005-10-17  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/22551
	* c-common.c (c_add_case_label): Revert my 2005-10-14 clearing of
	overflow flags.

2005-10-17  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/sh.h (OPTIMIZATION_OPTIONS): Set flag_schedule_insns
	to 2 if it's already non-zero.
	(OVERRIDE_OPTIONS): Clear flag_schedule_insns if flag_exceptions
	is set and warn about it if flag_schedule_insns is 1.

2005-10-17  Paul Woegerer  <paul.woegerer@nsc.com>

	* config/crx/crx.md: Compare-and-branch instructions need to
	invalidate CC.

2005-10-17  Uros Bizjak  <uros@kss-loka.si>

	PR target/24315
	* config/i386/i386.md (*pushdi2_rex64 splitter)
	(*movdi_1_rex64 splitter, *ashldi3_1 splitter)
	(*ashrdi3_1 splitter, *lshrdi3_1 splitter): Delay splitting after
	flow2 pass only when (optimize > 0 && flag_peephole2).

2005-10-16  Andrew Pinski  <pinskia@physics.uc.edu>

	PR driver/22544
	* gcc.c (have_c): New static variable.
	(have_o): Likewise.
	(process_command): Remove declation of have_c.
	Set have_o to 1 when handling -o.
	(main): Add a fatel error if there are multiple
	files specified and -o and -c/-S is passed witout
	-combine or multiple languages.

2005-10-16  Daniel Berlin  <dberlin@dberlin.org>

	Fix PR tree-optimization/22444
	* tree-ssa-alias.c (compute_flow_insensitive_aliasing):
	Assert that we don't hit something with subvars.
	(setup_pointers_and_addressables): Don't add things with subvars,
	because we'll already process the subvars for aliasing purposes.

2005-10-16  Hans-Peter Nilsson  <hp@axis.com>

	PR target/23424
	* config/cris/cris.md ("*mov_side<mode>", "*mov_sidesisf")
	("*mov_side<mode>_mem", "*mov_sidesisf_mem", "*clear_side<mode>")
	("*ext_sideqihi", "*ext_side<mode>si", "*op_side<mode>")
	("*op_swap_side<mode>", "*extopqihi_side", "*extop<mode>si_side")
	("*extopqihi_swap_side", "*extop<mode>si_swap_side"): Have separate,
	swapped, alternatives for the R constraint.

	PR middle-end/24341
	* builtins.c (get_builtin_sync_mode): Make unlimited
	mode_for_size request.

2005-10-15  Richard Henderson  <rth@redhat.com>

	* gimplify.c (gimplify_var_or_parm_decl): Split out from ...
	(gimplify_expr): ... here.
	(gimplify_compound_lval): Use it in initial scan loop.  Allow
	fb_lvalue in base expression.

2005-10-15  Richard Henderson  <rth@redhat.com>

	PR 23714
	* builtins.c (expand_builtin_trap): Export.
	* expr.h (expand_builtin_trap): Declare.
	* expr.c (expand_assignment): Emit a trap for integral offsets 
	from registers that weren't reduced to bitpos.

	* tree-cfg.c (mark_array_ref_addressable_1): Remove.
	(mark_array_ref_addressable): Remove.
	* tree-flow.h (mark_array_ref_addressable): Remove.
	* tree-optimize.c (execute_cleanup_cfg_post_optimizing): Don't call it.

2005-10-15  James E Wilson  <wilson@specifix.com>

	PR target/24232
	* sched-deps.c (add_dependence_list): New arg UNCOND.  Fix all callers.
	(add_dependence_list_and_free): Likewise.
	(sched_analyze_2, case MEM): Delete sched_insns_conditions_mutex_p
	call.

2005-10-15  Diego Novillo  <dnovillo@redhat.com>

	PR 23141
	PR 23142
	* tree-vrp.c (vrp_meet): Fix the intersection of equivalence
	sets VR0->EQUIV and VR1->EQUIV when meeting a range and an
	anti-range.
	(vrp_visit_phi_node): Only prevent infinite iterations when
	the previous result and the new result are both VR_RANGEs.

2005-10-15  Ranjit Mathew  <rmathew@gcc.gnu.org>

	* tree-into-ssa.c (mark_def_sites): Correct minor typo in
	function comment.

2005-10-14  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR c/23439
	* c-parser.c (c_parser_for_statement): Use location of RID_FOR
	to initialize loc.

2005-10-14  Per Bothner  <per@bothner.com>

	PR preprocessor/21250
	* c-ppoutput.c (print_line): Print internal line 0 as 1.

2005-10-14  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/22551
	* c-common.c (c_add_case_label): Clear LOW_VALUE and HIGH_VALUE's
	overflow flags.  Refactor some conditionals.

2005-10-13  Andrew Pinski  <pinskia@physics.uc.edu>

	PR tree-opt/21304
	* tree-dfa.c (add_referenced_var): Only look at decls which
	have TREE_CONSTANT or TREE_READONLY set instead of if
	!TREE_PUBLIC or !TREE_CONSTANT.

2005-10-13  James E Wilson  <wilson@specifix.com>

	* doc/invoke.texi: For -x, add f95-cpp-input.
	* doc/install.texi: For --enable-languages doc, change f95 to fortran.

2005-10-12  Sebastian Pop  <pop@cri.ensmp.fr>

	PR tree-optimization/24262
	* tree-data-ref.c (analyze_offset_expr): Check that init is invariant
	in loop all the time.

2005-10-12  Richard Henderson  <rth@redhat.com>

	PR c/24255
	* tree.h (DECL_TRANSPARENT_UNION): Remove.
	* function.c (assign_parm_find_data_types): Don't support it.
	* print-tree.c (print_node): Likewise.
	* c-common.c (handle_transparent_union_attribute): Likewise.
	Use build_duplicate_type.
	* tree-inline.c (remap_type_1): Split out of remap_type;
	properly remap aggregate fields.
	(build_duplicate_type): New.
	* doc/extend.texi (Variable Attributes): Remove documentation
	for transparent_union.

2005-10-12  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/24284
	* config/sparc/sparc.c (gen_stack_pointer_inc): Build by hand.
	(gen_stack_pointer_dec): Likewise.

2005-10-12  Danny Smith  <dannysmith@users.sourceforge.net>

	PR middle-end/21275
	PR middle-end/21766
	* target.h (struct gcc_target): Add valid_dllimport_attribute_p
	target hook.
	(struct cxx): Add adjust_class_at_definition target hook.
	* target-def.h: (TARGET_VALID_DLLIMPORT_ATTRIBUTE_P): New define,
	defaulting to hook_bool_tree_true. Add to TARGET_INITIALIZER
	(TARGET_CXX_ADJUST_CLASS_AT_DEFINITION): New define, defaulting to 
	hook_void_tree. Add to TARGET_CXX.
	* tree.h (struct decl_with_vis): Rename non_addr_const_p field to
	dllimport_flag.
	(DECL_NON_ADDR_CONSTANT_P): Replace with DECL_DLLIMPORT_P macro.
	* tree.c (merge_dllimport_decl_attributes): Check DECL_DLLIMPORT_P
	instead of attribute. Check for dllexport override.  Warn if
	inconsistent dll linkage. Don't lose old dllimport if decl has
	had address referenced.   Tweak lookup of dllimport atribute.  
	(handle_dll_attribute): Check targetm.valid_dllimport_attribute_p
	for target specific rules.  Don't add dllimport attribute if
	DECL_DECLARED_INLINE_P.  Set DECL_DLLIMPORT_P when adding
	dllimport attribute. 
	(staticp): Replace DECL_NON_ADDR_CONSTANT_P with DECL_DLLIMPORT_P.
	* varasm.c (initializer_constant_valid_p): Replace
	DECL_NON_ADDR_CONSTANT_P with DECL_DLLIMPORT_P

	PR target/21801
	PR target/23589
	* config.gcc (i[34567]86-*-cygwin*): Add winnt-cxx.o to 
	'cxx_target_objs', winnt-stubs,o to 'extra_objs'.
	(i[34567]86-*-mingw32*): Likewise.

	* doc/tm.texi (TARGET_CXX_ADJUST_CLASS_AT_DEFINITION): Document.
	(TARGET_VALID_DLLIMPORT_ATTRIBUTE_P): Document.
			
	* config/i386/winnt.c (i386_pe_dllimport_p): Factor out
	C++-specific code. Change return value to bool. 
	(i386_pe_dllimport_p): Likewise.
	(associated_type): Simplify and make language-independent
	(i386_pe_encode_section_info): Replace override of ambiguous
	dllimport symbol refs with a gcc_assert.
	(i386_pe_valid_dllimport_attribute_p): Define.
	* config/i386/winnt-cxx.c: New file. Define C++ versions of
	i386_pe_type_dllimport_p, i386_pe_type_dllexport_p,
	i386_pe_adjust_class_at_definition.
	* config/i386/winnt-stubs.c: New file. Define stub versions of
	lang-specific functions.
	* config/i386/i386-protos.h: Declare winnt-[cxx|stubs].c functions
	i386_pe_type_dllimport_p, i386_pe_type_dllexport_p, 
	i386_pe_adjust_class_at_definition.
	(i386_pe_valid_dllimport_attribute_p): Declare. 
	* config/i386/cygming.h (TARGET_VALID_DLLIMPORT_ATTRIBUTE_P): Define.
	(TARGET_CXX_ADJUST_CLASS_AT_DEFINITION): Define.
	* config/i386/t-cygming: Add rules for winnt-cxx.o, winnt-stubs.o.

	PR target/19704
	* config/i386/i386.c (ix86_function_ok_for_sibcall): Replace test for
	dllimport attribute with test of DECL_DLLIMPORT_P.

2005-10-12  Adrian Straetling <straetling@de.ibm.com>

	* combine.c (make_extraction): Correct offset computation.

2005-10-12  Hans-Peter Nilsson  <hp@axis.com>

	* config/cris/t-linux (LIMITS_H_TEST): Define.

2005-10-12  Richard Henderson  <rth@redhat.com>

	PR rtl-opt/23324
	* cfgexpand.c (add_alias_set_conflicts): Use objects_must_conflict_p.

2005-10-12  Richard Guenther  <rguenther@suse.de>

	* Makefile.in (CGRAPH_H): Depend on $(TREE_H).

2005-10-12  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/19964
	* stor-layout.c (place_field): Set DECL_FIELD_OFFSET and
	DECL_FIELD_BIT_OFFSET of FIELD_DECLs, even if they have an invalid
	type.

2005-10-12  Richard Guenther  <rguenther@suse.de>

	PR c++/23799
	* varasm.c (output_constant): Correct typo from previous
	patch by DJ.

2005-10-11  Ian Lance Taylor  <ian@airs.com>

	PR rtl-optimization/13931
	* combine.c: Revert patch of 2003-05-14, and:
	(try_combine): Only set elim_i1 and elim_i2 if the destination is
	completely killed in the appropriate insn.
	(distribute_notes): Don't skip multiple hard register test for
	elim_i1 and elim_i2.

2005-10-11  Richard Henderson  <rth@redhat.com>

	PR c/24255
	* c-typeck.c (convert_for_assignment): Use build_constructor_single
	to initialize a transparent union instead of a nop_expr.

2005-10-11  Richard Henderson  <rth@redhat.com>

	* Makefile.in (tree-ssa-dce.o): Depend on SCEV_H.
	* tree-ssa-dce.c: Include tree-scalar-evolution.h.
	(tree_ssa_dce_loop): Call scev_reset.

	PR tree-opt/24300
	* Makefile.in (tree-ssa-dce.o): Depend on CFGLOOP_H.
	* tree-ssa-dce.c: Include cfgloop.h.
	(tree_ssa_dce_loop, pass_dce_loop): New.
	* tree-pass.h (pass_dce_loop): Declare it.
	* passes.c (init_optimization_passes): Use it.

2005-10-11  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR middle-end/24263 
	* convert.c (convert_to_real): Revert 2005-10-05 patch.
	Only apply the optimization for rounding builtins if the inner
	cast is also an extension.

2005-10-11  Andrew Pinski  <pinskia@physics.uc.edu>

	PR tree-opt/23946
	* tree-ssa-ccp.c (execute_fold_all_builtins): Call
	mark_new_vars_to_rename instead of update_stmt.

2005-10-11  Bernd Schmidt  <bernd.schmidt@analog.com>

	* config/bfin/crti.s (__init, __fini): Renamed from _init, _fini.

2005-10-11  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.md (movsi_1, movdi_1_rex64): Use mmxadd type
	for setting MMX register to 0 rather than mmx.

2005-10-10  Steve Ellcey  <sje@cup.hp.com>

	PR target/12098
	* configure.ac: Move gas check from mips specific case to common case.
	Do check for GNU as for mips*-*-* and *-*-hpux* targets.
	* configure: Regenerate
	* doc/install.texi: Update.

2005-10-10  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/24284
	* config/sparc/sparc.c (sparc_expand_prologue): Remove bogus PATTERN.

2005-10-10  Maciej W. Rozycki  <macro@linux-mips.org>

	* gcc.c (do_spec_1): Accept numeric characters in file name
	suffixes.

2005-10-10  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.c: Remove extraneous whitespace.  Remove comment
	describing the deleted arm_gen_rotated_half_load function.

2005-10-09  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/sh.c (emit_fpu_switch): Set TREE_PUBLIC for
	__fpscr_values.

2005-10-09  Daniel Jacobowitz  <dan@codesourcery.com>

	* config.gcc (arm*-*-linux*): Remove redundant extra_parts and
	gnu_ld assignments.
	* config/arm/t-linux-eabi (LIB1ASMFUNCS)
	(EXTRA_MULTILIB_PARTS): Define.
	* config/arm/linux-elf.h (NO_IMPLICIT_EXTERN_C, CPLUSPLUS_CPP_SPEC)
	(STARTFILE_SPEC, ENDFILE_SPEC, CC1_SPEC)
	(LINK_GCC_C_SEQUENCE_SPEC, USE_LD_AS_NEEDED): Move to...
	* config/arm/uclinux-elf.h (NO_IMPLICIT_EXTERN_C, CPLUSPLUS_CPP_SPEC)
	(STARTFILE_SPEC, ENDFILE_SPEC, CC1_SPEC)
	(LINK_GCC_C_SEQUENCE_SPEC, USE_LD_AS_NEEDED): ... here.

2005-10-09  Zdenek Dvorak  <dvorakz@suse.cz>

	PR tree-optimization/24226
	* tree-cfg.c (remove_bb): Clean up unreachable loops.
	* tree-flow.h (free_numbers_of_iterations_estimates_loop): Declare.
	* tree-ssa-loop-niter.c (free_numbers_of_iterations_estimates_loop):
	Export.

2005-10-09  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/gmon-sol2.c (internal_mcount): Mark as used.

2005-10-08  Andrew Pinski  <pinskia@physics.uc.edu>

	PR target/24136
	* config/rs6000/darwin.md (movdf_low_si): Remove early clobber.
	Rewrite for no need for the early clobber.

2005-10-08  Kazu Hirata  <kazu@codesourcery.com>

	Merge from csl-arm-branch:
	2005-09-07  Paul Brook  <paul@codesourcery.com>
	* config/arm/linux-eabi.h (SUBTARGET_EXTRA_LINK_SPEC): Prepend a
	space to string.

	2005-04-30  Paul Brook  <paul@codesourcery.com>
	* config/arm/bpabi.h (TARGET_DEFAULT): Define.
	* config/arm/linux-eabi.h (SUBTARGET_CPU_DEFAULT): Define.

	2005-03-07  Daniel Jacobowitz  <dan@codesourcery.com>
	* config/arm/arm.c (arm_all_abis): Add aapcs-linux.
	(arm_override_options): Use TARGET_AAPCS_BASED.
	* config/arm/arm.h (enum arm_abi_type): Add ARM_ABI_AAPCS_LINUX.
	(PTRDIFF_TYPE): Use int for AAPCS.
	(DEFAULT_SHORT_ENUMS): Use false for aapcs-linux.
	* config/arm/linux-eabi.h (ARM_DEFAULT_ABI, WCHAR_TYPE): Define.
	(DEFAULT_SHORT_ENUMS): Delete.
	* doc/invoke.texi (ARM Options): Document -mabi=aapcs-linux.

	2004-12-15  Daniel Jacobowitz  <dan@codesourcery.com>
	* config/arm/arm.h (DEFAULT_SHORT_ENUMS): Wrap in #ifndef.
	* config/arm/linux-eabi.h (DEFAULT_SHORT_ENUMS): Define to 0.
	* config/arm/t-linux-eabi (TARGET_LIBGCC2_CFLAGS): Set to -fPIC.

	2004-12-03  Mark Mitchell  <mark@codesourcery.com>
	* config/arm/linux-eabi.h (LIBGCC_SPEC): Do not define.

	2004-11-22  Mark Mitchell  <mark@codesourcery.com>
	* config.gcc (arm*-*-linux-gnueabi): Use __cxa_atexit.
 
	2004-11-19  Mark Mitchell  <mark@codesourcery.com>
	* config.gcc (arm*-*-linux-gnueabi): Add it.
	* config/arm/bpabi.h (FPUTYPE_DEFAULT): Undefine it before
	redefining it.
	(TARGET_OS_CPP_BUILTINS): Likeiwse.
	* config/arm/linux-eabi.h: New file.
	* config/arm/linux-elf.h (LINUX_TARGET_INTERPRETER): New macro.
	(LINUX_TARET_LINK_SPEC): Likewise.
	(LINK_SPEC): Use it.
	* config/arm/t-linux-eabi: New file.

2005-10-08  Steven Bosscher  <stevenb@suse.de>

	PR other/22202
	* params.def (PARAM_MAX_VARIABLE_EXPANSIONS): Remove superfluous
	spaces.
	(PARAM_SMS_DFA_HISTORY): Likewise.

2005-10-08  Kazu Hirata  <kazu@codesourcery.com>

	PR middle-end/23150
	* calls.c (mem_overlaps_already_clobbered_arg_p): New.
	(load_register_parameters): Call it.
	(check_sibcall_argument_overlap_1): Likewise.
	(store_one_arg): Likewise.

2005-10-07  James E. Wilson  <wilson@specifix.com>

	* config/ia64/vect.md (ashl<mode>3, ashr<mode>3, lshr<mode>3): Use
	DImode not VECINT24 for operand 2.

	PR target/23644
	* doc/invoke.texi (IA-64 Options, item -mtune): Renamed from
	-mtune-arch.

	PR target/24193
	* config/ia64/ia64.md (movbi, movti_internal, gr_spill_internal,
	fr_spill): Use destination_operand for operand 0.

2005-10-07  DJ Delorie  <dj@redhat.com>

	* varasm.c (output_constant): Limit error to expanding
	conversions.

2005-10-07  Richard Guenther  <rguenther@suse.de>

	PR middle-end/24227
	* fold-const.c (fold_binary): Fix operand types during folding
	of X op (A, Y).  Evaluation order of the side-effects of
	X and A are frontend-defined, so ensure we honour that even for
	tcc_comparison class operands; eased by removing duplicate code.

2005-10-07  Steve Ellcey  <sje@cup.hp.com>

	* stor-layout.c (layout_type): Do not allow alignment of array
	elements to be greater than their size.

2005-10-07  Steve Ellcey  <sje@cup.hp.com>

	* config.host (hppa*-*-hpux*): Change out_host_hook_obj and
	host_xmake_file.
	(hppa*-*-linux*): Ditto.
	(ia64-*-hpux*): Add out_host_hook_obj and host_xmake_file.
	* config/host-hpux.c: New.
	* config/x-hpux: New.
	* config/pa/x-hpux: Remove.
	* config/pa/x-linux: Remove.
	* config/pa/pa-host.c: Remove.

2005-10-07  Jeff Law  <law@redhat.com>

	* tree-ssa-dom.c (dom_opt_finalize_block): Fix conditions to
	determine whether or not to try and thread outgoing edges.

2005-10-07  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.md (eqsi_power): New.
	(neg_eq0si): Add TARGET_POWER to final condition.
	(neg_eqsi): Same.

2005-10-06  Richard Henderson  <rth@redhat.com>

	* config/rs6000/rs6000.c: Revert last change.

2005-10-06  Richard Henderson  <rth@redhat.com>

	* config/rs6000/rs6000.c (rs6000_cannot_force_const_mem): New.
	(TARGET_CANNOT_FORCE_CONST_MEM): Use it.

2005-10-06  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/22216
	PR middle-end/23651
	* cfgexpand.c (tree_expand_cfg): After expanding the functions, clear
	out return_label and naked_return_label.

2005-10-06  Daniel Berlin  <dberlin@dberlin.org>
	
	* tree-ssa-structalias.c (check_for_overlaps): Fix bug in last
	change.

2005-10-06  Richard Henderson  <rth@redhat.com>

	PR tree-opt/22237
	* tree-inline.c (declare_return_variable): Handle modify_dest not
	being a DECL.

2005-10-06  Daniel Berlin  <dberlin@dberlin.org>
	
	Fix PR tree-optimization/22488
	* tree-ssa-structalias.c (check_for_overlaps): New function.
	(create_variable_info_for): Use it.

2005-10-06  Richard Henderson  <rth@redhat.com>

	PR debug/24070
	* dwarf2out.c (lookup_filename): Return the result of maybe_emit_file.
	(dwarf2out_start_source_file): Print it.

2005-10-06  Geoffrey Keating  <geoffk@apple.com>

	* config/t-slibgcc-darwin (SHLIB_MAPFILES): Use '+='.

2005-10-06  Richard Henderson  <rth@redhat.com>

	PR 23706
	* mode-switching.c (optimize_mode_switching): Clear transp bit
	for block with incomming abnormal edges.

	* config/sh/sh.c (fpscr_values, emit_fpu_switch): New.
	(fpscr_set_from_mem): Use them.
	* config/sh/sh.md (fpu_switch0, fpu_switch1): Remove.
	(fpscr postinc splitters): Rewrite as peephole2+split.

2005-10-06  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.md (eq<mode>): Add !TARGET_POWER.
	(eq<mode>_compare): Same.

2005-10-06  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/24238
	* tree-ssa-alias.c (find_used_portions): Handle RESULT_DECL.

2005-10-06  Daniel Jacobowitz  <dan@codesourcery.com>

	* acinclude.m4 (gcc_AC_CHECK_TOOL): Handle environment variables
	here.  Use AC_PATH_PROG for environment variables instead of
	test -x.
	* configure.ac: Update calls to gcc_AC_CHECK_TOOL.  Use it for
	objdump also.
	* configure: Regenerated.

2005-10-06  Richard Earnshaw  <richard.earnshaw@arm.com>

	PR target/23783
	* arm.md (call): If the address isn't a SYMBOL_REF or a register,
	then force it into a register.
	(call_value): Likewise.

2005-10-06  Richard Henderson  <rth@redhat.com>

	PR 24049
	* passes.c (init_optimization_passes): Move pass_lower_vector_ssa
	under pass_vectorize.  Clear TODO_ggc_collect from the dce pass
	under pass_vectorize.

2005-10-05  Devang Patel  <dpatel@apple.com>

	PR Debug/23205
	* dbxout.c (dbxout_symbol): Check DECL_RTL_SET_P, after
	handling constants. Check NAMESPACE_DECL context for constants.
	
2005-10-05  Eric Christopher  <echristo@apple.com>

	* doc/md.texi (Standard Names): Fix name of pushm1 pattern.

2005-10-05  Richard Henderson  <rth@redhat.com>

	PR 23714
	* tree-cfg.c (mark_array_ref_addressable_1): New.
	(mark_array_ref_addressable): New.
	* tree-flow.h (mark_array_ref_addressable): Declare.
	* tree-optimize.c (execute_cleanup_cfg_post_optimizing): Use it.

2005-10-05  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/20606
	PR middle-end/24069
	* reload.c (subst_reloads): When adding a REG_LABEL to a
	jump instruction, also update JUMP_LABEL.

2005-10-05  David Edelsohn  <edelsohn@gnu.org>

	* params.def (PARAM_MAX_GROW_COPY_BB_INSNS): New.
	* bb-reorder.c (copy_bb_p): Use it.
	* doc/invoke.texi (param table): Add max-grow-copy-bb-insn.

2005-10-05  Richard Henderson  <rth@redhat.com>

	PR target/23602
	* toplev.c (process_options): Warn about unsupported combinations
	of unwind tables and omit-frame-pointer.
	* config/i386/i386.c (override_options): Similarly.  Enable
	accumulate-outgoing-args if not explicitly disabled.

2005-10-05  Steve Ellcey  <sje@cup.hp.com>

	* vect.md (vec_initv2si): Fix typo of V2SF to V2SI.
	Handle big endian vs. small endian.
	(vec_initv2sf): Handle big endian vs. small endian.
	(*vec_extractv2sf_1): Ditto.

2005-10-05  Dale Johannesen  <dalej@apple.com>

	* convert.c (convert_to_real):  Don't convert
	(float)floor(double d) to floorf((float)d).

2005-10-05  Daniel Jacobowitz  <dan@codesourcery.com>

	* config/arm/arm.md (insv): Use gen_int_mode in more places.

2005-10-05  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/18587
	* tree-ssa-operands.c (struct opbuild_list_d, OPBUILD_LAST): Delete.
	(build_defs, build_uses, build_v_may_defs, build_v_must_defs,
	build_vuses): Change to VEC type.
	(opbuild_initialize_virtual, opbuild_initialize_real, opbuild_free,
	opbuild_num_elems, opbuild_append_real, opbuild_append_virtual,
	opbuild_first, opbuild_next, opbuild_elem_real, opbuild_elem_virtual,
	opbuild_elem_uid, opbuild_clear, opbuild_remove_elem): Delete.
	(get_name_decl): New.  Return DECL_UID of base variable.
	(operand_build_cmp): New.  qsort comparison routine.
	(operand_build_sort_virtual): New.  Sort virtual build vector.
	(init_ssa_operands, fini_ssa_operands): Use VEC routines.
	(FINALIZE_OPBUILD_BASE, FINALIZE_OPBUILD_ELEM): Use VEC_Index.
	(FINALIZE_BASE): Use get_name_decl.
	(finalize_ssa_defs, finalize_ssa_uses, cleanup_v_may_defs,
	finalize_ssa_v_may_defs, finalize_ssa_vuses, finalize_ssa_v_must_defs,
	(start_ssa_stmt_operands, append_def, append_use, append_vuse,
	append_v_may_def, append_v_must_def): Replace opbuild_* routines with
	direct VEC_* manipulations.
	(build_ssa_operands): Call operand_build_sort_virtual.
	(copy_virtual_operand, create_ssa_artficial_load_stmt,
	add_call_clobber_ops, add_call_read_ops): Replace opbuild_* routines
	with direct VEC_* manipulations.
	* tree-ssa-opfinalize.h (FINALIZE_FUNC): Replace opbuild_* routines
	with direct VEC manipulations.

2005-10-05  Paolo Bonzini  <bonzini@gnu.org>

	PR tree-optimization/21419
	PR tree-optimization/24146
	PR tree-optimization/24151

	* c-typeck.c (readonly_error): Handle USE being lv_asm.
	(build_asm_expr): Call it if outputs are read-only.
	* gimplify.c (gimplify_asm_expr): Remove former fix to PR 21419.

2005-10-05  Billy Biggs  <billy.biggs@gmail.com>
	    Paolo Bonzini  <bonzini@gnu.org>

	PR target/23809

	* doc/extend.texi (x86 Built-ins): Document that -msse and friends
	enable the instructions and not just the built-ins.
	* doc/invoke.texi (x86 Options): Likewise.

2005-10-04  Geoffrey Keating  <geoffk@apple.com>

	* config/i386/t-darwin (SHLIB_VERPFX): Fix typo.

	* doc/invoke.texi (Option Summary): Correct spelling
	of -mmacosx-version-min.

2005-10-04  Devang Patel  <dpatel@apple.com>

	* c-common.c (vector_types_convertible_p): Check TYPE_PRECISION for
	real types.

2005-10-04  Steve Ellcey  <sje@cup.hp.com>

	* tree-vect-transform.c (vect_create_epilog_for_reduction):
	Use BYTES_BIG_ENDIAN instead of BITS_BIG_ENDIAN.

2005-10-04  Adrian Straetling  <straetling@de.ibm.com>

	* config/s390/s390.md ("TDSI","DP"): New mode macros.
	("TE","tg"): New mode attributes.
	("sync_compare_and_swap<mode>"): Replace with a define_expand.
	("sync_compare_and_swap<mode>_cc"): Replace GPR with TDSI.
	("*sync_compare_and_swap<mode>_cc"): Replace with one pattern for
	dword_mode and one for GPRmode.

2005-10-04  Ian Lance Taylor  <ian@airs.com>

	PR preprocessor/13726
	* c-ppoutput.c (cb_include): Add comments parameter, and print out
	any comments passed in.

2005-10-04  Andrew Pinski  <pinskia@physics.uc.edu>

	* tree.c (annotate_with_file_line): Fix typo.

2005-10-04  Ulrich Weigand  <Ulrich.Weigand@de.ibm.com>

	PR ada/19382
	* builtins.c (fold_builtin_memcmp): When constructing the pointer
	type used to access data in the inlined length == 1 case, use
	build_pointer_type_for_mode with CAN_ALIAS_ALL set to true.
	(fold_builtin_strcmp, fold_builtin_strncmp): Likewise.

2005-10-04  Uros Bizjak  <uros@kss-loka.si>

	* config/i386/i386.h (TARGET_FISTTP): Enable also for
	TARGET_SSE3 and only for TARGET_80387.
	* config/i386/i386.md (fix_trunc<mode>_fisttp_i387_1,
	(fix_trunc<mode>_i387_fisttp, fix_trunc<mode>_i387_fisttp_with_temp):
	Do not depend on TARGET_80387.

2005-10-04  Andrew Pinski  <pinskia@physics.uc.edu>

	* tree.c (last_annotated_node): Change type to location_t*.
	(annotate_with_file_line): Reflect the change of
	last_annotated_node type.

2005-10-04  Richard Guenther  <rguenther@suse.de>

	PR c/23576
	* c-decl.c (grokdeclarator): Don't write to fields
	of error_mark_node.

2005-10-04  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/23125
	* c-decl.c (finish_decl): Use set_user_assembler_name even for
	register variables.
	* varasm.c (make_decl_rtl): If a register variable does not
	have a set user assmbler name, error out.
	Decode the asmspec is now name+1 bypassing '*'.

2005-10-04  Steven Bosscher  <stevenb@suse.de>

	PR tree-optimization/23049
	* tree-ssa-dom.c (thread_across_edge): Make sure that the condition
	of a COND_EXPR is folded before calling fold on the whole rhs of a
	conditional assignment.
	* doc/tree-ssa.texi: Update the GIMPLE grammar for a valid rhs to
	document that a COND_EXPR may appear there.

2005-10-03  Diego Novillo  <dnovillo@redhat.com>

	PR 23445
	* tree-vrp.c (extract_range_from_assert): If the new numeric
	range created out of the assertion contradicts the existing
	numeric range of the ASSERT_EXPR variable, make the new range
	varying.

2005-10-03  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/sh.c (sh_register_move_cost): Add case for moving
	from T_REGS to FP register class.

2005-10-03  Richard Henderson  <rth@redhat.com>

	PR 24135
	* tree-nested.c (convert_nl_goto_reference): Lookup a translation
	before creating a new one.

2005-10-03  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/t-aix43 (LDFLAGS): New.
	* config/rs6000/t-aix52 (LDFLAGS): New.

2005-10-03  Ian Lance Taylor  <ian@airs.com>

	* gimplify.c (find_single_pointer_decl_1): New static function.
	(find_single_pointer_decl): New static function.
	(internal_get_tmp_var): For a formal variable, set restrict base
	information if appropriate.
	* alias.c (find_base_decl): If a VAR_DECL has a restrict base,
	return it.
	* tree.h (DECL_BASED_ON_RESTRICT_P): Define.
	(DECL_GET_RESTRICT_BASE): Define.
	(SET_DECL_RESTRICT_BASE): Define.
	(decl_restrict_base_lookup): Declare.
	(decl_restrict_base_insert): Declare.
	(struct tree_decl_with_vis): Add based_on_restrict_p field.
	* tree.c (restrict_base_for_decl): New static variable.
	(init_ttree): Initialize restrict_base_for_decl.
	(copy_node_stat): Copy restrict base information.
	(decl_restrict_base_lookup): New function.
	(decl_restrict_base_insert): New function.
	(print_restrict_base_statistics): New static function.
	(dump_tree_statistics): Call print_restrict_base_statistics.

2005-10-02  Diego Novillo  <dnovillo@redhat.com>

	PR 24142
	* tree-vrp.c (vrp_meet): Fix call to range_includes_zero_p in
	case of anti-ranges.

2005-10-02  Andrew Pinski  <pinskia@physics.uc.edu>

	PR c/18851
	* c-typeck.c (tagged_tu_seen): Rename to ...
	(tagged_tu_seen_cache): this and add val field.
	(comptypes): Move functional to comptypes_internal
	and free tagged_tu_seen.
	(comptypes_internal): New function and call comptypes_internal
	instead of comptypes. Speed up by sibcalling
	tagged_types_tu_compatible_p.
	(alloc_tagged_tu_seen): New function
	(free_all_tagged_tu_seen_up_to): New function.
	(tagged_types_tu_compatible_p): Return the val of the seen two
	types.
	Add that the two types are the same to tagged_tu_seen_base
	if they are and call comptypes_internal instead of comptypes.
	<case UNION_TYPE>: Speed up common type where the fields are
	in the same order.
	(function_types_compatible_p): Call comptypes_internal instead of
	comptypes.
	(type_lists_compatible_p): Likewise.
	(all functions): s/tagged_tu_seen/tagged_tu_seen_cache/.

2005-10-02  Matthias Klose  <doko@debian.org>

	* doc/invoke.texi: Fix typo and speling error.

2005-10-01  Richard Henderson  <rth@redhat.com>

	* tree-stdarg.c (execute_optimize_stdarg): Process PHI nodes too.

2005-10-01  Mark Mitchell  <mark@codesourcery.com>

	* config/arm/unknown-elf.h (LINK_GCC_C_SEQUENCE_SPEC): Define
	using --start-group and --end-group.

2005-10-01  Diego Novillo  <dnovillo@redhat.com>

	* tree-vrp.c (value_inside_range, range_includes_zero_p): Add
	FIXME note regarding quirky semantics.

2005-10-01  Diego Novillo  <dnovillo@redhat.com>

	PR 24141
	* tree-vrp.c (vrp_meet): Clear VR0->EQUIV when building a
	non-null range as a last resort.

2005-10-01  James A. Morrison  <phython@gcc.gnu.org>
